function varargout = LUTconf_step1bUserAtm(varargin)
% LUTCONF_STEP1BUSERATM MATLAB code for LUTconf_step1bUserAtm.fig
%      LUTCONF_STEP1BUSERATM, by itself, creates a new LUTCONF_STEP1BUSERATM or raises the existing
%      singleton*.
%
%      H = LUTCONF_STEP1BUSERATM returns the handle to a new LUTCONF_STEP1BUSERATM or the handle to
%      the existing singleton*.
%
%      LUTCONF_STEP1BUSERATM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LUTCONF_STEP1BUSERATM.M with the given input arguments.
%
%      LUTCONF_STEP1BUSERATM('Property','Value',...) creates a new LUTCONF_STEP1BUSERATM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LUTconf_step1bUserAtm_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LUTconf_step1bUserAtm_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LUTconf_step1bUserAtm

% Last Modified by GUIDE v2.5 01-Nov-2018 20:06:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LUTconf_step1bUserAtm_OpeningFcn, ...
                   'gui_OutputFcn',  @LUTconf_step1bUserAtm_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LUTconf_step1bUserAtm is made visible.
function LUTconf_step1bUserAtm_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LUTconf_step1bUserAtm (see VARARGIN)

% Choose default command line output for LUTconf_step1bUserAtm
handles.output = hObject;

set(handles.uitable1,'data',[])
set(handles.listbox1,'string','')
set(handles.popupmenu1,'string','Select profile...','enable','off','value',1)
set(handles.edit6,'string','','enable','off')
set(handles.edit7,'string','','enable','off')


% Read reference data and store in GUI:
atmDataFile = ['..',filesep,'Others',filesep,'atmprofiles.h5'];
info   = h5info(atmDataFile);
datasets = info.Datasets;
ZM =  h5read(atmDataFile,'/ZM')';   % Altitude profile
set(handles.text2,'userdata',ZM)
names  = cell(1,numel(datasets)-2);
for i=1:numel(datasets)-2
    if strcmp(datasets(i).Name,'ZM')
       iZM = i; 
    else
        names{i} = [datasets(i).Name,' (',datasets(i).Attributes.Value,')'];
    end
end
names(iZM) = [];
set(handles.uitable1,'userdata',names)

set(handles.edit1,'userdata',365*91) % Max number of combinations

% Help icon:
[X,map] = imread(['..',filesep,'Others',filesep,'figs',filesep,'info_icon.png']);
alpha = ones(size(X)); alpha(X==0)=0;
info = cell(1,3);
i=1;
axes(handles.(['info',num2str(i)]))
info{i} = imshow(ind2rgb(X,map));
set(handles.(['info',num2str(i)]),'userdata',['info',num2str(i)])
set(info{i}, 'AlphaData', alpha);
set(info{i},'ButtonDownFcn',@(hObject,eventdata)LUTconf_step1bUserAtm('ImageClickCallback',hObject,eventdata,guidata(hObject)));


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes LUTconf_step1bUserAtm wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = LUTconf_step1bUserAtm_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get profiles data:
profiles = get(handles.listbox1,'userdata');
profiles = permute(profiles,[2 3 1]);
sz = size(profiles);
% Get altitude grid:
ZM = get(handles.text2,'userdata');
% Get gas names:
names = get(handles.uitable1,'userdata');

% Save into h5 file:
stepsdata = get(handles.output,'UserData');
filename = [stepsdata.GenConf.filename,'_UserAtm.h5'];
for i=1:numel(names)
    ind = strfind(names{i},'(');
    datasetname = ['/',names{i}(1:ind-2)];
    h5create(filename,datasetname,[sz(1) sz(2)]);
    h5write(filename,datasetname,profiles(:,:,i))
    h5writeatt(filename,datasetname,'units',names{i}(ind+1:end-1))
end
h5create(filename,'/ZM',[numel(ZM) 1])
h5write(filename,'/ZM',ZM)

close LUTconf_step1bUserAtm


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
N = str2double(get(hObject,'String'));
Nmax = get(handles.edit1,'userdata');
if N<1
    h = msgbox('Number of atmospheric profiles must be larger than 0','Wrong input value','error');
    set(handles.edit1,'string','1')
    uiwait(h)
elseif N>Nmax
    h = msgbox(['Number of atmospheric profiles must be ',num2str(Nmax),' as maximum'],'Wrong input value','error');
    uiwait(h)
    set(handles.edit1,'string',num2str(Nmax))
else
    set(handles.edit1,'string',num2str(round(N)))
end

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Read reference/default atmospheric profiles data:
atmDataFile = ['..',filesep,'Others',filesep,'atmprofiles.h5'];
doyRef = h5read(atmDataFile,'/doy');
latRef = h5read(atmDataFile,'/latitude');
ZM     = get(handles.text2,'userdata');
info   = h5info(atmDataFile); datasets = info.Datasets;
names  = cell(1,numel(datasets)-2);
staticProfiles = []; dynamicProfiles = []; iStatic = []; iDynamic = [];
for i=1:numel(datasets)-2
    if strcmp(datasets(i).Name,'ZM')
       iZM = i; 
    else
        names{i} = datasets(i).Name;
        profile = h5read(atmDataFile,['/',names{i}]);
        if size(profile,1)==1
            % Profile does not change as function of DOY and LAT
            staticProfiles = [staticProfiles,profile];
            iStatic = [iStatic,i];
        else
            dynamicProfiles = [dynamicProfiles,profile];
            iDynamic = [iDynamic,i];
        end
    end
end
clear profile
names(iZM) = []; 
nPro = numel(iDynamic); % Number of profiles to interpolate
nAlt = size(ZM,1); % Number of altitude layers

% Read input values:
table = get(handles.uitable2,'data');
profilesList = get(handles.listbox1,'string');
n = numel(profilesList);
N = str2num(get(handles.edit1,'string'));
Nmax = get(handles.edit1,'userdata');

% Create pseudo-random homogeneus combinations (LHS) of DOY and LAT:
if N<Nmax
    lb   = cell2mat(table(1:2,1))'; % Upper bound
    ub   = cell2mat(table(1:2,2))'; % Lower bound
    comb = lhsdesign(N,2);       % Latin Hypercube Sampling
    comb = bsxfun(@plus,lb,bsxfun(@times,comb,(ub-lb)));
    comb = round(comb);          % Rounding. We are not interested into fine details
    comb = unique(comb,'rows','stable'); % Remove repeated values
    N    = size(comb,1);
else
	comb{1} = 1:365; comb{2} = 0:90;
    [comb{:}] = ndgrid(comb{:});
    comb = [comb{1}(:),comb{2}(:)];
end

% Generate atmospheric profile name and fill in listbox and popupmenu:
aux = genvarname(repmat({'Atm'},[1,1+N+n])); aux = aux(2+n:end);
for i=1:N
    aux{i} = [aux{i},' (doy: ',num2str(comb(i,1)),...
                     ' lat: ',num2str(comb(i,2)),')'];
end
listboxstr = [profilesList',aux];
set(handles.listbox1,'string',listboxstr,'max',numel(listboxstr),'value',1)
profilesList = get(handles.listbox1,'string');
set(handles.popupmenu1,'string',[{'Select profile...'},profilesList'],'enable','on');

% Interpolate reference data based on generated combinations (DAY and LAT):
% 1) Convert DOY into angular variable
% (January=December=0; summer=90; spring=autum=45)
comb(:,1) = (180/364)*comb(:,1) - (180/364);
% comb(:,1) = abs(sind(comb(:,1)));
comb(:,1) = abs(tripuls(pi*comb(:,1)/180-pi/2,pi));
doyRef(doyRef==0)=-1; % Negative indicate that reference profile is valid for all the year long
doyRef(doyRef>0) = (180/364)*doyRef(doyRef>0) - (180/364);
doyRef(doyRef>0) = abs(sind(doyRef(doyRef>0)));
% 2) Linearize LAT:
comb(:,2) = sind(comb(:,2));
latRef    = sind(latRef);
% 3) Bi-linear interpolation of profiles
profiles = zeros(nPro,nAlt,N);
for j=1:numel(iStatic) % for each static profile
    profiles(iStatic(j),:,:) = repmat(staticProfiles(1,1+(j-1)*nAlt:j*nAlt),1,1,N);
end
for i=1:N % for each new atmosphere
    % Interpolate reference profiles depending on DOY and LAT
    if comb(i,2)>latRef(4) % Interpolate between SAS at different DOY
        auxProfiles = ((diff(dynamicProfiles(4:5,:)))/diff(doyRef(4:5)))*(comb(i,1)-doyRef(4)) + dynamicProfiles(4,:);
        auxProfiles = auxProfiles';
    elseif comb(i,2)>=latRef(2) && comb(i,2)<=latRef(4) % Interpolate between ML and SA:
    	auxProfiles = myinterpn([doyRef(2:5);latRef(2:5)],...
                            dynamicProfiles(2:5,:)',comb(i,:)','linear');
    elseif comb(i,2)>=latRef(1) && comb(i,2)<=latRef(2) % Interpolate between TRO and ML
    	auxProfiles = myinterpn([[comb(i,1),doyRef(2:3)];latRef(1:3)],...
                            dynamicProfiles(1:3,:)',comb(i,:)','matlablinear');
    else % Latitude <15 deg. Atmosphere is tropical
        auxProfiles = dynamicProfiles(1,:)';
    end
    for j=1:numel(iDynamic) % for each dynamic profile
        profiles(iDynamic(j),:,i) = auxProfiles(1+(j-1)*nAlt:j*nAlt);
    end
end

% Save profiles in user data:
auxProfiles = get(handles.listbox1,'userdata');
profiles = cat(3,auxProfiles,profiles);
set(handles.listbox1,'userdata',profiles);



% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ind = get(handles.listbox1,'value');

if ~isempty(ind)
    % Remove profiles from list and update listbox1 user data:
    profiles = get(handles.listbox1,'userdata');
    profiles(:,:,ind) = [];
    set(handles.listbox1,'userdata',profiles)
    % Remove profile names from listbox1 and update names:
    atmnames = get(handles.listbox1,'string');
    atmnames(ind) = [];
    for i=1:numel(atmnames)
        j = strfind(atmnames{i},'(doy');
        atmnames{i}(4:j-2) = num2str(i);
    end
    set(handles.listbox1,'string',atmnames,'max',numel(atmnames),'value',1)
    % Remove profile names from popupmenu1 and update names:
    aux = get(handles.popupmenu1,'string');
    set(handles.popupmenu1,'string',[aux{1};atmnames],'value',1)
    % Clear other handles:
    set(handles.edit6,'string','')
    set(handles.edit7,'string','')
    set(handles.uitable1,'data',[])
    if numel(atmnames)==0
        set(handles.popupmenu1,'enable','off')
    end
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
ind = get(handles.listbox1,'value');

if ~isempty(ind)
    profiles = get(handles.listbox1,'userdata');
    profiles = profiles(:,:,ind);
    names    = get(handles.uitable1,'userdata');
    ZM       = get(handles.text2,'userdata');
    atmnames = get(handles.listbox1,'string');

    plotprofile(ZM,profiles,names,atmnames(ind))
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
ind = get(handles.popupmenu1,'value');
if ind==1
    set(handles.uitable1,'data',[],'enable','off')
    set(handles.edit6,'string','','enable','off')
    set(handles.edit7,'string','','enable','off')
else
    ZM  = get(handles.text2,'userdata');
	set(handles.uitable1,'ColumnName',ZM)
    gas = get(handles.uitable1,'userdata');
    set(handles.uitable1,'RowName',gas)
    profiles = get(handles.listbox1,'userdata');
    profiles = profiles(:,:,ind-1);
    set(handles.uitable1,'data',profiles,'enable','on','ColumnEditable',true)
    atmname = get(handles.popupmenu1,'string');
    atmname = atmname{ind};
    i   = strfind(atmname,'lat');
    doy = atmname(i-4:i-2);
    lat = atmname(i+5:i+6);
    set(handles.edit6,'string',doy,'enable','on')
    set(handles.edit7,'string',lat,'enable','on')
end

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double
% Check validity of input values
value = str2num(get(handles.edit6,'string'));
if value<1 || value>365
    h = msgbox('Day-of-year must be between 1 and 365','Wrong input value','error');
    i = get(handles.popupmenu1,'value');
    doy = get(handles.popupmenu1,'string'); doy = doy{i};
    i = strfind(doy,'doy'); j = strfind(doy,'lat');
    doy = doy(i+5:j-2);
    set(handles.edit6,'string',doy)
    uiwait(h)
else
    % Update edit6 textbox:
    doy = num2str(round(value));
    set(handles.edit6,'string',doy)
    % Update popupmenu1:
    i = get(handles.popupmenu1,'value');
    str = get(handles.popupmenu1,'string'); auxstr = str{i};
    ii = strfind(auxstr,'doy'); jj = strfind(auxstr,'lat');
    auxstr = strrep(auxstr,auxstr(ii+5:jj-2),doy);
    str{i} = auxstr;
    set(handles.popupmenu1,'string',str,'value',i)
    % Update listbox1:
    str = get(handles.listbox1,'string');
    str{i-1} = auxstr;
    set(handles.listbox1,'string',str)
    % Update profiles data:
    lat = get(handles.edit7,'string');
    profile = generate_profile(str2num(doy),str2num(lat),handles);
    set(handles.uitable1,'data',profile)
    profiles = get(handles.listbox1,'userdata');
    profiles(:,:,i-1) = profile;
    set(handles.listbox1,'userdata',profiles);
end

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double
value = str2num(get(handles.edit7,'string'));
if value<0 || value>90
    h = msgbox('Latitude must be between 15 and 90','Wrong input value','error');
    i = get(handles.popupmenu1,'value');
    lat = get(handles.popupmenu1,'string'); lat = lat{i};
    i = strfind(lat,'lat');
    lat = lat(i+5:end-1);
    set(handles.edit7,'string',lat)
    uiwait(h)
elseif value>=0 && value<15
    h = msgbox('Latitudes <15 are equivalent to Tropical atmospheres. Please introduce a latitude >=15','Wrong input value','error');
    i = get(handles.popupmenu1,'value');
    lat = get(handles.popupmenu1,'string'); lat = lat{i};
    i = strfind(lat,'lat');
    lat = lat(i+5:end-1);
    set(handles.edit7,'string',lat)
    uiwait(h)    
else
    % Update edit6 textbox:
    lat = num2str(round(value));
    set(handles.edit7,'string',lat)
    % Update popupmenu1:
    i = get(handles.popupmenu1,'value');
    str = get(handles.popupmenu1,'string'); auxstr = str{i};
    ii = strfind(auxstr,'lat');
    auxstr = strrep(auxstr,auxstr(ii+5:end-1),lat);    
    str{i} = auxstr;
    set(handles.popupmenu1,'string',str,'value',i)
    % Update listbox1:
    str = get(handles.listbox1,'string');
    str{i-1} = auxstr;
    set(handles.listbox1,'string',str)
    % Update profiles data:
    doy = get(handles.edit6,'string');
    profile = generate_profile(str2num(doy),str2num(lat),handles);
    set(handles.uitable1,'data',profile)
    profiles = get(handles.listbox1,'userdata');
    profiles(:,:,i-1) = profile;
    set(handles.listbox1,'userdata',profiles);
end


% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when entered data in editable cell(s) in uitable2.
function uitable2_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable2 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
i=eventdata.Indices(1); j = eventdata.Indices(2);
table = get(handles.uitable2,'data');

% Check validity of input values
if i==1 && (table{i,j}<1 || table{i,j}>365)
    h = msgbox('Day-of-year must be between 1 and 365','Wrong input value','error');
    table{i,j} = eventdata.PreviousData;
    uiwait(h)
elseif i==2 && (table{i,j}<0 || table{i,j}>90)
    h = msgbox('Latitude must be between 15 and 90','Wrong input value','error');
    table{i,j} = eventdata.PreviousData;
    uiwait(h)
elseif i==2 && (table{i,j}>=0 && table{i,j}<15)
    h = msgbox('Latitudes <15 are equivalent to Tropical atmospheres. Please introduce a latitude >=15','Wrong input value','error');
    table{i,j} = eventdata.PreviousData;
    uiwait(h)    
end

% Round value before saving table:
table{i,j} = round(table{i,j});

% Re-organize min/max table cells:
if ~any(cellfun(@isempty,table(i,:)))
    aux = sort([table{i,1}, table{i,2}]);
    table{i,1} = aux(1);
    table{i,2} = aux(2);
end
    
set(handles.uitable2,'data',table)

function profiles = generate_profile(doy,lat,handles)
% This function automatically generates a vertical atmospheric profile
% based on the interpolation of of MODTRAN references profiles. Input
% variables are day-of-year (doy, 1-365) and latitude (0-90 deg)

% Read reference/default atmospheric profiles data:
atmDataFile = ['..',filesep,'Others',filesep,'atmprofiles.h5'];
doyRef = h5read(atmDataFile,'/doy');
latRef = h5read(atmDataFile,'/latitude');
ZM     = get(handles.text2,'userdata');
info   = h5info(atmDataFile); datasets = info.Datasets;
staticProfiles = []; dynamicProfiles = []; iStatic = []; iDynamic = [];
for i=1:numel(datasets)-2
    if ~strcmp(datasets(i).Name,'ZM')
        profile = h5read(atmDataFile,['/',datasets(i).Name]);
        if size(profile,1)==1
            % Profile does not change as function of DOY and LAT
            staticProfiles = [staticProfiles,profile];
            iStatic = [iStatic,i];
        else
            dynamicProfiles = [dynamicProfiles,profile];
            iDynamic = [iDynamic,i];
        end
    end
end
clear profile
nPro = numel(iDynamic); % Number of profiles to interpolate
nAlt = size(ZM,1); % Number of altitude layers

% Read input DOY and LAT
comb = round([doy,lat]); % Rounding. We are not interested into fine details

% Interpolate reference data based on generated combinations (DAY and LAT):
% 1) Convert DOY into angular variable
% (January=December=0; summer=90; spring=autum=45)
comb(1) = (180/364)*comb(1) - (180/364);
% comb(:,1) = abs(sind(comb(:,1)));
comb(1) = abs(tripuls(pi*comb(1)/180-pi/2,pi));
doyRef(doyRef==0)=-1; % Negative indicate that reference profile is valid for all the year long
doyRef(doyRef>0) = (180/364)*doyRef(doyRef>0) - (180/364);
doyRef(doyRef>0) = abs(sind(doyRef(doyRef>0)));
% 2) Linearize LAT:
comb(2) = sind(comb(2));
latRef    = sind(latRef);
% 3) Bi-linear interpolation of profiles
profiles = zeros(nPro,nAlt);
for j=1:numel(iStatic) % for each static profile
    profiles(iStatic(j),:) = staticProfiles(1,1+(j-1)*nAlt:j*nAlt);
end
% Interpolate reference profiles depending on DOY and LAT
if comb(2)>latRef(4) % Interpolate between SAS at different DOY
	auxProfiles = ((diff(dynamicProfiles(4:5,:)))/diff(doyRef(4:5)))*(comb(1)-doyRef(4)) + dynamicProfiles(4,:);
    auxProfiles = auxProfiles';
elseif comb(2)>=latRef(2) && comb(2)<=latRef(4) % Interpolate between ML and SA:
	auxProfiles = myinterpn([doyRef(2:5);latRef(2:5)],...
                    dynamicProfiles(2:5,:)',comb','linear');
elseif comb(2)>=latRef(1) && comb(2)<=latRef(2) % Interpolate between TRO and ML
	auxProfiles = myinterpn([[comb(1),doyRef(2:3)];latRef(1:3)],...
                    dynamicProfiles(1:3,:)',comb','matlablinear');
else % Latitude <15 deg. Atmosphere is tropical
	auxProfiles = dynamicProfiles(1,:)';
end
for j=1:numel(iDynamic) % for each dynamic profile
	profiles(iDynamic(j),:) = auxProfiles(1+(j-1)*nAlt:j*nAlt);
end

function ImageClickCallback(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

web(['..',filesep,'Help',filesep,'html',filesep,'generation',filesep,'useratminput.html'],'-browser')


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
ind = get(handles.popupmenu1,'value')-1;

profile = get(handles.uitable1,'data');

profiles = get(handles.listbox1,'userdata');
profiles(:,:,ind) = profile;
set(handles.listbox1,'userdata',profiles);
