function varargout = LUTconf_step2(varargin)
% LUTCONF_STEP2 MATLAB code for LUTconf_step2.fig
%      LUTCONF_STEP2, by itself, creates a new LUTCONF_STEP2 or raises the existing
%      singleton*.
%
%      H = LUTCONF_STEP2 returns the handle to a new LUTCONF_STEP2 or the handle to
%      the existing singleton*.
%
%      LUTCONF_STEP2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LUTCONF_STEP2.M with the given input arguments.
%
%      LUTCONF_STEP2('Property','Value',...) creates a new LUTCONF_STEP2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LUTconf_step2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LUTconf_step2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LUTconf_step2

% Last Modified by GUIDE v2.5 04-Mar-2018 23:34:42

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LUTconf_step2_OpeningFcn, ...
                   'gui_OutputFcn',  @LUTconf_step2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LUTconf_step2 is made visible.
function LUTconf_step2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LUTconf_step2 (see VARARGIN)

% Choose default command line output for LUTconf_step2
handles.output = hObject;

cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

[X,map] = imread(['..',filesep,'Others',filesep,'figs',filesep,'info_icon.png']);
alpha = ones(size(X)); alpha(X==0)=0;
info = cell(1,3);
for i=1:3
    axes(handles.(['info',num2str(i)]))
    info{i} = imshow(ind2rgb(X,map));
    set(handles.(['info',num2str(i)]),'userdata',['info',num2str(i)])
    set(info{i}, 'AlphaData', alpha);
    set(info{i},'ButtonDownFcn',@(hObject,eventdata)LUTconf_step2('ImageClickCallback',hObject,eventdata,guidata(hObject)));
end

% Load LUT configuration parameters if selected:
h = findobj('Tag','AtmLutGen');
handlesAtmLutGen = guidata(h);

% Load stored steps data from output data:
stepsdata = get(handles.output,'userdata');
fn = fieldnames(stepsdata);

LUTconffile = get(handlesAtmLutGen.loadlut,'UserData');
if ~isempty(LUTconffile) && (~any(cellfun(cellfind('uitable1'),fn)) || isempty(stepsdata.uitable1))
    if stepsdata.loadparam
        % User has selected to load LUT configuration file, then read file and
        % update handles
        ParamConf = read_LUTconfig(LUTconffile,'ParamConf');
        fn        = fieldnames(ParamConf);
        table = {};
        for i=1:numel(fn)
            aux = ParamConf.(fn{i});
            if ~isempty(aux)
                fn1 = fieldnames(aux);
                for j=1:numel(fn1)
                    auxval = aux.(fn1{j}).values;
                    if ~strcmp(stepsdata.GenConf.inputmode,'Manual (gridded) sampling')
                        ind = strfind(auxval,',');
                        auxval = [auxval(1:ind(1)),auxval(ind(end)+1:end)];
                    end
                    if i==1 && j==1
                        table(1,:) = {false,aux.(fn1{j}).name,aux.(fn1{j}).description,auxval,aux.(fn1{j}).unit};
                    else
                        table(end+1,:) = {false,aux.(fn1{j}).name,aux.(fn1{j}).description,auxval,aux.(fn1{j}).unit};
                    end
                end
            end
        end
        if ~exist('table','var'), table = []; end
        try, set(handles.edit6,'string',stepsdata.prevGenConf.numberpoints), end
    else
        table = [];
    end
    % Set visible and enable when stop condition is based on max number of samples AND is not gridded data:
    if ~strcmp(stepsdata.GenConf.inputmode,'Manual (gridded) sampling') && strcmp(stepsdata.GenConf.stopmethod,'Input max. # of samples')
    	aux1 = 'on'; aux2 = 'off';
    else
    	aux1 = 'off'; aux2 = 'on';
    end
    set(handles.text9,'visible',aux1), set(handles.edit6,'visible',aux1)
    set(handles.edit3,'enable',aux2), set(handles.pushbutton4,'enable',aux2)
    set(handles.popupmenu3,'enable',aux2)
else
    % User has opened Step 2 from Step 1 or Step 3. In both cases the LUT
    % parameters table can be read from the stepsdata (output User Data):
	table = stepsdata.uitable1;

    % Set visible and enable when stop condition is based on max number of samples AND is not gridded data:
    if ~strcmp(stepsdata.GenConf.inputmode,'Manual (gridded) sampling') && strcmp(stepsdata.GenConf.stopmethod,'Input max. # of samples')
        aux1 = 'on'; aux2 = 'off';
    else
        aux1 = 'off'; aux2 = 'on';
    end
    set(handles.text9,'visible',aux1), set(handles.edit6,'visible',aux1)
    set(handles.edit3,'enable',aux2), set(handles.pushbutton4,'enable',aux2), set(handles.popupmenu3,'enable',aux2)

end

[~,Groupnames,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],stepsdata.GenConf.RTMname);
set(handles.listbox2,'string',Groupnames(1:end-2),'userdata',data,'value',[],'min',0,'max',2)
set(handles.listbox3,'string','Select group first','value',[],'min',0,'max',2,'enable','off')

pos = get(handles.listbox1,'position'); pos(2) = 0.09; %Units in normalized!!
set(handles.listbox1,'visible','off','position',pos)
pos = get(handles.uipanel1,'position'); pos(2) = 0.09; %Units in normalized!!
set(handles.uipanel1,'visible','off','position',pos)

% Modify foreground color of Previous and Next buttons (pushbutton1 and pushbutton2):
button = {'pushbutton1','pushbutton2'};
for i=1:numel(button)
    units = get(handles.(button{i}),'units'); set(handles.(button{i}),'units','pixels')
    cdark = get(handles.(button{i}),'foregroundcolor'); clight = 1.8*cdark;
    aux = uint16(get(handles.(button{i}),'position')); set(handles.(button{i}),'units',units)
    x = 0.94*ones(aux(4),aux(3),3);
    sz1 = size(x(2:round(aux(4)/2),2:end-1,:)); sz2 = size(x(round(aux(4)/2)+1:end-1,2:end-1,:));
    x(2:round(aux(4)/2),2:end-1,:) = permute(repmat(clight',[1,sz1(1:2)]),[2 3 1]);
    x(round(aux(4)/2)+1:end-1,2:end-1,:) = permute(repmat(cdark',[1,sz2(1:2)]),[2 3 1]);
    x(3:end-2,2,:)=0.7; x(4:end-2,size(x,2)-1,:)=0.5; x(2,3:end-2,:)=0.7; x(size(x,1)-1,4:end-2,:)=0.5;
    x(2,2,:)=0.85; x(size(x,1)-1,size(x,2)-1,:)=0.85; x(2,size(x,2)-1,:)=0.85; x(size(x,1)-1,2,:)=0.85;
    x(3,size(x,2)-1,:)=0.85; x(size(x,1)-1,3,:)=0.85;
    x(3,3,:)=0.65; x(size(x,1)-2,size(x,2)-2,:)=0.7; x(3,size(x,2)-2,:)=0.65; x(size(x,1)-2,3,:)=0.65; 
    set(handles.(button{i}),'cdata',x,'userdata',{x,cdark});
    set(handles.(button{i}),'foregroundcolor',[1 1 1])
end

set(handles.uitable1,'data',table)

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes LUTconf_step2 wait for user response (see UIRESUME)
% uiwait(handles.LUTconf_step2);


% --- Outputs from this function are returned to the command line.
function varargout = LUTconf_step2_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

guidata(hObject, handles);
try
    % Before moving back to Step 1 we update the output UserData including the
    % table from uitable1. The structure stepsdata will contain the GenConf
    % from the step 1 and the uitable data from step 2:
    stepsdata = get(handles.output,'UserData');
    stepsdata.uitable1 = get(handles.uitable1,'data');
    h = findobj('Tag','AtmLutGen');
    handlesAtmLutGen = guidata(h);
    updatesubblock('LUTconf_step1',handlesAtmLutGen,stepsdata);
    % LUTconf_step1('UserData',stepsdata)
    % close(handles.LUTconf_step2)
catch me
    msgbox(me.message,'Error','error')
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

try
    % Before moving to Step 3 we update the output UserData including the
    % table from uitable1. The structure stepsdata will contain the GenConf
    % from the step 1 and the uitable data from step 2:
    stepsdata = get(handles.output,'UserData');
    stepsdata.uitable1 = get(handles.uitable1,'data');
    set(handles.output,'UserData',stepsdata);

    filename = stepsdata.GenConf.filename;

    table = get(handles.uitable1,'data');
    if ~isempty(table) % If user has input data for the LUT
        if ~strcmp(stepsdata.GenConf.inputmode,'Manual (gridded) sampling') && strcmp(stepsdata.GenConf.stopmethod,'Input max. # of samples')%strcmp(stepsdata.GenConf.inputmode,'Latin hypercube') % Latin Hypercube
            minNpoints = 1;
            for i=1:size(table,1), minNpoints=minNpoints*numel(str2num(table{i,4})); end
            if isempty(get(handles.edit6,'string'))
                h = msgbox('Please introduce a valid number of grid points',...
                       'Save LUT configuration error','error');
                set(handles.edit6,'backgroundcolor',[1 1 0])
                set(h,'windowstyle','modal'), uiwait(h)
                return
            elseif str2num(get(handles.edit6,'string'))<minNpoints
                h = msgbox(['At least ',num2str(minNpoints),' should be introduced'],...
                        'Save LUT configuration error','error');
                set(handles.edit6,'backgroundcolor',[1 1 0])
                set(h,'windowstyle','modal'), uiwait(h)
                return
            else
                set(handles.edit6,'backgroundcolor',[1 1 1])
                ParamConf.Npoints = str2num(get(handles.edit6,'string'));
            end
        end
        % Save ParamConf in LUT configuration file:
        [~,name,~] = fileparts(filename);

        data = get(handles.listbox2,'userdata');
        aux = {'AtmParam','AerParam','GeoParam'};
        for i=1:length(aux) % For each family of parameters...
            data1 = data.(aux{i});
            fn   = fieldnames(data1);
            for j=1:size(table,1)  % ...we look if each parameter of table is in that family...
                idx = find(cellfun(cellfind(table(j,2)),fn));
                if ~isempty(idx) % ...in that case, we add this parameter to the ParamConf in the corresponding family
                    ParamConf.(aux{i}).(table{j,2}).name        = table{j,2};
                    ParamConf.(aux{i}).(table{j,2}).description = table{j,3};
                    ParamConf.(aux{i}).(table{j,2}).values      = table{j,4};
                    ParamConf.(aux{i}).(table{j,2}).unit        = table{j,5};
                    ParamConf.(aux{i}).(table{j,2}).paramtype   = data1.(fn{idx}).paramtype;
                    ParamConf.(aux{i}).(table{j,2}).datatype    = data1.(fn{idx}).datatype;
                end
            end
        end

        update_LUTconfig([filename,'.xml'],'ParamConf',ParamConf)

        % Update OpacConf based on Aerosol models used in the LUT:
        fn = fieldnames(ParamConf);
        if find(cellfun(cellfind('AerParam'),fn))
            % There are aerosol parameters used in LUT
            fn = fieldnames(ParamConf.AerParam);
            for i=1:numel(fn)
                if strcmp(ParamConf.AerParam.(fn{i}).description,'Aerosol model')
                    % There are aerosol models used in LUT
                    aux = str2num(ParamConf.AerParam.(fn{i}).values);
                    if any(aux<0)
                        % Some values are negative (OPAC)
                        OpacConf = read_LUTconfig([filename,'.xml'],'OpacConf');
                        fn2 = fieldnames(OpacConf);
                        if any(cellfun(cellfind('OpacConf'),fn2))
                            if isempty(OpacConf.OpacConf)
                                OpacConf = [];
                            end
                        end
                        [OPACconf,Groupnames,datos]   = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
                        AERTYPE = datos.MainParam.AERTYPE; 
                        OpacConf.AERTYPE.name        = AERTYPE.name;
                        OpacConf.AERTYPE.description = AERTYPE.description;
                        OpacConf.AERTYPE.values      = strjoin(-aux(aux<0));
                        OpacConf.AERTYPE.unit        = AERTYPE.unit;
                        OpacConf.AERTYPE.paramtype   = AERTYPE.paramtype;
                        OpacConf.AERTYPE.datatype    = AERTYPE.datatype;
                        update_LUTconfig([filename,'.xml'],'OpacConf',OpacConf)               
                    else
                        % Any value is negative (all are default to RTM) so
                        % clear OpacConf:
                        update_LUTconfig([filename,'.xml'],'OpacConf',[])
                    end
                end
            end
        end


%         msg = ['LUT key input parameters configuration stored in ',name,'.xml file'];
%         h = msgbox(msg,'Parameters configuration updated','warn');
%         set(h,'windowstyle','modal'), uiwait(h)

        guidata(hObject, handles);
    else % If table is empty
        h = msgbox('No input parameters have been defined. LUT will be generated with default values',...
                   'LUT input configuration','warn');
        set(h,'windowstyle','modal'), uiwait(h)
        update_LUTconfig([filename,'.xml'],'ParamConf',[])
    end
    % Move to step 3:
    MovetoStep3(handles)
catch me
    msgbox(me.message,'Error','error')
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
stepsdata=get(handles.output,'UserData');

set(handles.listbox1,'visible','off'), set(handles.uipanel1,'visible','off')

value = get(handles.listbox2,'value');
set(handles.listbox2,'value',value(1),'min',0,'max',1)
set(handles.listbox3,'enable','on')


if get(handles.listbox2,'value')~=0 && ~isempty(get(handles.listbox2,'value'))
    % Clear previous values:
    aux = {'edit1','edit2','edit3'};
    for i=1:length(aux),	set(handles.(aux{i}),'string',''),   end
    set(handles.popupmenu3,'value',1)
    set(handles.pushbutton3,'enable','on')
    
    aux  = get(handles.listbox2,'string');
    data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
    % Select as accesible to the user those parameters with the visibility
    % attribute set in Step1:
    visibility = {'Basic','Medium','Advanced'};
    aux = stepsdata.GenConf.userlevel;
    visibility = visibility(1:aux);
    fn   = fieldnames(data);
    for i=1:numel(fn)
        if ~isempty(find(cellfun(cellfind(data.(fn{i}).visibility),visibility)))
            auxdata.(fn{i}) = data.(fn{i});
        end
    end
    data = auxdata;
    
    if ~isempty(data)
        fn   = fieldnames(data);    parameters = cell(1,length(fn));
        for i=1:length(fn),	parameters{i} = data.(fn{i}).description;    end
%         pos = get(handles.listbox3,'position'); %% MODIFICAR EL TAMANO SEGUN EL NUMERO DE VARIABLES
        set(handles.listbox3,'string',parameters,'value',[],'enable','on','min',0,'max',2)
        uicontrol(handles.listbox3)
    else
        h = msgbox(['No ',aux{opt},' have been defined for the ',stepsdata.GenConf.RTMname,' RTM.'],'Input parameters error','error');
        set(handles.listbox3,'string','Select group first','value',[],'enable','off','min',0,'max',2)
        set(h,'windowstyle','modal'), uiwait(h)
    end
else
    set(handles.listbox3,'string','Select group first','value',[],'enable','off','min',0,'max',2)
end

% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
stepsdata=get(handles.output,'UserData');

value = get(handles.listbox3,'value');
set(handles.listbox3,'value',value(1),'min',0,'max',1)


if get(handles.listbox3,'value')~=0 && ~isempty(get(handles.listbox3,'value'))
    % Clear previous values:
    aux = {'edit1','edit2','edit3'};
    for i=1:length(aux),	set(handles.(aux{i}),'string',''),   end
    set(handles.popupmenu3,'value',1)
    set(handles.pushbutton3,'enable','on')

    % Load parameter data from the RTMconf.xml file:
    data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
    % Select as accesible to the user those parameters with the visibility
    % attribute set in Step1:
    visibility = {'Basic','Medium','Advanced'};
    aux = stepsdata.GenConf.userlevel;
    visibility = visibility(1:aux);
    fn   = fieldnames(data);
    for i=1:numel(fn)
        if ~isempty(find(cellfun(cellfind(data.(fn{i}).visibility),visibility)))
            auxdata.(fn{i}) = data.(fn{i});
        end
    end
    data = auxdata;     fn   = fieldnames(data);
    opt  = get(handles.listbox3,'value');     data = data.(fn{opt});
    
    % Check if parameter is discrete or continuous to allow input:
    if strcmp(data.paramtype,'discrete')
        enable  = 'off'; visible = 'on'; visible2 = 'off';
        options = data.desc(2:end-1);   op_modes = str2cell(options);
        values  = str2num(data.values); default  = str2num(data.default);
        % Check if it is Aerosol model and Opac option is implemented:
        if strfind(options,'Opac') % Selected parameter is Aerosol model
            [OPACconf,Groupnames,OPACparam] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
            if OPACconf.filepath % Opac is implemented in AtmLutGen software
                % Add OPAC options in Aerosol models:
                ind = find(cellfun(cellfind('Opac'),op_modes));
                optionsopac   = OPACparam.MainParam.AERTYPE.desc(2:end-1);
                valuesopac    = str2num(OPACparam.MainParam.AERTYPE.values);
                op_modes_opac = str2cell(optionsopac);
                op_modes(ind) = [];
                aux           = values(ind); %-1 identifies OPAC
                values(ind)   = [];
                if ind~=1
                    op_modes = [op_modes(1:ind-1),op_modes_opac,op_modes(ind:end)];
                    values   = [values(1:ind-1),aux*valuesopac,values(ind:end)];
                else
                    op_modes = [op_modes_opac,op_modes];
                    values   = [aux*valuesopac,values];
                end
            else
                % Remove OPAC option in Aerosol model:
                ind = find(cellfun(cellfind('Opac'),op_modes));
                op_modes(ind) = [];
                aux = values(ind); values(ind)= [];
                if default==aux, default = values(1); end
            end
        end
        % Check if it is User-Defined (ATK) Aerosol model option is implemented:
        if strfind(options,'ATK') % Selected parameter is Aerosol model
            dbfile = ['..',filesep,'Userdata',filesep,'aerdb.h5']; flag = exist(dbfile,'file');
            rtm = stepsdata.GenConf.RTMname; info = [];
            try info = h5info(dbfile,['/',rtm]); end

            if flag==2 && ~isempty(info)% User-defined aerosols are available
                % Add ATK aerosols in Aerosol models:
                ind = find(cellfun(cellfind('ATK'),op_modes));
                n = numel(info.Datasets); % Number of user-defined aerosols
                aernames = cell(1,n); valuesatk = (1:n)-1;
                for i=1:n, aernames{i} = info.Datasets(i).Name; end
                op_modes(ind) = [];
                aux           = values(ind); values(ind) = [];
                if ind~=1
                    op_modes = [op_modes(1:ind-1),aernames,op_modes(ind:end)];
                    values   = [values(1:ind-1),aux+valuesatk,values(ind:end)];
                else
                    op_modes = [aernames,op_modes];
                    values   = [aux+valuesatk,values];
                end
            else
                % Remove ATK user-defined aerosol option in Aerosol model:
                ind = find(cellfun(cellfind('ATK'),op_modes));
                op_modes(ind) = [];
                aux = values(ind); values(ind)= [];
                if default==aux, default = values(1); end
            end
        end
        
        if strcmp(data.static,'static'), maxopt=1; else maxopt=length(op_modes); end
        if ~isempty(values),	value = find(values==default);
        else
            values = str2cell(data.values(2:end-1));
            value = find(cellfun(cellfind(data.default),values));
        end
        
        set(handles.listbox1,'string',op_modes,'max',maxopt,'value',value,...
            'userdata',values)
        aux = {'edit1','edit2','text3','text4'};
        for i=1:length(aux),	set(handles.(aux{i}),'enable','off'),   end
    else
        val = stepsdata.GenConf.inputmode;
        if strcmp(val,'Manual (gridded) sampling'), enable = 'on'; else enable = 'off'; end
        visible = 'off'; visible2 = 'on';
        aux = {'edit1','edit2','text3','text4'};
        for i=1:length(aux),	set(handles.(aux{i}),'enable','on'),   end
        aux = str2num(data.values);
        set(handles.edit1,'string',min(aux))
        set(handles.edit2,'string',max(aux))
        set(handles.edit3,'string',2)
    end
    aux = {'edit3','pushbutton4','popupmenu3','text5'};
    for i=1:length(aux),	set(handles.(aux{i}),'enable',enable),   end
    set(handles.uipanel1,'visible',visible2)
    set(handles.listbox1,'visible',visible)
    
end

% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

stepsdata=get(handles.output,'userdata');

if get(handles.listbox2,'value')~=0 && get(handles.listbox3,'value')~=0
    data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
    % Select as accesible to the user those parameters with the visibility
    % attribute set in Step1:
    visibility = {'Basic','Medium','Advanced'};
    aux = stepsdata.GenConf.userlevel;
    visibility = visibility(1:aux);
    fn   = fieldnames(data);
    for i=1:numel(fn)
        if ~isempty(find(cellfun(cellfind(data.(fn{i}).visibility),visibility)))
            auxdata.(fn{i}) = data.(fn{i});
        end
    end
    data = auxdata;     fn   = fieldnames(data);
    opt  = get(handles.listbox3,'value');     data = data.(fn{opt});
    
    ID = data.name; desc = data.description; units = data.unit;
    if strcmp(data.paramtype,'continuous')
        if strcmp(stepsdata.GenConf.inputmode,'Manual (gridded) sampling') % Manual distribution
            if isempty(get(handles.edit3,'string'))
                h = msgbox('Introduce at least 1 sample points','Error add parameter','error');
                set(handles.edit3,'backgroundcolor',[1 1 0])
                uicontrol(handles.edit3)
                set(h,'windowstyle','modal'), uiwait(h)
                return
            elseif (isempty(get(handles.edit1,'string')) || isempty(get(handles.edit2,'string'))) && str2num(get(handles.edit3,'string'))>=2
                h = msgbox('Introduce min/max values','Error add parameter','error');
                set(handles.edit1,'backgroundcolor',[1 1 0])
                set(handles.edit2,'backgroundcolor',[1 1 0])
                uicontrol(handles.edit1)
                set(h,'windowstyle','modal'), uiwait(h)
                return
            elseif (isempty(get(handles.edit1,'string')) && isempty(get(handles.edit2,'string'))) && str2num(get(handles.edit3,'string'))==1
                h = msgbox('Introduce at least a value in the min/max boxes','Error add parameter','error');
                set(handles.edit1,'backgroundcolor',[1 1 0])
                set(handles.edit2,'backgroundcolor',[1 1 0])
                uicontrol(handles.edit1)
                set(h,'windowstyle','modal'), uiwait(h)
                return
            elseif get(handles.popupmenu3,'value')==1
                h = msgbox('Select a valid distribution','Error add parameter','error');
                set(handles.popupmenu3,'backgroundcolor',[1 1 0])
                set(handles.popupmenu3,'value',1)
                uicontrol(handles.popupmenu3)
                set(h,'windowstyle','modal'), uiwait(h)
                return
            else
                set(handles.edit1,'backgroundcolor',[1 1 1])
                set(handles.edit2,'backgroundcolor',[1 1 1])
                set(handles.edit3,'backgroundcolor',[1 1 1])
                set(handles.popupmenu3,'backgroundcolor',[1 1 1])
                
                % Read user-input min/max values:
                min = str2num(get(handles.edit1,'string'));
                max = str2num(get(handles.edit2,'string'));
                % Fill min/max values if not introduced by user:
                if isempty(min), min=max; set(handles.edit1,'string',num2str(min))
                elseif isempty(max), max=min; set(handles.edit1,'string',num2str(max)), end
                n   = str2num(get(handles.edit3,'string'));
                if n==1, max=min; set(handles.edit2,'string',num2str(max)), end
                if n>=2 && max==min, n=1; set(handles.edit3,'string',num2str(n)), end
                % Check if units change with input values then modify
                % min/max:
                if ~isempty(units) && iscell(str2cell(units)) && numel(str2cell(units))==2
                    units = str2cell(units(2:end-1));
                    if min<0 && max<0, units = units{1}; else units = units{2}; end
                    minaux = abs(max); maxaux = abs(min);
                    min = minaux; max = maxaux;
                end
                
                opt = get(handles.popupmenu3,'value');
                switch opt
                    case 2 % Linear spacing in value
                        values = linspace(min,max,n);
                    case 3 % Linear spacing in log of value
                        values = exp(linspace(log(min),log(max),n));
                    case 4 % Linear spacing in exp of - value
                        values = -log(linspace(exp(-min),exp(-max),n));
                    case 5 % Linear spacing in cosine of value
                        values = acosd(linspace(cosd(min),cosd(max),n));
                end
                values = unique(values);
            end
            values = str2num(sprintf('%.3f ',values)); % Just consider up to 3 decimals
            values = strjoin(sort(values));
        else % Latin Hypercute distribution OR Automatic distribution
            if isempty(get(handles.edit1,'string')) || isempty(get(handles.edit2,'string'))
                h = msgbox('Introduce min/max values','Error add parameter','error');
                set(handles.edit1,'backgroundcolor',[1 1 0])
                set(handles.edit2,'backgroundcolor',[1 1 0])
                set(h,'windowstyle','modal'), uiwait(h)
                return
            else
                set(handles.edit1,'backgroundcolor',[1 1 1])
                set(handles.edit2,'backgroundcolor',[1 1 1])
                
                min = str2num(get(handles.edit1,'string'));
                max = str2num(get(handles.edit2,'string'));
                values = strjoin(unique([min,max]));
            end
            % Check if units change with input values then modify min/max:
            if ~isempty(units) && iscell(str2cell(units)) && numel(str2cell(units))==2
            	units = str2cell(units(2:end-1));
                if min<0 && max<0, units = units{1}; else units = units{2}; end
                minaux = abs(max); maxaux = abs(min);
                min = minaux; max = maxaux;
            end
        end
    elseif strcmp(data.paramtype,'discrete') % Only for Discrete options
        if isempty(get(handles.listbox1,'value'))
            h = msgbox('Select at least one option','Error add parameter','error');
            set(handles.listbox1,'backgroundcolor',[1 1 0])
            set(h,'windowstyle','modal'), uiwait(h)
            return
        else
            set(handles.listbox1,'backgroundcolor',[1 1 1])
            aux = str2num(data.values);
            % Check if discrete options are numeric or string:
            if ~isempty(aux) 
                if ~isempty(strfind(data.desc,'Opac')) || ~isempty(strfind(data.desc,'ATK'))
                    % Selected parameter have user-defined or Opac aerosol model
                    aux = get(handles.listbox1,'userdata');
                end
                values = sort(aux(get(handles.listbox1,'value')));
            else
                aux = str2cell(data.values(2:end-1));  
                values = aux{get(handles.listbox1,'value')};
%                 aux = get(handles.listbox1,'string');
            end
            
            % Check whether selected options are user-input Atmospheric or 
            % OPAC Aerosol models:
            UserInput_AtmModel = ~isempty(strfind(data.description,'model')) && ~isempty(strfind(data.description,'Atmospheric')) && any(values<0);
            UserInput_AerModel = ~isempty(strfind(data.description,'model')) && ~isempty(strfind(data.description,'Aerosol')) && any(values<0);
            if UserInput_AtmModel
                hUserAtm = LUTconf_step1bUserAtm('UserData',stepsdata);
                uiwait(hUserAtm)
                filename = stepsdata.GenConf.filename;
                N = h5info([filename,'_UserAtm.h5']);
                N = N.Datasets(14).Dataspace.Size(2);
                % -N indicates N user-defined atmospheric profiles
                values(values==-1) = [];
                values = sort([values,-(1:N)]);
            elseif UserInput_AerModel
                % 1) Run OPAC configuration window
                [OPACconf,~,~] = read_OPACconfig('../Conf/OPACconf.xml');
                [pathstr,~,~]  = fileparts(OPACconf.filepath);
                % Delete all .inp and .out files except the default OPAC
                % opac.inp and opac.out files:
                path = {[pathstr,'/input'],[pathstr,'/results']};
                ext  = {'inp','out'};
                for k=1:2 % For the input and results folders
                	d = dir(path{k});
                    for i=1:length(d)
                    	if ~d(i).isdir && ~strcmp(d(i).name,['opac.',ext{k}])
                        	delete([path{k},d(i).name]) % Delete old files
                        end
                    end
                end
                % Check if user has selected user-defined Aerosol Model
                % with OPAC. In this case launch LUTconf_step1bOPAC:
                if any(values==-11)
                	hOPAC = LUTconf_step1bOPAC('UserData',stepsdata);
                    uiwait(hOPAC)
                    filename = stepsdata.GenConf.filename;
                    confdata = read_LUTconfig([filename,'.xml'],'OpacConf');
                    % <-10 indicates the user-defined aerosols
                    values(values==-11) = [];
                    values = sort([values,-(10+(1:numel(str2num(confdata.NDENS1.values))))]);
                else
                	filename = stepsdata.GenConf.filename;
                    update_LUTconfig([filename,'.xml'],'OpacConf',[])
                end
                % Warn that OPAC will be run
                h = msgbox('OPAC aerosol models will be included in this LUT.',...
                           'Updated aerosol models (OPAC)','warn');
                set(h,'windowstyle','modal'), uiwait(h)
            end
            values = strjoin(values);
        end
    end
    
    table = get(handles.uitable1,'data');
    if ~isempty(table),
        ids = table(:,2);
        idx = find(cellfun(cellfind(ID),ids));
        if ~isempty(idx)
            table(idx,:) = {false,ID,desc,values,units};
            h = msgbox(['The values of the parameter ',ID,' have been updated.'],'Parameter updated','warn');
            set(h,'windowstyle','modal'), uiwait(h)
        else
            table(end+1,:) = {false,ID,desc,values,units};
        end 
    else
        table = {false,ID,desc,values,units};
    end
    set(handles.uitable1,'data',table)
    uicontrol(handles.listbox3)
    
else
    h = msgbox('Select a key input parameter to add to the LUT','Error adding parameter','error');
    set(h,'windowstyle','modal'), uiwait(h)
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

stepsdata=get(handles.output,'userdata');

data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
fn   = fieldnames(data);

% Select as accesible to the user those parameters with the visibility
% attribute set in Step1:
visibility = {'Basic','Medium','Advanced'};
aux = stepsdata.GenConf.userlevel;
visibility = visibility(1:aux);
fn   = fieldnames(data);
for i=1:numel(fn)
	if ~isempty(find(cellfun(cellfind(data.(fn{i}).visibility),visibility)))
    	auxdata.(fn{i}) = data.(fn{i});
	end
end
data = auxdata; fn = fieldnames(data);
opt  = get(handles.listbox3,'value');     data = data.(fn{opt});

input = str2double(get(hObject,'String'));
maxval = max(str2num(data.values)); minval = min(str2num(data.values));
if input>maxval || input<minval
    h = msgbox(['The minimum input value should be between ',num2str(minval),' and ',num2str(maxval)],'Error input value','error');
    set(handles.edit1,'string',num2str(minval))
    set(h,'windowstyle','modal'), uiwait(h)
elseif ~isempty(get(handles.edit2,'string'))
    if str2num(get(handles.edit2,'string'))<input
        h = msgbox('The minimum input value should be lower than the maximum input value','Error input value','error');
        valedit1 = get(handles.edit1,'string');
        valedit2 = get(handles.edit2,'string');
        set(handles.edit1,'string',valedit2)
        set(handles.edit2,'string',valedit1)
        set(h,'windowstyle','modal'), uiwait(h)
    else
        set(handles.pushbutton3,'enable','on')
    end
end

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

stepsdata=get(handles.output,'userdata');

data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
fn   = fieldnames(data);

% Select as accesible to the user those parameters with the visibility
% attribute set in Step1:
visibility = {'Basic','Medium','Advanced'};
aux = stepsdata.GenConf.userlevel;
visibility = visibility(1:aux);
fn   = fieldnames(data);
for i=1:numel(fn)
	if ~isempty(find(cellfun(cellfind(data.(fn{i}).visibility),visibility)))
    	auxdata.(fn{i}) = data.(fn{i});
	end
end
data = auxdata; fn = fieldnames(data);
opt  = get(handles.listbox3,'value');     data = data.(fn{opt});

input = str2double(get(hObject,'String'));
maxval = max(str2num(data.values)); minval = min(str2num(data.values));
if input>maxval || input<minval
    h =msgbox(['The maximum input value should be between ',num2str(minval),' and ',num2str(maxval)],'Error input value','error');
    set(handles.edit2,'string',num2str(maxval))
    set(h,'windowstyle','modal'), uiwait(h)
elseif ~isempty(get(handles.edit1,'string'))
    if str2num(get(handles.edit1,'string'))>input
        h = msgbox('The maximum input value should be higher than the minimum input value','Error input value','error');
        set(handles.pushbutton3,'enable','off')
        valedit1 = get(handles.edit1,'string');
        valedit2 = get(handles.edit2,'string');
        set(handles.edit1,'string',valedit2)
        set(handles.edit2,'string',valedit1)
        set(h,'windowstyle','modal'), uiwait(h)
    else
        set(handles.pushbutton3,'enable','on')
    end
end




% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3


% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if str2num(get(handles.edit3,'string'))<2 || isempty(get(handles.edit3,'string'))
    h = msgbox('Introduce at least 2 sample points','Error preview parameter distribution','error');
    set(handles.edit3,'backgroundcolor',[1 1 0])
    set(h,'windowstyle','modal'), uiwait(h)
elseif isempty(get(handles.edit1,'string')) || isempty(get(handles.edit2,'string'))
    h = msgbox('Introduce min/max values','Error preview parameter distribution','error');
    set(handles.edit1,'backgroundcolor',[1 1 0])
    set(handles.edit2,'backgroundcolor',[1 1 0])
    set(h,'windowstyle','modal'), uiwait(h)
elseif get(handles.popupmenu3,'value')==1
    h = msgbox('Select a valid distribution','Error preview parameter distribution','error');
    set(handles.popupmenu3,'backgroundcolor',[1 1 0])
    set(h,'windowstyle','modal'), uiwait(h)
else
    set(handles.edit1,'backgroundcolor',[1 1 1])
    set(handles.edit2,'backgroundcolor',[1 1 1])
    set(handles.edit3,'backgroundcolor',[1 1 1])
    set(handles.popupmenu3,'backgroundcolor',[1 1 1])
    
    min = str2num(get(handles.edit1,'string'));
    max = str2num(get(handles.edit2,'string'));
    n   = str2num(get(handles.edit3,'string'));
       
    data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox2,'value');     data = data.(fn{opt});
    fn   = fieldnames(data);
    opt  = get(handles.listbox3,'value');     data = data.(fn{opt});
    
    desc = data.description; units = data.unit;
    
    opt = get(handles.popupmenu3,'value');
    switch opt
        case 2
            values = linspace(min,max,n);
        case 3
            values = exp(linspace(log(min),log(max),n));
        case 4
            values = log(linspace(exp(min),exp(max),n));
        case 5
            values = acosd(linspace(cosd(min),cosd(max),n));
    end
    figure
    plot(values,'marker','o','markeredge','r'), grid on
    xlabel('Sample #'), ylabel([desc,' [',units,']'])
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double


% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
table = get(handles.uitable1,'data');
if ~isempty(table)
    select = table(:,1);
    idx    = cell2mat(select);
    ids    = table(:,2);
    if sum(idx)==0
        h = msgbox('Select parameters to remove from LUT.','Remove parameters','warn');
    else
        if sum(idx)==size(table,1), set(handles.checkbox1,'value',0), end
        str = strjoin(ids(idx));
        h = msgbox(['Parameter(s) ',str,' have been removed from LUT.'],'Remove parameters','warn');
        table(idx,:) = [];
        set(handles.uitable1,'data',table)
    end
    set(h,'windowstyle','modal'), uiwait(h)
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

stepsdata=get(handles.output,'userdata');

table = get(handles.uitable1,'data');
if ~islogical(eventdata.EditData)
    if isempty(str2num(eventdata.EditData))
        h = msgbox('Updated data must be comma-separated numerical values.','Input data error','error');
        table{eventdata.Indices(1),eventdata.Indices(2)} = eventdata.PreviousData;
        set(h,'windowstyle','modal'), uiwait(h)
    else
        data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
        for i=1:length(fn)
            try
                data = getfield(data.(fn{i}),table{eventdata.Indices(1),2});
                break
            end
        end
        values = str2num(eventdata.EditData);
        if strcmp(data.paramtype,'continuous')
            maxval = max(str2num(data.values)); minval = min(str2num(data.values));
            if  numel(values)>2 && (strcmp(get(handles.text9,'visible'),'on') || strcmp(stepsdata.GenConf.stopmethod,'Cross-validation error'))
                h = msgbox('No more than 2 values can be introduced.','Input data error','error');
                table{eventdata.Indices(1),eventdata.Indices(2)} = eventdata.PreviousData;
                set(h,'windowstyle','modal'), uiwait(h)
            elseif any(values<minval | values>maxval)
                h = msgbox(['Updated data must be between ',num2str(minval),' and ',num2str(maxval)],'Input data error','error');
                table{eventdata.Indices(1),eventdata.Indices(2)} = eventdata.PreviousData;
                set(h,'windowstyle','modal'), uiwait(h)
            else
                values = strjoin(unique(sort(values)));
                table{eventdata.Indices(1),eventdata.Indices(2)} = values;
            end
        elseif strcmp(data.paramtype,'discrete')
            opt = str2num(data.values); aux = true;
            for i=1:numel(values)
                if any(opt==values(i))==false
                    h = msgbox(['Updated data must only have the following discrete value: ',strjoin(opt)],'Input data error','error');
                    table{eventdata.Indices(1),eventdata.Indices(2)} = eventdata.PreviousData;
                    aux = false; set(h,'windowstyle','modal'),  uiwait(h)
                    break
                end
            end
            if aux
                values = strjoin(unique(sort(values)));
                table{eventdata.Indices(1),eventdata.Indices(2)} = values;
            end
        end
    end
end
idx = eventdata.Indices;
if idx(2)==1
    select = table(:,1);
    idx    = cell2mat(select);
    if any(idx==0), set(handles.checkbox1,'value',0)
    else,           set(handles.checkbox1,'value',1)
    end
end
set(handles.uitable1,'data',table)


% --- Executes on key press with focus on LUTconf_step2 or any of its controls.
function LUTconf_step2_WindowKeyPressFcn(hObject, eventdata, handles)
% hObject    handle to LUTconf_step2 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

% determine the key that was pressed 
keyPressed = eventdata.Key;
switch keyPressed
    case 'return'
        % set focus to the button
        uicontrol(handles.pushbutton3);
        % call the callback
        pushbutton3_Callback(handles.pushbutton3,[],handles);
    case 'n'
         % set focus to the button
         uicontrol(handles.pushbutton2);
         % call the callback
         pushbutton2_Callback(handles.pushbutton2,[],handles);
    case 'p'
         % set focus to the button
         uicontrol(handles.pushbutton1);
         % call the callback
         pushbutton1_Callback(handles.pushbutton1,[],handles);
end

function MovetoStep3(handles)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

h = findobj('Tag','AtmLutGen'); %%%%%%%%%%
handlesAtmLutGen = guidata(h); %%%%%%%%%%

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
prevGenConf = stepsdata.prevGenConf;

[~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
data = data.SpeParam;

% Check if RTM has defined spectral parameters in the RTMconf.xml:
if ~isempty(data)
    fn = fieldnames(data);
    desc = str2cell(data.(fn{end}).desc(2:end-1)); if ischar(desc), desc = {desc}; end
    values = str2cell(data.(fn{end}).values(2:end-1)); if ischar(values), values = {values}; end
    format = {'logical','numeric','numeric',desc};
    
    % Move to step 3 considering step 1 configuration and considering
    % whether or not step 3 was previously opened:
    fn = fieldnames(stepsdata);
    if ~isempty(find(cellfun(cellfind('SpeConf'),fn)))
        % Step 3 has been opened before so we need to update uitable1
        % according to the previous stored data and the updated Step 1
        % configuration     
        if ~isempty(prevGenConf) && ~strcmp(prevGenConf.RTMname,GenConf.RTMname)
            % If previous selected RTM has changed, then previous spectral
            % configutation is not valid ==> default table
            fn = fieldnames(data);
            N   = str2num(data.NumBands.default);
            min = str2num(data.MinLambda.default); max = str2num(data.MaxLambda.default);
            res = find(cellfun(cellfind(data.(fn{end}).default),values));
            tabledata = cell(N,4);
            for i=1:N,	tabledata(i,:) = {false,min,max,desc{res}}; end
        else
            tabledata = stepsdata.SpeConf.table;
            for i=1:size(tabledata,1)
                res = find(cellfun(cellfind(tabledata{i,end}),values));
                if ~isempty(res)
                    tabledata{i,end} = desc{res};
                end
            end
        end
    else
        % It is the first time to open Step 3 therefore table is default:
        % Update table with default wavelengths and resolutions:
        tabledata = [];
    end
    stepsdata.SpeConf.table  = tabledata;
    stepsdata.SpeConf.format = format;
    stepsdata.SpeConf.unit   = data.MinLambda.unit;
%     LUTconf_step3('UserData',stepsdata)
    updatesubblock('LUTconf_step3',handlesAtmLutGen,stepsdata);
%     set(handlesStep3.uitable1,'data',table,'columnformat',format)
    
    % Closes Step2:
%     close(handles.LUTconf_step2)
else
    h = msgbox(['No spectral configuration parameters have been defined for the ',...
            GenConf.RTMname,' RTM.'],'Input spectral configuration error','error');
    set(h,'windowstyle','modal'), uiwait(h)
end


% --- Executes on mouse press over figure background.
function ImageClickCallback(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
if strcmp(GenConf.RTMname,'MODTRAN5')
    aux = 'modtran5';
elseif strcmp(GenConf.RTMname,'MODTRAN6')
    aux = 'modtran6';
elseif strcmp(GenConf.RTMname,'sixSV')
    aux = '6sv';
end

axesHandle  = get(hObject,'Parent');
tag = get(axesHandle,'userdata'); 
switch tag
    case 'info1'
        web(['../Help/html/third_party_sw/',aux,'-variables.html'],'-browser')
    case 'info2'
        opt = get(handles.listbox2,'value');
        if opt==1
            web(['../Help/html/third_party_sw/',aux,'vars/',aux,'-variables-atmospheric.html'],'-browser')
        elseif opt==2
            web(['../Help/html/third_party_sw/',aux,'vars/',aux,'-variables-aerosols.html'],'-browser')
        elseif opt==3
            web(['../Help/html/third_party_sw/',aux,'vars/',aux,'-variables-geometric.html'],'-browser')
        end
    case 'info3'
        web('../Help/html/generation/keyvars.html#paramtype','-browser')
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
opt   = get(handles.checkbox1,'value');
tabledata = get(handles.uitable1,'data');

if opt==1, tabledata(:,1) = {true};
else tabledata(:,1) = {false};
end
set(handles.uitable1,'data',tabledata)

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
stepsdata=get(handles.output,'UserData');

visibility = {'Basic','Medium','Advanced'};
aux = stepsdata.GenConf.userlevel;
visibility = visibility(1:aux);

table = get(handles.uitable1,'data');

data = get(handles.listbox2,'userdata');  fn   = fieldnames(data);
for i=1:3
    data2 = data.(fn{i}); fn2   = fieldnames(data2);
    % Add to table according to the user visibility attribute set in Step1:
    for j=1:numel(fn2)
        if ~isempty(find(cellfun(cellfind(data2.(fn2{j}).visibility),visibility)))
            auxdata.(fn2{j}) = data2.(fn2{j});
        end
    end
end

fn = fieldnames(auxdata);
for i=1:numel(fn)
    if isempty(find(cellfun(cellfind(fn{i}),table(:,2))))
        table(end+1,:) = {false,fn{i},auxdata.(fn{i}).description,'',auxdata.(fn{i}).unit};
        sz=size(table,1);
        if strcmp(auxdata.(fn{i}).paramtype,'continuous')
                table{sz,4} = strjoin(str2num(auxdata.(fn{i}).values));
            elseif strcmp(auxdata.(fn{i}).paramtype,'discrete')
                table{sz,4} = auxdata.(fn{i}).default;
        end
    end
end
set(handles.uitable1,'data',table)

h = msgbox(['All Atmospheric, Aerosol and Geometric parameters have been',...
            ' added. Review values and update table!'],'Updated table','warn');
    set(h,'windowstyle','modal'), uiwait(h)
