function varargout = LUTconf_step3(varargin)
% LUTCONF_STEP3 MATLAB code for LUTconf_step3.fig
%      LUTCONF_STEP3, by itself, creates a new LUTCONF_STEP3 or raises the existing
%      singleton*.
%
%      H = LUTCONF_STEP3 returns the handle to a new LUTCONF_STEP3 or the handle to
%      the existing singleton*.
%
%      LUTCONF_STEP3('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LUTCONF_STEP3.M with the given input arguments.
%
%      LUTCONF_STEP3('Property','Value',...) creates a new LUTCONF_STEP3 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LUTconf_step3_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LUTconf_step3_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LUTconf_step3

% Last Modified by GUIDE v2.5 10-May-2017 18:15:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LUTconf_step3_OpeningFcn, ...
                   'gui_OutputFcn',  @LUTconf_step3_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LUTconf_step3 is made visible.
function LUTconf_step3_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LUTconf_step3 (see VARARGIN)

% Choose default command line output for LUTconf_step3
handles.output = hObject;

cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

% Load LUT configuration parameters if selected:
h = findobj('Tag','AtmLutGen');
handlesAtmLutGen = guidata(h);

stepsdata = get(handles.output,'UserData');
LUTconffile = get(handlesAtmLutGen.loadlut,'UserData');
if ~isempty(LUTconffile) && isempty(stepsdata.SpeConf.table)
    % User has selected to load LUT configuration file, then read file and
    % update handles
    SpeConf = read_LUTconfig(LUTconffile,'SpeConf');
    fn = fieldnames(SpeConf);
    wvlmin  = str2cell(SpeConf.MinLambda.values);
    wvlmax  = str2cell(SpeConf.MaxLambda.values);
    value   = str2cell(SpeConf.(fn{end}).values(2:end-1));
    
    [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],stepsdata.GenConf.RTMname);
    data = data.SpeParam; fn = fieldnames(data);
    desc = str2cell(data.(fn{end}).desc(2:end-1));
    values = str2cell(data.(fn{end}).values(2:end-1));
    
    if iscell(wvlmin)
        N = numel(wvlmin);
        for i=1:N
            aux = find(cellfun(cellfind(value{i}),values));
            res{i} = desc{aux};
            tabledata(i,:) = {false,str2num(wvlmin{i}),str2num(wvlmax{i}),res{i}};	
        end
    else
        aux = find(cellfun(cellfind(value),values));
        res = desc{aux};
        tabledata = {false,str2num(wvlmin),str2num(wvlmax),res};
    end
    Colname = get(handles.uitable1,'ColumnName');
    set(handles.uitable1,'data',tabledata,'columnformat',stepsdata.SpeConf.format)
elseif isempty(stepsdata.SpeConf.table)
    % It is the first time to open Step 3 from Step 2 therefore table is 
    % default. Update table with default wavelengths and resolutions:
    [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],stepsdata.GenConf.RTMname);
    data = data.SpeParam;
    fn = fieldnames(data);
	desc = str2cell(data.(fn{end}).desc(2:end-1)); if ischar(desc), desc = {desc}; end
    values = str2cell(data.(fn{end}).values(2:end-1)); if ischar(values), values = {values}; end
    N   = str2num(data.NumBands.default);
    min = str2num(data.MinLambda.default); max = str2num(data.MaxLambda.default);
    res = find(cellfun(cellfind(data.(fn{end}).default),values));
    tabledata = cell(N,4);
    for i=1:N,	tabledata(i,:) = {false,min,max,desc{res}}; end
    set(handles.uitable1,'data',tabledata,'columnformat',stepsdata.SpeConf.format)
    colname = get(handles.uitable1,'columnname');
    set(handles.uitable1,'columnname',cellfun(@(x)strrep(x,'nm',data.MinLambda.unit),colname,'un',0))
else
    % Step 3 has been opened from Step 4:
	if ~strcmp(stepsdata.SpeConf.unit,'nm')
        Colname = get(handles.uitable1,'ColumnName');
        i1 = strfind(Colname{2},'[')+1; i2 = strfind(Colname{2},']')-1;
        Colname{2} = strrep(Colname{2},Colname{2}(i1:i2),stepsdata.SpeConf.unit);
        i1 = strfind(Colname{3},'[')+1; i2 = strfind(Colname{3},']')-1;
        Colname{3} = strrep(Colname{3},Colname{3}(i1:i2),stepsdata.SpeConf.unit);
        set(handles.uitable1,'ColumnName',Colname)
    end
    set(handles.uitable1,'data',stepsdata.SpeConf.table,'columnformat',stepsdata.SpeConf.format)
end

[Sensorconf]   = read_Sensorconfig(['..',filesep,'Conf',filesep,'Sensorconf.xml']);
set(handles.listbox1,'string',{Sensorconf(:).name},'value',[],'min',0,'max',numel(Sensorconf))
set(handles.pushbutton8,'enable','off')

% Modify foreground color of Next button (pushbutton2):
% Modify foreground color of Previous and Next buttons (pushbutton1 and pushbutton2):
button = {'pushbutton1','pushbutton2'};
for i=1:numel(button)
    units = get(handles.(button{i}),'units'); set(handles.(button{i}),'units','pixels')
    cdark = get(handles.(button{i}),'foregroundcolor'); clight = 1.8*cdark;
    aux = uint16(get(handles.(button{i}),'position')); set(handles.(button{i}),'units',units)
    x = zeros(aux(4),aux(3),3);
    sz1 = size(x(1:round(aux(4)/2),:,:)); sz2 = size(x(round(aux(4)/2)+1:end,:,:));
    x(1:round(aux(4)/2),:,:) = permute(repmat(clight',[1,sz1(1:2)]),[2 3 1]);
    x(round(aux(4)/2)+1:end,:,:) = permute(repmat(cdark',[1,sz2(1:2)]),[2 3 1]);
    x(1:end,1,:)=0.94; x(1:end,size(x,2),:)=0.94; x(1,1:end,:)=0.94; x(size(x,1),1:end,:)=0.94;
    x(3:end-2,2,:)=0.7; x(4:end-2,size(x,2)-1,:)=0.5; x(2,3:end-2,:)=0.7; x(size(x,1)-1,4:end-2,:)=0.5;
    x(2,2,:)=0.85; x(size(x,1)-1,size(x,2)-1,:)=0.85; x(2,size(x,2)-1,:)=0.85; x(size(x,1)-1,2,:)=0.85;
    x(3,size(x,2)-1,:)=0.85; x(size(x,1)-1,3,:)=0.85;
    x(3,3,:)=0.65; x(size(x,1)-2,size(x,2)-2,:)=0.7; x(3,size(x,2)-2,:)=0.65; x(size(x,1)-2,3,:)=0.65; 
    set(handles.(button{i}),'cdata',x,'userdata',{x,cdark});
    set(handles.(button{i}),'foregroundcolor',[1 1 1])
end


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes LUTconf_step3 wait for user response (see UIRESUME)
% uiwait(handles.LUTconf_step3);


% --- Outputs from this function are returned to the command line.
function varargout = LUTconf_step3_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

tabledata = get(handles.uitable1,'data');

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
[~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);

data = data.SpeParam; Nmax = max(str2num(data.NumBands.values));

if size(tabledata,1)==Nmax
    h = msgbox(['Error adding spectral band. The maximum spectral bands allowed is ',num2str(Nmax)],'Error adding spectral band','error');
    set(h,'windowstyle','modal'), uiwait(h)
    return
elseif isempty(tabledata)
    fn = fieldnames(data);
    min1 = str2num(data.MinLambda.default); max1 = str2num(data.MaxLambda.default);
    desc = str2cell(data.(fn{end}).desc(2:end-1)); if ischar(desc), desc = {desc}; end
    values = str2cell(data.(fn{end}).values(2:end-1)); if ischar(values), values = {values}; end
    res = find(cellfun(cellfind(data.(fn{end}).default),values));
    tabledata(1,:) = {false,min1,max1,desc{res}};
else
    tabledata(end+1,:) = {false,tabledata{end,3},[],tabledata{end}};
end
set(handles.uitable1,'data',tabledata);


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

try
    % Before moving back to Step 2 we update the output UserData including the
    % table from uitable1. The structure stepsdata will contain the GenConf
    % from the step 1, the uitable1 data from step 2 and the SpeConf from step 3:
    stepsdata = get(handles.output,'UserData');
    stepsdata.SpeConf.table = get(handles.uitable1,'data');
    stepsdata.SpeConf.format = get(handles.uitable1,'columnformat');
    h = findobj('Tag','AtmLutGen');
    handlesAtmLutGen = guidata(h);
    updatesubblock('LUTconf_step2',handlesAtmLutGen,stepsdata);
    % LUTconf_step2('UserData',stepsdata)
    % close(handles.LUTconf_step3)
catch me
    msgbox(me.message,'Error','error')
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

try
    h = findobj('Tag','AtmLutGen');
    handlesAtmLutGen = guidata(h);

    tabledata = get(handles.uitable1,'data');
    if ~isempty(tabledata) % If user has input data for the LUT
        % Check if every cell in the table has a valid value:
        if sum(any(strcmp(tabledata,'')))
            h = msgbox('Please don''t leave any empty values in the table',...
                       'Save LUT configuration error','error');
            set(h,'windowstyle','modal'), uiwait(h)
            aux = strcmp(tabledata,'');
            for i=1:size(aux,1)
                if any(aux(i,:)), tabledata(i,1) = {true}; end
            end
            set(handles.uitable1,'data',tabledata)
            return
        end

        stepsdata = get(handles.output,'UserData');
        stepsdata.SpeConf.table = tabledata;
        stepsdata.SpeConf.format = get(handles.uitable1,'columnformat');

        GenConf   = stepsdata.GenConf;
        prevGenConf = stepsdata.prevGenConf;
        [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
        data = data.SpeParam; fn = fieldnames(data);
        desc = str2cell(data.(fn{end}).desc(2:end-1)); if ischar(desc), desc = {desc}; end
        values = str2cell(data.(fn{end}).values(2:end-1)); if ischar(values), values = {values}; end

        for i=1:size(tabledata,1)
            res = find(cellfun(cellfind(tabledata{i,end}),desc));
            value{i} = values{res};
        end
        for i=2:3    % MinLambda and MaxLambda:
            SpeConf.(fn{i}).values      = strjoin(tabledata(:,i));
            SpeConf.(fn{i}).description = data.(fn{i}).description;
            SpeConf.(fn{i}).datatype    = data.(fn{i}).datatype;
            SpeConf.(fn{i}).unit        = data.(fn{i}).unit;
        end
        % Resolution:
        SpeConf.(fn{end}).values      = ['{',strjoin(value),'}'];
        SpeConf.(fn{end}).description = data.(fn{end}).description;
        SpeConf.(fn{end}).datatype    = data.(fn{end}).datatype;
        SpeConf.(fn{end}).unit        = data.(fn{end}).unit;

        filename = GenConf.filename;
        [~,name,~] = fileparts(filename);

        update_LUTconfig([filename,'.xml'],'SpeConf',SpeConf)

%         msg = ['LUT spectral configuration stored in ',name,'.xml file'];
%         h = msgbox(msg,'Spectral configuration updated','warn');
%         set(h,'windowstyle','modal'), uiwait(h)

    %     set(handles.output,'UserData',SpeConf)
        guidata(hObject, handles);

        % Move to step 4 considering step 1 configuration and considering
        % whether or not step 4 was previously opened:
        fn = fieldnames(stepsdata);
        if ~isempty(find(cellfun(cellfind('AdvConf'),fn)))
            % Step 4 has been opened before so we need to update uitable1
            % according to the previous stored data and the updated Step 1
            % configuration
            if ~isempty(prevGenConf) && ~strcmp(prevGenConf.RTMname,GenConf.RTMname)
                % If previous selected RTM has changed, then previous spectral
                % configutation is not valid ==> empty table
                tabledata = [];
            else
                tabledata = stepsdata.AdvConf.table;
            end
        else
            % It is the first time to open Step 4 therefore table is empty:
            % Update table with default wavelengths and resolutions:
            tabledata = [];
        end
        [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
        data = data.AdvParam; 
        if isempty(data)
            update_LUTconfig([filename,'.xml'],'AdvConf',[])
            % Move to LUT creation:
            LUTGen_inputs(['..',filesep,'Conf',filesep,'RTMconf.xml'],[filename,'.xml'])
            close(handles.LUTconf_step3)
        else
            fn = fieldnames(data);
            for i=1:numel(fn)
                ParamNames{i} = data.(fn{i}).description;
            end
            stepsdata.AdvConf.ParamNames = ParamNames;
            stepsdata.AdvConf.data       = data;
            stepsdata.AdvConf.table      = tabledata;
            updatesubblock('LUTconf_step4',handlesAtmLutGen,stepsdata);
        %     LUTconf_step4('UserData',stepsdata)

            % Close Step3:
        %     close(handles.LUTconf_step3)
        end
    else
         h = msgbox('There should be at least one spectral band.','Spectral configuration error','error');
         set(h,'windowstyle','modal'), uiwait(h)
    end
catch me
    msgbox(me.message,'Error','error')
end

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tabledata = get(handles.uitable1,'data');
if ~isempty(tabledata)
    select = tabledata(:,1);
    idx    = cell2mat(select);
    if sum(idx)==0
        h = msgbox('Select spectral bands to remove.','Remove spectral bands','error');
        set(h,'windowstyle','modal'), uiwait(h)
    else
        if sum(idx)==size(tabledata,1), set(handles.checkbox1,'value',0), end
        tabledata(idx,:) = [];
        set(handles.uitable1,'data',tabledata)
    end
    
end


% --- Executes on key press with focus on LUTconf_step3 or any of its controls.
function LUTconf_step3_WindowKeyPressFcn(hObject, eventdata, handles)
% hObject    handle to LUTconf_step3 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

keyPressed = eventdata.Key;
switch keyPressed
    case 'add'
        % set focus to the button
        uicontrol(handles.pushbutton3)
        % call the callback
        pushbutton3_Callback(handles.pushbutton3,[],handles);
        uitable(handles.uitable1);
    case 'subtract'
        % set focus to the button
        uicontrol(handles.pushbutton4);
        % call the callback
        pushbutton4_Callback(handles.pushbutton4,[],handles);
    case 'n'
         % set focus to the button
         uicontrol(handles.pushbutton2);
         % call the callback
         pushbutton2_Callback(handles.pushbutton2,[],handles);
    case 'p'
         % set focus to the button
         uicontrol(handles.pushbutton1);
         % call the callback
         pushbutton1_Callback(handles.pushbutton1,[],handles);
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

tabledata = get(handles.uitable1,'data');
idx = eventdata.Indices;
if idx(2)==2 || idx(2)==3
    % Check if input is string or numeric:
    if isempty(str2num(eventdata.EditData))
        h = msgbox('Only numeric values are accepted','Wrong input value','warn');
        set(h,'windowstyle','modal'), uiwait(h)
        tabledata(idx(1),idx(2)) = {eventdata.PreviousData};
        auxtable = tabledata;
    elseif idx(2)==2
        auxtable = tabledata;
        aux = 1:size(tabledata,1); aux = find(aux~=idx(1));
        if eventdata.NewData < cell2mat(tabledata(1,2))
            % New band starts with the lowest wavelength ==> first band
            if ~isempty(cell2mat(tabledata(idx(1),3))) && cell2mat(tabledata(idx(1),3))>cell2mat(tabledata(aux(1),3))
                tabledata(idx(1),3) = tabledata(aux(1),2);
            end
            auxtable = tabledata([idx(1) aux],:);
        elseif eventdata.NewData >= cell2mat(tabledata(size(tabledata,1),3))
        	% New band starts with the highest wavelength ==> last band
            if ~isempty(cell2mat(tabledata(idx(1),3)))
                tabledata(idx(1),3) = tabledata(idx(1),2);
            end
            auxtable = tabledata([aux idx(1)],:);
        end
        % Check if updated value is within the spectral range of existing 
        % bands:
        for i=aux
            if eventdata.NewData>cell2mat(tabledata(i,2)) && eventdata.NewData<cell2mat(tabledata(i,3))
            	h = msgbox(['Inserted value (',eventdata.EditData,' nm) is overlapping with existing band #',...
                       num2str(i),' (',strrep(strjoin(tabledata(i,2:3)),',','-'),...
                       ' nm). Please introduce a different value'],'Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                auxtable(idx(1),idx(2)) = {eventdata.PreviousData};
            end
        end
        % Check if updated value is within two existing bands:
        for i=1:numel(aux)-1
        	if eventdata.NewData>=cell2mat(tabledata(aux(i),3)) && eventdata.NewData<=cell2mat(tabledata(aux(i+1),2));
                if ~isempty(cell2mat(tabledata(idx(1),3))) && (cell2mat(tabledata(idx(1),3))<eventdata.NewData || cell2mat(tabledata(idx(1),3))>cell2mat(tabledata(aux(i+1),2)))
                    tabledata(idx(1),3) = tabledata(aux(i+1),2);
                end
                auxtable = tabledata([aux(1:i) idx(1) aux(i+1:end)],:);
            end
        end
        % Check if updated value is within valid RTM spectral range:
        stepsdata = get(handles.output,'UserData');
        GenConf   = stepsdata.GenConf;
        [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
        data = data.SpeParam; range = str2num(data.MinLambda.values);
        if eventdata.NewData<range(1) || eventdata.NewData>range(2)
            h = msgbox(['Inserted value (',eventdata.EditData,' nm) exceeds the valid ',...
                       GenConf.RTMname,' spectral range (',num2str(range(1)),'-',...
                       num2str(range(2)),' nm). Please introduce a different value'],...
                       'Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                auxtable(idx(1),idx(2)) = {eventdata.PreviousData};
        end        
    elseif idx(2)==3
        auxtable = tabledata;
        if eventdata.NewData<cell2mat(tabledata(idx(1),2)) 
             h = msgbox(['Inserted value (',eventdata.EditData,' nm) is below min. wavelength of band #',...
                    num2str(idx(1)),' (',num2str(cell2mat(tabledata(idx(1),2))),...
                    ' nm). Please introduce a different value'],'Wrong input value','error');
            set(h,'windowstyle','modal'), uiwait(h)
            auxtable(idx(1),idx(2)) = {eventdata.PreviousData};
        elseif any(eventdata.NewData>cell2mat(tabledata(idx(1)+1:end,2)))
            h = msgbox(['Updated band #',num2str(idx(1)),' (',num2str(cell2mat(tabledata(idx(1),2))),...
                   '-',eventdata.EditData,' nm) is overlapping with band #',...
                    num2str(idx(1)+1),' (',strrep(strjoin(tabledata(idx(1)+1,2:3)),',','-'),...
                    ' nm). Please introduce a different value'],'Wrong input value','error');
            set(h,'windowstyle','modal'), uiwait(h)
            auxtable(idx(1),idx(2)) = {eventdata.PreviousData};
        end
        % Check if updated value is within valid RTM spectral range:
        stepsdata = get(handles.output,'UserData');
        GenConf   = stepsdata.GenConf;
        [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
        data = data.SpeParam; range = str2num(data.MinLambda.values);
        if eventdata.NewData<range(1) || eventdata.NewData>range(2)
            h = msgbox(['Inserted value (',eventdata.EditData,' nm) exceeds the valid ',...
                       GenConf.RTMname,' spectral range (',num2str(range(1)),'-',...
                       num2str(range(2)),' nm). Please introduce a different value'],...
                       'Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                auxtable(idx(1),idx(2)) = {eventdata.PreviousData};
        end  
        
    end    
    set(handles.uitable1,'data',auxtable);
	return
elseif idx(2)==1
    select = tabledata(:,1);
    idx    = cell2mat(select);
    if any(idx==0), set(handles.checkbox1,'value',0)
    else            set(handles.checkbox1,'value',1)
    end
end


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
[~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);

data = data.SpeParam; Nmax = max(str2num(data.NumBands.values));
fn = fieldnames(data);
min1 = str2num(data.MinLambda.values); min1 = min1(1);
max1 = str2num(data.MaxLambda.values); max1 = max1(2);
if strcmp(data.MinLambda.unit,'um') % Convert to nm
    min1 = 1000*min1; max1=1000*max1;
end
desc = str2cell(data.(fn{end}).desc(2:end-1)); if ischar(desc), desc = {desc}; end
res  = zeros(1,numel(desc)); % RTM resolution options in units of data.(fn{end}).unit
for i=1:numel(res), ind = strfind(desc{i},' '); res(i) = str2num(desc{i}(1:ind-1)); end

opt = get(handles.listbox1,'value');

[Sensorconf]   = read_Sensorconfig(['..',filesep,'Conf',filesep,'Sensorconf.xml']);

% Spectral Oversampling Factor (SOF) sets output spectral resolution output
% a factor at least SOF higher than the FWHM:
SOF = 10;
% ISRF Kernel Size (IKS) specifies the size of the ISRF, as a percentage 
% (in %) of the FWHM, around the barycenter. For wavelenghts beyond the
% IKS, the ISRF is assumed to be 0 and thus no spectral data would be
% needed:
IKS = 1.25; % 125% of the FWHM

% Read sensors configuration and fill table:
auxind = 1;
for i=1:numel(opt)
    auxsensor = Sensorconf(opt(i));
    if strcmp(auxsensor.spectral_mode,'Multiband')
        for j=1:numel(auxsensor.bands)
            if isempty(auxsensor.bands(1).isrf_wvl)
                % Band limits are set by a IKS factor of the FWHM around
                % the barycenter:
                C      = str2num(auxsensor.bands(j).barycenter);
                FWHM   = str2num(auxsensor.bands(j).fwhm);
                auxmin = C - IKS*FWHM;
                auxmax = C + IKS*FWHM;
                if auxmin<min1, auxmin = min1; end
                if auxmax<min1, auxmax = min1; end
                if auxmax>max1, auxmax = max1; end
                if auxmin>max1, auxmin = max1; end
                % Find the spectral resolution closer to the FWHM scaled by
                % the SOF:
                auxres = unitconvert(C,res,data.(fn{end}).unit);
                dv = FWHM/SOF - auxres; 
                aux = find(dv>0); [~,ind] = min(dv(dv>0)); ind = aux(ind);
                if isempty(ind)
                    aux = find(dv<0); [~,ind] = max(dv(dv<0)); ind = aux(ind);
                end
                % Add entry to the table:
                tabledata(auxind,:) = {false,auxmin,auxmax,desc{ind}};
                if strcmp(data.MinLambda.unit,'um') % Convert to back to um
                    tabledata{auxind,2} = tabledata{auxind,2}/1000;
                    tabledata{auxind,3} = tabledata{auxind,3}/1000;
                end
                auxind = auxind+1;
            else
                % Band limits are set according to the ISRF:
                % TO BE DONE
            end
        end
    elseif strcmp(auxsensor.spectral_mode,'Hyperspectral')
        for j=1:numel(auxsensor.bands)
            % Band limits are set by a IKS factor of the lowest value 
            % between the FWHM and the SSI, extending the predefiend 
            % min/max wavelength range:
            FWHM   = str2num(auxsensor.bands(j).fwhm);
            SSI   = str2num(auxsensor.bands(j).ssi);
            auxmin = str2num(auxsensor.bands(j).min_wvl) - IKS*min(FWHM,SSI);
            auxmax = str2num(auxsensor.bands(j).max_wvl) + IKS*min(FWHM,SSI);
            if auxmin<min1, auxmin = min1; end
            if auxmax<min1, auxmax = min1; end
            if auxmax>max1, auxmax = max1; end
            if auxmin>max1, auxmin = max1; end
            % Find the spectral resolution closer to the lowest of FWHM or 
            % SSI scaled bythe SOF:
            auxres1 = unitconvert(auxmin,res,data.(fn{end}).unit);
            auxres2 = unitconvert(auxmax,res,data.(fn{end}).unit);
            auxres  = max([auxres1;auxres2]);
            dv = min(FWHM,SSI)/SOF - auxres; aux = find(dv>0);
            if isempty(aux)
                [~,ind] = min(abs(dv));
                h = msgbox([GenConf.RTMname,' RTM available spectral ',...
                       'resolutions are not fine enough for the ',...
                       'selected instrument. Resolution has been set to ',...
                       desc{ind}],'','warn');
                set(h,'windowstyle','modal'), uiwait(h)
            else
                [~,ind] = min(dv(dv>0)); ind = aux(ind);
            end
            % Add entry to the table:
            tabledata(auxind,:) = {false,auxmin,auxmax,desc{ind}};
            if strcmp(data.MinLambda.unit,'um') % Convert to back to um
                tabledata{auxind,2} = tabledata{auxind,2}/1000;
                tabledata{auxind,3} = tabledata{auxind,3}/1000;
            end
            auxind = auxind+1;
        end 
    end
end

% Reorganize table (e.g. sorting, overlapping bands...):
tabledata = [get(handles.uitable1,'data');tabledata];
% Sort table in increasing order of min. wavelength:
[~,i] = sort(cell2mat(tabledata(:,2))); tabledata = tabledata(i,:);

i=1;
while i<size(tabledata,1)
    start = cell2mat(tabledata(:,2)); finish = cell2mat(tabledata(:,3));
    over = bsxfun(@lt,start,finish'); over = over & over';
    if over(i,i+1) 
        % Band i and i+1 are overlapped
        if strcmp(cell2mat(tabledata(i+1,4)),cell2mat(tabledata(i,4)))
            % Overlapping bands have the same resolution ==> 1 single band
            tabledata(i,2:4) = [tabledata(i,2) {max([cell2mat(tabledata(i,3)) cell2mat(tabledata(i+1,3))])} cell2mat(tabledata(i,4))];
            tabledata(i+1,:) = [];
        else
            % Overlapping bands have different resolution ==> Divide in 3 
            % subbands :
            clear res1 res2 res3
            subband1 = [tabledata(i,2),tabledata(i+1,2)]; res1 = cell2mat(tabledata(i,4));
            if cell2mat(tabledata(i,3))<=cell2mat(tabledata(i+1,3))
                subband2 = [tabledata(i+1,2),tabledata(i,3)];
                auxres2 = {cell2mat(tabledata(i,4)),cell2mat(tabledata(i+1,4))};
                ind = strfind(auxres2,' '); for j=1:2, res2(j) = str2num(auxres2{j}(1:ind{j}-1)); end
                res2 = [num2str(min(res2)),auxres2{1}(ind{1}:end)];
                subband3 = [tabledata(i,3),tabledata(i+1,3)];
                res3 = cell2mat(tabledata(i+1,4));
            else
                subband2 = [tabledata(i+1,2),tabledata(i+1,3)];
                auxres2 = {cell2mat(tabledata(i,4)),cell2mat(tabledata(i+1,4))};
                ind = strfind(auxres2,' '); for j=1:2, res2(j) = str2num(auxres2{j}(1:ind{j}-1)); end
                res2 = [num2str(min(res2)),auxres2{1}(ind{1}:end)];
                subband3 = [tabledata(i+1,3),tabledata(i,3)];
                res3 = cell2mat(tabledata(i,4));
            end
            % 2) Merge subbands if resolution is the same:
            if strcmp(res1,res2)
                subband1 = [subband1(1), subband2(2)];
                tabledata(i,2:4) = [subband1(1) subband1(2) res1];
                if strcmp(res1,res3)
                    subband1 = [subband1(1), subband3(2)];
                    tabledata(i,2:4) = [subband1(1) subband1(2) res1];
                    tabledata(i+1,:) = [];
                else
                    subband2 = subband3;
                    tabledata(i+1,2:4) = [subband2(1) subband2(2) res3];
                end
            elseif strcmp(res2,res3)
                tabledata(i,2:4) = [subband1(1) subband1(2) res1];
                subband2 = [subband2(1),subband3(2)];
                tabledata(i+1,2:4) = [subband2(1) subband2(2) res3];
            else
                tabledata(i,2:4) = [subband1(1) subband1(2) res1];
                tabledata(i+1,2:4) = [subband2(1) subband2(2) res2];
                tabledata(i+3:end+1,:) = tabledata(i+2:end,:);
                tabledata(i+2,:) = [false subband3(1) subband3(2) res3];
            end
        end
        % 3) Sort table in increasing order of min. wavelength:
        [~,j] = sort(cell2mat(tabledata(:,2))); tabledata = tabledata(j,:);
        idxaux = cellfun(@isequal,tabledata(:,2),tabledata(:,3));
        tabledata(idxaux,:) = [];
        
        i=1;
    else
        if tabledata{i,3}==tabledata{i+1,2} && strcmp(cell2mat(tabledata(i+1,4)),cell2mat(tabledata(i,4)))
            % Overlapping bands have the same resolution ==> 1 single band
            tabledata(i,2:4) = [tabledata(i,2) {max([cell2mat(tabledata(i,3)) cell2mat(tabledata(i+1,3))])} cell2mat(tabledata(i,4))];
            tabledata(i+1,:) = [];
            i=i-1;
        end
        i=i+1;
    end
end
    
set(handles.uitable1,'data',tabledata)

% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

opt = get(handles.listbox1,'value');
if isempty(opt)
    set(handles.pushbutton8,'enable','off')
else
    set(handles.pushbutton8,'enable','on')
end

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
opt   = get(handles.checkbox1,'value');
tabledata = get(handles.uitable1,'data');

if opt==1, tabledata(:,1) = {true};
else tabledata(:,1) = {false};
end
set(handles.uitable1,'data',tabledata)


function outres = unitconvert(wvl,inres,unit)
% UNITCONVERT converts the spectral resolution INRES (at the wavelength WVL
% in [nm]) from the units specified in UNIT to [nm] and outputs its value
% in OUTRES

if strcmp(unit,'nm')
    outres = inres;
elseif strcmp(unit,'cm-1')
    outres = wvl - 1e7*wvl./(inres*wvl+1e7);
end
