function varargout = LUTconf_step4(varargin)
% LUTCONF_STEP4 MATLAB code for LUTconf_step4.fig
%      LUTCONF_STEP4, by itself, creates a new LUTCONF_STEP4 or raises the existing
%      singleton*.
%
%      H = LUTCONF_STEP4 returns the handle to a new LUTCONF_STEP4 or the handle to
%      the existing singleton*.
%
%      LUTCONF_STEP4('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LUTCONF_STEP4.M with the given input arguments.
%
%      LUTCONF_STEP4('Property','Value',...) creates a new LUTCONF_STEP4 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LUTconf_step4_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LUTconf_step4_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LUTconf_step4

% Last Modified by GUIDE v2.5 05-May-2017 13:40:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LUTconf_step4_OpeningFcn, ...
                   'gui_OutputFcn',  @LUTconf_step4_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LUTconf_step4 is made visible.
function LUTconf_step4_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LUTconf_step4 (see VARARGIN)

% Choose default command line output for LUTconf_step4
handles.output = hObject;

% Load LUT configuration parameters if selected:
h = findobj('Tag','AtmLutGen');
handlesAtmLutGen = guidata(h);

stepsdata = get(handles.output,'UserData');
AdvConf   = stepsdata.AdvConf;
set(handles.listbox1,'string',AdvConf.ParamNames,'userdata',AdvConf.data,'value',[],'min',0,'max',2)
set(handles.listbox2,'enable','off','string','Select advance parameter first','value',[],'min',0,'max',2)

[X,map] = imread(['..',filesep,'Others',filesep,'figs',filesep,'info_icon.png']);
alpha = ones(size(X)); alpha(X==0)=0;
info = cell(1,1);
i=1;
axes(handles.(['info',num2str(i)]))
info{i} = imshow(ind2rgb(X,map));
set(handles.(['info',num2str(i)]),'userdata',['info',num2str(i)])
set(info{i}, 'AlphaData', alpha);
set(info{i},'ButtonDownFcn',@(hObject,eventdata)LUTconf_step4('ImageClickCallback',hObject,eventdata,guidata(hObject)));


set(handles.uitable1,'data',{})

LUTconffile = get(handlesAtmLutGen.loadlut,'UserData');
if ~isempty(LUTconffile)
    % User has selected to load LUT configuration file, then read file and
    % update handles
    AdvConf = read_LUTconfig(LUTconffile,'AdvConf');
    fn = fieldnames(AdvConf);
    if ~strcmp(fn{1},'AdvConf')
        for i=1:numel(fn)
            table(i,:) = {false,AdvConf.(fn{i}).name,AdvConf.(fn{i}).description,AdvConf.(fn{i}).values};
        end
        set(handles.uitable1,'data',table)
    end
else
    % User has opened Step 4 from Step 3. In this case the Advance 
    % parameters table can be read from the stepsdata (output User Data):
    set(handles.uitable1,'data',AdvConf.table)
end


% Modify foreground color of Previous and Next buttons (pushbutton3 and pushbutton4):
button = {'pushbutton3','pushbutton4'};
for i=1:numel(button)
    units = get(handles.(button{i}),'units'); set(handles.(button{i}),'units','pixels')
    cdark = get(handles.(button{i}),'foregroundcolor'); clight = 1.8*cdark;
    aux = uint16(get(handles.(button{i}),'position')); set(handles.(button{i}),'units',units)
    x = zeros(aux(4),aux(3),3);
    sz1 = size(x(1:round(aux(4)/2),:,:)); sz2 = size(x(round(aux(4)/2)+1:end,:,:));
    x(1:round(aux(4)/2),:,:) = permute(repmat(clight',[1,sz1(1:2)]),[2 3 1]);
    x(round(aux(4)/2)+1:end,:,:) = permute(repmat(cdark',[1,sz2(1:2)]),[2 3 1]);
    x(1:end,1,:)=0.94; x(1:end,size(x,2),:)=0.94; x(1,1:end,:)=0.94; x(size(x,1),1:end,:)=0.94;
    x(3:end-2,2,:)=0.7; x(4:end-2,size(x,2)-1,:)=0.5; x(2,3:end-2,:)=0.7; x(size(x,1)-1,4:end-2,:)=0.5;
    x(2,2,:)=0.85; x(size(x,1)-1,size(x,2)-1,:)=0.85; x(2,size(x,2)-1,:)=0.85; x(size(x,1)-1,2,:)=0.85;
    x(3,size(x,2)-1,:)=0.85; x(size(x,1)-1,3,:)=0.85;
    x(3,3,:)=0.65; x(size(x,1)-2,size(x,2)-2,:)=0.7; x(3,size(x,2)-2,:)=0.65; x(size(x,1)-2,3,:)=0.65; 
    set(handles.(button{i}),'cdata',x,'userdata',{x,cdark});
    set(handles.(button{i}),'foregroundcolor',[1 1 1])
end

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes LUTconf_step4 wait for user response (see UIRESUME)
% uiwait(handles.LUTconf_step4);


% --- Outputs from this function are returned to the command line.
function varargout = LUTconf_step4_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1
value = get(handles.listbox1,'value');
set(handles.listbox1,'value',value(1),'min',0,'max',1)

if get(handles.listbox1,'value')~=0 && ~isempty(get(handles.listbox1,'value'))
    aux = get(handles.listbox1,'string');
    data = get(handles.listbox1,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox1,'value');     data = data.(fn{opt});
    if ~isempty(data)
        options  = data.desc(2:end-1);  op_modes = str2cell(options);
        set(handles.listbox2,'string',op_modes,'enable','on')
        uicontrol(handles.listbox2)
    else
        stepsdata = get(handles.output,'UserData');
        GenConf   = stepsdata.GenConf;
        msg = ['No advanced parameters have been defined for the ',GenConf.RTMname,' RTM. ',...
               'Click Next button to proceed with LUT generation'];
        msgbox(msg,'Input parameters error','error')
        set(handles.listbox2,'string','Select advance parameter first','value',[],'enable','off','min',0,'max',2)
    end
% else
%     set(handles.popupmenu2,'string','Select parameter...','value',1)
end

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2


% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

if get(handles.listbox1,'value')~=0 && get(handles.listbox2,'value')~=0
    data = get(handles.listbox1,'userdata');  fn   = fieldnames(data);
    opt  = get(handles.listbox1,'value');     data = data.(fn{opt});
    fn   = fieldnames(data);
    opt  = get(handles.listbox2,'value');
    
    ID = data.name; desc = data.description;
    
    aux = str2num(data.values);
    % Check if discrete options are numeric or string:
    if ~isempty(aux),   values = aux(opt);
    else   aux = str2cell(data.values(2:end-1));   values = aux{opt};
    end
    values = strjoin(values);
    
    table = get(handles.uitable1,'data');
    if ~isempty(table)
        ids = table(:,2);   idx = find(cellfun(cellfind(ID),ids));
        if ~isempty(idx)
            table(idx,:) = {false,ID,desc,values};
            msgbox(['The value of the parameter ',ID,' has been updated.'],'Parameter updated','warn')
        else
            table(end+1,:) = {false,ID,desc,values};
        end 
    else
        table = {false,ID,desc,values};
    end
    set(handles.uitable1,'data',table)
    uicontrol(handles.listbox1)
else
    msgbox('Select a key input parameter to add to the LUT','Error adding parameter','error')
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
table = get(handles.uitable1,'data');
if ~isempty(table)
    select = table(:,1);    idx    = cell2mat(select);
    ids    = table(:,2);
    if sum(idx)==0
        msgbox('Select parameters to remove from LUT.','Remove parameters','warn')
    else
        str = strjoin(ids(idx));
        msgbox(['Parameter(s) ',str,' have been removed from LUT.'],'Remove parameters','warn')
        table(idx,:) = [];
        set(handles.uitable1,'data',table)
    end
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
guidata(hObject, handles);

try
    h = findobj('Tag','LUTconf_step3');
    if ~isempty(h)
        handlesStep3 = guidata(h);
        set(handlesStep3.LUTconf_step3,'visible','on')
    end
    set(handles.LUTconf_step4,'visible','off')

    % Before moving back to Step 3 we update the output UserData including the
    % table from uitable1. The structure stepsdata will contain the GenConf
    % from the step 1, the uitable1 data from step 2, the SpeConf from step 3
    % and the AdvConf from step 4
    stepsdata = get(handles.output,'UserData');
    stepsdata.AdvConf.table = get(handles.uitable1,'data');
    h = findobj('Tag','AtmLutGen');
    handlesAtmLutGen = guidata(h);
    updatesubblock('LUTconf_step3',handlesAtmLutGen,stepsdata);
    % LUTconf_step3('UserData',stepsdata)
    % close(handles.LUTconf_step4)
catch me
    msgbox(me.message,'Error','error')
end    


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
filename  = GenConf.filename;

try
    table = get(handles.uitable1,'data');
    if ~isempty(table) % If user has input data for the LUT
        % Save AdvConf in LUT configuration file:
        [~,name,~] = fileparts(filename);
        [~,~,data] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],GenConf.RTMname);
        data = data.AdvParam;
        for i=1:size(table,1)
            data1 = data.(table{i,2});
            AdvConf.(table{i,2}).name        = table{i,2};
            AdvConf.(table{i,2}).description = table{i,3};
            AdvConf.(table{i,2}).values      = table{i,4};
            AdvConf.(table{i,2}).datatype    = data1.datatype;
        end

        update_LUTconfig([filename,'.xml'],'AdvConf',AdvConf)

%         msg = ['LUT advanced configuration stored in ',name,'.xml file'];
%         h = msgbox(msg,'Advanced configuration updated','warn');
%         uiwait(h)

        set(handles.output,'UserData',AdvConf)
        guidata(hObject, handles);
    else % If table is empty
        h = msgbox('No input advanced configuration have been defined. LUT will be generated with default advanced configuration',...
                   'LUT input advanced configuration','warn'); uiwait(h)
        update_LUTconfig([filename,'.xml'],'AdvConf',[])   
    end
catch me
    msgbox(me.message,'Error','error')
end

choice = questdlg('Do you want to start running the atmospheric RTM?','Run RTM','Yes','No','Yes');
% Handle response
if strcmp(choice,'Yes')
    % Move to LUT creation:
    LUTGen_inputs(['..',filesep,'Conf',filesep,'RTMconf.xml'],[filename,'.xml'])
    % Close LUTconf_steps:
    close(handles.LUTconf_step4)
end

% --- Executes on key press with focus on LUTconf_step4 or any of its controls.
function LUTconf_step4_WindowKeyPressFcn(hObject, eventdata, handles)
% hObject    handle to LUTconf_step4 (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

keyPressed = eventdata.Key;
switch keyPressed
    case 'return'
        % set focus to the button
        uicontrol(handles.pushbutton1);
        % call the callback
        pushbutton1_Callback(handles.pushbutton1,[],handles);
    case 'n'
         % set focus to the button
         uicontrol(handles.pushbutton4);
         % call the callback
         pushbutton4_Callback(handles.pushbutton4,[],handles);
    case 'p'
         % set focus to the button
         uicontrol(handles.pushbutton3);
         % call the callback
         pushbutton3_Callback(handles.pushbutton3,[],handles);
end


% --- Executes on mouse press over figure background.
function ImageClickCallback(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

stepsdata = get(handles.output,'UserData');
GenConf   = stepsdata.GenConf;
if strcmp(GenConf.RTMname,'MODTRAN5')
    aux = 'modtran5';
elseif strcmp(GenConf.RTMname,'MODTRAN6')
    aux = 'modtran6';
elseif strcmp(GenConf.RTMname,'sixSV')
    aux = '6sv';
end

web(['..',filesep,'Help',filesep,'html',filesep,'third_party_sw',filesep,'',aux,'vars',filesep,'',aux,'-variables-advanced.html'],'-browser')
