function plotprofile(ZM,profiles,names,atmnames)

% Create gui for plotting profiles:
f = figure('Visible','off','Position',[360,500,450,285]);
hpopup = uicontrol('Style','popupmenu',...
                   'String',names,...
                   'Value',numel(names),...
                   'Position',[60,250,100,25],...
                   'Callback',{@pop_up_menu});
ha = axes('Units','pixels','Position',[60,50,360,195]);


currentProfile = squeeze(profiles(get(hpopup,'value'),:,:));
plot(currentProfile,ZM), grid on
ha.YLabel.String = 'Altitude (km)';
ha.XLabel.String = names{get(hpopup,'value')};
ylim([min(ZM),max(ZM)])
legend(atmnames)
    
f.Visible = 'on';
% Figure behaviour: 
    function pop_up_menu(source,eventdata) 
        % Determine the selected data set.
        val = source.Value;
        % Set current data to the selected data set.
        currentProfile = squeeze(profiles(val,:,:));
        plot(currentProfile,ZM), grid on
        ha.YLabel.String = 'Altitude (km)';
        ha.XLabel.String = names{val};
        ylim([min(ZM),max(ZM)])
        legend(atmnames)
    end
end