function outcell = str2cell(instr)
%   OUTPUT_CELL = STR2CELL(INPUT_STRING) converts the input string of N
%   comma-separated elements into an output cell of N elements
%
%   STR2CELL will return the INPUT_STRING when there are no commas.
%
%   Examples
%       instr = 'text1,text2';
%       strfind(instr)    returns a cell with two elements: 'text1'  'text2' 
%       instr = 'text1';
%       strfind(instr)    returns the same input string 'text1' 
%
%   See also: STRFIND.

idx = strfind(instr,',');
if ~isempty(idx)
    outcell{1} = instr(1:idx(1)-1);
    if length(idx)>1
        for i=1:length(idx)-1
            outcell{i+1} = instr(idx(i)+1:idx(i+1)-1);
        end
    end
    outcell{end+1} = instr(idx(end)+1:end);
else
    outcell = instr;
end