function varargout = OPACconf(varargin)
% OPACCONF MATLAB code for OPACconf.fig
%      OPACCONF, by itself, creates a new OPACCONF or raises the existing
%      singleton*.
%
%      H = OPACCONF returns the handle to a new OPACCONF or the handle to
%      the existing singleton*.
%
%      OPACCONF('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in OPACCONF.M with the given input arguments.
%
%      OPACCONF('Property','Value',...) creates a new OPACCONF or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before OPACconf_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to OPACconf_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help OPACconf

% Last Modified by GUIDE v2.5 06-May-2017 20:24:15

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @OPACconf_OpeningFcn, ...
                   'gui_OutputFcn',  @OPACconf_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before OPACconf is made visible.
function OPACconf_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to OPACconf (see VARARGIN)

% Choose default command line output for OPACconf
handles.output = hObject;

[OPACconf,Groupnames,~] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);


set(handles.text2,'string',[OPACconf.name,' source file:'])
set(handles.edit1,'string',OPACconf.filepath)
set(handles.edit2,'string',OPACconf.version)

set(handles.popupmenu2,'string',['Select group...',Groupnames])
set(handles.popupmenu2,'value',1)
set(handles.uitable1,'data',[])


colname = {'','Name','Description','Type','Disc./cont.','Static/Dynamic','Default','Values/Min-Max','Options','Units','Visibility'};
colformat = {'logical','char','char',{'STRING','INTEGER','FLOAT'},{'continuous','discrete'},{'static','dynamic'},'char','char','char','char',{'Hidden','Basic','Medium','Advanced'}};
[colwidth{1:length(colname)}] = deal('auto');

set(handles.uitable1,'columnname',colname)
set(handles.uitable1,'columnformat',colformat)
set(handles.uitable1,'ColumnEditable',true(size(colname)))
set(handles.uitable1,'ColumnWidth',colwidth)


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes OPACconf wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = OPACconf_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2

[OPACconf,Groupnames,paramdata] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);

idx1 = get(hObject,'Value');
aux = get(handles.uitable1,'columnname'); Ncols = numel(aux);

if idx1~=1
    fn = fieldnames(paramdata); aux1 = fn{idx1-1};
    if ~isempty(paramdata.(aux1))
        % Update Row and Column names:
        VarName = fieldnames(paramdata.(aux1));
        
        % Update uitable1 Data:
        data = cell(length(VarName),Ncols);
        for i = 1:length(VarName)
            aux = paramdata.(aux1).(VarName{i});
            data(i,:) = {false,aux.name,aux.description,aux.datatype,aux.paramtype,aux.static,aux.default,aux.values,aux.desc,aux.unit,aux.visibility};
        end

        set(handles.uitable1,'Data',data)
    else
        msg = {[OPACconf(idx-1).name,' has no defined ',Groupnames{idx1-1},' parameters.'],...
                'Press + to add a new parameter first.'};
        msgbox(msg,'No parameters found','warn')
        set(handles.uitable1,'data',[])
    end
else
    set(handles.uitable1,'data',[])
end


% columnformat = {'string','string','logical',{'Fixed' 'Adjustable'}};

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.uitable1,'data');
newdata = {false,'','','FLOAT','continuous','static','','','','',''};
data = [data;newdata];

set(handles.uitable1,'data',data);




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.uitable1,'data');
select = cell2mat(data(:,1));
if any(select,true)
    newdata = data(~select,:);
    set(handles.uitable1,'data',newdata);
else
    msgbox('Select first parameters to remove','','warn')
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
