function varargout = Preferences(varargin)
% PREFERENCES MATLAB code for Preferences.fig
%      PREFERENCES, by itself, creates a new PREFERENCES or raises the existing
%      singleton*.
%
%      H = PREFERENCES returns the handle to a new PREFERENCES or the handle to
%      the existing singleton*.
%
%      PREFERENCES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PREFERENCES.M with the given input arguments.
%
%      PREFERENCES('Property','Value',...) creates a new PREFERENCES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Preferences_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Preferences_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Preferences

% Last Modified by GUIDE v2.5 24-Sep-2017 21:50:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Preferences_OpeningFcn, ...
                   'gui_OutputFcn',  @Preferences_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Preferences is made visible.
function Preferences_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Preferences (see VARARGIN)

% Choose default command line output for Preferences
handles.output = hObject;

idx = get(handles.listbox1,'value');
opt = get(handles.listbox1,'string');
set(handles.uipanel3,'title',[opt{idx},' configuration:'])
if idx==1 % RTM configuration
    % Read handles from subfigure:
    handles=updatesubblock('RTMconf',hObject,handles);
elseif idx==2 % OPAC configuration
    handles=updatesubblock('OPACconf',hObject,handles);
elseif idx==3 % Default key param. configuration
    % Me falta borrar la previa subgui
    handles=updatesubblock('Paramconf',hObject,handles);
elseif idx==4 % Default sensor configuration
    % Me falta borrar la previa subgui
    handles=updatesubblock('Sensorconf',hObject,handles);
elseif idx==5 % Other parameters
    handles=updatesubblock('Otherconf',hObject,handles);
end

% Modify foreground color of Apply_and_Close and Apply buttons (okbutton and applybutton):
button = {'okbutton','applybutton','cancelbutton'};
for i=1:numel(button)
    units = get(handles.(button{i}),'units'); set(handles.(button{i}),'units','pixels')
    cdark = get(handles.(button{i}),'foregroundcolor'); clight = 1.8*cdark;
    aux = uint16(get(handles.(button{i}),'position')); set(handles.(button{i}),'units',units)
    x = 0.94*ones(aux(4),aux(3),3);
	sz1 = size(x(2:round(aux(4)/2),2:end-1,:)); sz2 = size(x(round(aux(4)/2)+1:end-1,2:end-1,:));
    x(2:round(aux(4)/2),2:end-1,:) = permute(repmat(clight',[1,sz1(1:2)]),[2 3 1]);
    x(round(aux(4)/2)+1:end-1,2:end-1,:) = permute(repmat(cdark',[1,sz2(1:2)]),[2 3 1]);
    x(3:end-2,2,:)=0.7; x(4:end-2,size(x,2)-1,:)=0.5; x(2,3:end-2,:)=0.7; x(size(x,1)-1,4:end-2,:)=0.5;
    x(2,2,:)=0.85; x(size(x,1)-1,size(x,2)-1,:)=0.85; x(2,size(x,2)-1,:)=0.85; x(size(x,1)-1,2,:)=0.85;
    x(3,size(x,2)-1,:)=0.85; x(size(x,1)-1,3,:)=0.85;
    x(3,3,:)=0.65; x(size(x,1)-2,size(x,2)-2,:)=0.7; x(3,size(x,2)-2,:)=0.65; x(size(x,1)-2,3,:)=0.65; 
    set(handles.(button{i}),'cdata',x,'userdata',{x,cdark});
    set(handles.(button{i}),'foregroundcolor',[1 1 1])
end

axes(handles.info1)
[X,map] = imread(['..',filesep,'Others',filesep,'figs',filesep,'info_icon.png']);
alpha = ones(size(X)); alpha(X==0)=0; 
imageHandle = imshow(ind2rgb(X,map));
set(imageHandle, 'AlphaData', alpha);
set(imageHandle,'ButtonDownFcn',@(hObject,eventdata)Preferences('ImageClickCallback',hObject,eventdata,guidata(hObject)));


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Preferences wait for user response (see UIRESUME)
% uiwait(handles.Preferences);


% --- Outputs from this function are returned to the command line.
function varargout = Preferences_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

idx = get(handles.listbox1,'value');
opt = get(handles.listbox1,'string');
set(handles.uipanel3,'title',[opt{idx},' configuration:'])

if idx==1 % RTM configuration
    updatesubblock('RTMconf',hObject,handles);
elseif idx==2 % OPAC configuration
    handles=updatesubblock('OPACconf',hObject,handles);
elseif idx==3 % Default key param. configuration
    updatesubblock('Paramconf',hObject,handles);
elseif idx==4 % Default sensor configuration
    updatesubblock('Sensorconf',hObject,handles);
elseif idx==5 % Other parameters
    updatesubblock('Otherconf',hObject,handles);
end


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns calleds

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in applybutton.
function applybutton_Callback(hObject, eventdata, handles)
% hObject    handle to applybutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

idx = get(handles.listbox1,'value');

if idx==1 % RTM configuration
    rtmconfFilename = ['..',filesep,'Conf',filesep,'RTMconf.xml'];
    [RTMconf]   = read_RTMconfig(rtmconfFilename,[]);
    
    opt         = get(handles.popupmenu1,'value');
    newRTMconf.filepath = get(handles.edit1,'string');
    newRTMconf.op_mode  = get(handles.listbox3,'string');
    newRTMconf.version  = get(handles.edit2,'string');
    
    maxopt = numel(get(handles.popupmenu1,'string'));

    if opt~=1 && opt~=maxopt
        update_RTMconfig(rtmconfFilename,RTMconf(opt-1).name,newRTMconf,[],[],[],[])
        msg = ['The ',RTMconf(opt-1).name,' file path, operation mode and version have been updated.'];
        msgh = msgbox(msg,[RTMconf(opt-1).name,' updated RTM configuration'],'warn');
    elseif opt==maxopt
        newRTMname = get(handles.edit3,'string');
        if isempty(newRTMname)
            msgbox('Introduce first a new RTM name','Add RTM - warning','warn')
            set(handles.edit3,'backgroundcolor',[1 1 0])
        else
            update_RTMconfig(rtmconfFilename,[],[],'add',newRTMname,[],[])
            [RTMconf] = read_RTMconfig(rtmconfFilename,[]);
            set(handles.popupmenu1,'string',['Select RTM...',{RTMconf(:).name,'Add new RTM'}],...
                                   'value',length(RTMconf)+1)
            update_RTMconfig(rtmconfFilename,RTMconf(opt-1).name,newRTMconf,[],[],[],[])
            set(handles.text2,'string',[RTMconf(length(RTMconf)).name,' executable source file:'])
            set(handles.edit3,'backgroundcolor',[1 1 1],'visible','off','enable','off')
            set(handles.text6,'visible','off')
            msg = ['The ',RTMconf(opt-1).name,' RTM has been added.'];
            msgh = msgbox(msg,[RTMconf(opt-1).name,' updated RTM configuration'],'warn');
        end
    elseif opt==1
        msgbox('Select first a (new) RTM to update (create).','Update RTM error message','error')
    end
elseif idx==2 % OPAC configuration
    opacconfFilename = ['..',filesep,'Conf',filesep,'OPACconf.xml'];
    [OPACconf,Groupnames,datos]   = read_OPACconfig(opacconfFilename);
    attrnames = {'','name','description','datatype','paramtype','static','default','values','desc','unit','visibility'};
    newParam  = get(handles.uitable1,'data');
    opt2      = get(handles.popupmenu2,'value');
    paramaux  = get(handles.popupmenu2,'string');
    
    newOPACconf.filepath = get(handles.edit1,'string');
    newOPACconf.version  = get(handles.edit2,'string');
    
    if opt2~=1
        ParamFamily = {'MainParam','PARTYPE'};
        update_OPACconfig(opacconfFilename,newOPACconf,ParamFamily{opt2-1},[attrnames;newParam])
        msg = [OPACconf.name,' ',paramaux{opt2},' parameters have been updated.'];
        msgh = msgbox(msg,[OPACconf.name,' updated parameters'],'warn');
    end
elseif idx==3 % Parameters configuration
    rtmconfFilename = ['..',filesep,'Conf',filesep,'RTMconf.xml'];
    [RTMconf]   = read_RTMconfig(rtmconfFilename,[]);
    
    attrnames = {'','name','description','datatype','paramtype','static','default','values','desc','unit','visibility'};
    newParam  = get(handles.uitable1,'data');
    opt1      = get(handles.popupmenu1,'value');
    opt2      = get(handles.popupmenu2,'value');
    paramaux  = get(handles.popupmenu2,'string');
    
    if opt1~=1 && opt2~=1
        ParamFamily = {'AtmParam','AerParam','GeoParam','SpeParam','AdvParam'};
        update_RTMconfig(rtmconfFilename,RTMconf(opt1-1).name,[],[],[],ParamFamily{opt2-1},[attrnames;newParam])
        msg = [RTMconf(opt1-1).name,' ',paramaux{opt2},' parameters have been updated.'];
        msgh = msgbox(msg,[RTMconf(opt1-1).name,' updated parameters'],'warn');
    end
elseif idx==4 % Sensor configuration
    sensorconfFilename = ['..',filesep,'Conf',filesep,'Sensorconf.xml'];
    opt    = get(handles.popupmenu1,'value');
    maxopt = numel(get(handles.popupmenu1,'string'));
    
    spectral_mode = {get(handles.radiobutton1,'string'),get(handles.radiobutton2,'string')};
    value = get(handles.radiobutton1,'value') + 2*get(handles.radiobutton2,'value');
    newSensorconf.spectral_mode = spectral_mode{value};
    
    % Remove rows in uitable1 that are not complete:
    table  = get(handles.uitable1,'data'); ind = [];
    if value==1 % Multispectral (needs at least barycentrer and ISRF)
        for i=1:size(table,1)
            if ~isempty(cell2mat(table(i,2))) && ~isempty(cell2mat(table(i,3)))
                ind = [ind,i];
            end
        end
    elseif value==2 % Hyperspectral (needs at least min/max wavelengths and FWHM)
        for i=1:size(table,1)
            if ~isempty(cell2mat(table(i,2))) && ~isempty(cell2mat(table(i,3))) && ~isempty(cell2mat(table(i,4)))
                ind = [ind,i];
            end
        end
    end
    newSensorconf.bands = table(ind,:);

    if opt~=1 && opt~=maxopt
        [Sensorconf]   = read_Sensorconfig(sensorconfFilename);
        update_Sensorconfig(sensorconfFilename,Sensorconf(opt-1).name,newSensorconf,[])
        msg = ['The ',Sensorconf(opt-1).name,' sensor configuration has been updated.'];
        msgh = msgbox(msg,[Sensorconf(opt-1).name,' updated sensor configuration'],'warn');
    elseif opt==maxopt
        newsensorname = get(handles.edit1,'string');
        if isempty(newsensorname)
            msgbox('Introduce first a new sensor name','Add sensor - warning','warn')
            set(handles.edit1,'backgroundcolor',[1 1 0])
        else
            update_Sensorconfig(sensorconfFilename,newsensorname,newSensorconf,[])
            [Sensorconf]   = read_Sensorconfig(sensorconfFilename);
            set(handles.popupmenu1,'string',['Select sensor...',{Sensorconf(:).name,'Add new sensor'}],...
                                   'value',length(Sensorconf)+1)
            set(handles.edit1,'backgroundcolor',[1 1 1],'visible','off','enable','off')
            set(handles.text2,'visible','off')
            msg = [Sensorconf(opt-1).name,' sensor has been added.'];
            msgh = msgbox(msg,[Sensorconf(opt-1).name,' updated sensor configuration'],'warn');
        end
    elseif opt==1
        msgbox('Select first a (new) RTM to update (create).','Update RTM error message','error')
    end
elseif idx==5 % Other parameters
    aux.parallel      = num2str(get(handles.popupmenu1,'value'));
    aux.defaultfolder = get(handles.edit1,'string'); 
    update_Otherconfig(['..',filesep,'Conf',filesep,'Otherconf.xml'],aux)
    msg = 'Additional software configuration parameters have been updated.';
    msgh = msgbox(msg,'Updated additional sw parameters','warn');
end
uiwait(msgh)

% --- Executes on button press in okbutton.
function okbutton_Callback(hObject, eventdata, handles)
% hObject    handle to okbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
applybutton_Callback(hObject, eventdata, handles)
% try % Try closing figure handle
%     close(handles.Preferences), clear handles
% catch % Otherwise "Preferences" is within AtmLutGen figure
    fn = fieldnames(handles);
    cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
    logical_cells = cellfun(cellfind('subuipanel1'),fn);
    aux = cellfun(cellfind('subgui'),fn);

    for i=find(logical_cells)+1:find(aux)-1
        try delete(handles.(fn{i})); end
        handles=rmfield(handles,(fn{i}));
    end
    if find(logical_cells)>0
        handles=rmfield(handles,'subuipanel1');
        try handles=rmfield(handles,'subgui'); end
    end
    figure_handle = findobj('Tag','AtmLutGen');
    guidata(figure_handle, handles);
% end


% --- Executes on button press in cancelbutton.
function cancelbutton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% try % Try closing figure handle
%     close(handles.Preferences), clear handles
% catch % Otherwise "Preferences" is within AtmLutGen figure
    fn = fieldnames(handles);
    cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
    logical_cells = cellfun(cellfind('subuipanel1'),fn);
    aux = cellfun(cellfind('subgui'),fn);

    for i=find(logical_cells)+1:find(aux)-1
        try delete(handles.(fn{i})); end
        handles=rmfield(handles,(fn{i}));
    end
    if find(logical_cells)>0
        handles=rmfield(handles,'subuipanel1');
        try handles=rmfield(handles,'subgui'); end
    end
    figure_handle = findobj('Tag','AtmLutGen');
    guidata(figure_handle, handles);
% end

% --- Updates the sub-handle in uipanel3
function handles=updatesubblock(confsection,hObject,handles)
% Deletes previous sub-handle
fn = fieldnames(handles);
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));
logical_cells = cellfun(cellfind('sub'),fn);
aux = cellfun(cellfind('subfigure1'),fn);


for i=find(logical_cells)+1:find(aux)-1
    try delete(handles.(fn{i})); end
    handles=rmfield(handles,(fn{i}));
end
if find(logical_cells)>0
    handles=rmfield(handles,'sub');
    handles=rmfield(handles,'subfigure1');
end

figure_handle = eval([confsection,'(''Visible'',''off'')']);
handles.sub   = get(figure_handle,'children');
subhandles    = guidata(figure_handle);

% Renames subhandle.Preferences to subfigure1:
subhandles.subfigure1 = subhandles.figure1;
subhandles = rmfield(subhandles,'figure1');

% Read subfigure handles and associates them to main figure handle
fn = fieldnames(subhandles);
units0 = get(subhandles.subfigure1,'units');
units1 = get(handles.uipanel3,'units');
set(subhandles.subfigure1,'units','characters');
set(handles.uipanel3,'units','characters');
refpos0 = get(subhandles.subfigure1,'position'); % reference position
refpos1 = get(handles.uipanel3,'position');   % reference position
refpos1(2) = refpos1(2)+refpos1(4)-refpos0(4)-1; refpos1(4)=refpos0(4)+1;
set(handles.uipanel3,'position',refpos1)
set(subhandles.subfigure1,'units',units0);
set(handles.uipanel3,'units',units1);


for i=1:length(fn)
    handles.(fn{i}) = subhandles.(fn{i});
end
set(handles.sub,'Parent',handles.uipanel3);

delete(figure_handle);
try
    aux = handles.subgui;
    handles=rmfield(handles,'subgui');
    handles.subgui = aux;
end
guidata(hObject, handles);
    
% --- Executes on mouse press over figure background.
function ImageClickCallback(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axesHandle  = get(hObject,'Parent');
tag = get(axesHandle,'tag'); 
opt = get(handles.listbox1,'value');
rootname = ['..',filesep,'Help',filesep,'html',filesep,'preferences',filesep];
if opt==1
    web([rootname,'rtmconfig.html'],'-browser')
elseif opt==2
    web([rootname,'opacconfig.html'],'-browser')
elseif opt==3
    web([rootname,'varsconfig.html'],'-browser')
elseif opt==4
    web([rootname,'sensorconfig.html'],'-browser')
elseif opt==5
    web([rootname,'otherconfig.html'],'-browser')
end
