function varargout = RTMconf(varargin)
% RTMCONF MATLAB code for RTMconf.fig
%      RTMCONF, by itself, creates a new RTMCONF or raises the existing
%      singleton*.
%
%      H = RTMCONF returns the handle to a new RTMCONF or the handle to
%      the existing singleton*.
%
%      RTMCONF('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RTMCONF.M with the given input arguments.
%
%      RTMCONF('Property','Value',...) creates a new RTMCONF or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RTMconf_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RTMconf_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RTMconf

% Last Modified by GUIDE v2.5 06-May-2017 20:25:14

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RTMconf_OpeningFcn, ...
                   'gui_OutputFcn',  @RTMconf_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before RTMconf is made visible.
function RTMconf_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RTMconf (see VARARGIN)

% Choose default command line output for RTMconf
handles.output = hObject;

[RTMconf] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],[]);

set(handles.popupmenu1,'string',['Select RTM...',{RTMconf(:).name,'Add new RTM'}])
set(handles.edit3,'visible','off','enable','off')
set(handles.text6,'visible','off')

set(handles.listbox2,'string',{'Transfer Functions','At-sensor radiance','Transmittance'})
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes RTMconf wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = RTMconf_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

[RTMconf] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],[]);
opt = get(handles.popupmenu1,'value');
maxopt = numel(get(handles.popupmenu1,'string'));

set(handles.text2,'string','RTM executable source file:')
set(handles.edit1,'string','')
set(handles.edit2,'string',[])
set(handles.listbox3,'string',[])

vis = 'off';
if opt~=1 && opt~=maxopt
    set(handles.text2,'string',[RTMconf(opt-1).name,' executable source file:'])
    set(handles.edit1,'string',RTMconf(opt-1).filepath)
    set(handles.edit2,'string',RTMconf(opt-1).version)
    
    op_mode  = RTMconf(opt-1).op_mode; op_mode = op_mode(2:end-1);
    idx = findstr(op_mode,',');
    if ~isempty(idx)
        op_modes{1} = op_mode(1:idx(1)-1);
        if length(idx)>1
            for i=1:length(idx)-1
                op_modes{i+1} = op_mode(idx(i)+1:idx(i+1)-1);
            end
        end
        op_modes{end+1} = op_mode(idx(end)+1:end);
    else
        op_modes = op_mode;
    end
    set(handles.listbox3,'string',op_modes)
elseif opt==maxopt
    vis = 'on';
end
set(handles.edit3,'visible',vis,'enable',vis,'string',[])
set(handles.text6,'visible',vis)

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[RTMconf] = read_RTMconfig(['..',filesep,'Conf',filesep,'RTMconf.xml'],[]);
opt = get(handles.popupmenu1,'value');
[FileName,PathName] = uigetfile('*.*',['Select the ',RTMconf(opt-1).name,' source code file']);
set(handles.edit1,'string',fullfile(PathName,FileName))
% Ahora tengo que actualizar RTMconf.xml con el PathName/FileName


% --- Executes on button press in removebutton.
function removebutton_Callback(hObject, eventdata, handles)
% hObject    handle to removebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

rtmconfFilename = ['..',filesep,'Conf',filesep,'RTMconf.xml'];
[RTMconf] = read_RTMconfig(rtmconfFilename,[]);
opt = get(handles.popupmenu1,'value');
maxopt = numel(get(handles.popupmenu1,'string'));

if opt==1 || opt==maxopt
    msgbox('Select first a RTM to remove','Remove RTM - warning','warn')
else
    choice = questdlg(['Do you want to remove ',RTMconf(opt-1).name,'?'],['Remove ',RTMconf(opt-1).name],'Yes','No','No');
    if strcmp(choice,'Yes')
        update_RTMconfig(rtmconfFilename,RTMconf(opt-1).name,[],'remove',[],[],[])
        msg = {[RTMconf(opt-1).name,' has been removed.']};
        msgbox(msg,['Remove ',RTMconf(opt-1).name],'warn')
        [RTMconf] = read_RTMconfig(rtmconfFilename,[]);
        set(handles.popupmenu1,'string',['Select RTM...',{RTMconf(:).name,'Add new RTM'}])
        set(handles.popupmenu1,'value',1)
        set(handles.text2,'string','RTM executable source file:')
        set(handles.edit1,'string',[])
        set(handles.listbox3,'string',[])
        set(handles.edit2,'string',[])
    end
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2


% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox3.
function listbox3_Callback(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox3


% --- Executes during object creation, after setting all properties.
function listbox3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addOpbutton.
function addOpbutton_Callback(hObject, eventdata, handles)
% hObject    handle to addOpbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

op_modes_values = get(handles.listbox2,'value');
op_modes        = get(handles.listbox2,'string');
op_modes_imple  = get(handles.listbox3,'string');
if isempty(op_modes_imple)  op_modes_imple = {};    end

for i = 1:length(op_modes_values)
    add_op_mode    = op_modes{op_modes_values(i)};
    if iscell(op_modes_imple)
        logical_cells = cellfun(cellfind(add_op_mode),op_modes_imple);
    else
        logical_cells = strcmp(add_op_mode,op_modes_imple);
    end
    if sum(logical_cells)==0
        if iscell(op_modes_imple)
            op_modes_imple{end+1} = add_op_mode;
        else
            aux = op_modes_imple; clear op_modes_imple
            op_modes_imple{1} = aux;
            op_modes_imple{2} = add_op_mode;
        end
        set(handles.listbox3,'string',op_modes_imple)
    end
end


% --- Executes on button press in removeOpbutton.
function removeOpbutton_Callback(hObject, eventdata, handles)
% hObject    handle to removeOpbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
op_mode         = get(handles.listbox3,'value');
op_modes_imple  = get(handles.listbox3,'string');

if iscell(op_modes_imple)
    set(handles.listbox3,'value',1)
    op_modes_imple(op_mode) = [];
    set(handles.listbox3,'string',op_modes_imple)
else
    set(handles.listbox3,'string',[])
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
