function varargout = Sensorconf(varargin)
% SENSORCONF MATLAB code for Sensorconf.fig
%      SENSORCONF, by itself, creates a new SENSORCONF or raises the existing
%      singleton*.
%
%      H = SENSORCONF returns the handle to a new SENSORCONF or the handle to
%      the existing singleton*.
%
%      SENSORCONF('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SENSORCONF.M with the given input arguments.
%
%      SENSORCONF('Property','Value',...) creates a new SENSORCONF or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Sensorconf_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Sensorconf_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Sensorconf

% Last Modified by GUIDE v2.5 03-Feb-2018 13:07:53

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Sensorconf_OpeningFcn, ...
                   'gui_OutputFcn',  @Sensorconf_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Sensorconf is made visible.
function Sensorconf_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Sensorconf (see VARARGIN)

% Choose default command line output for Sensorconf
handles.output = hObject;

[Sensorconf]   = read_Sensorconfig(['..',filesep,'Conf',filesep,'Sensorconf.xml']);

set(handles.uitable1,'data',[],'ColumnEditable',[true true true true true],...
    'ColumnFormat',{'logical','numeric','numeric','char','char'})

set(handles.popupmenu1,'string',['Select sensor...',{Sensorconf(:).name,'Add new sensor'}])
set(handles.radiobutton1,'enable','off'), set(handles.radiobutton2,'enable','off')
set(handles.text2,'visible','off')
set(handles.edit1,'visible','off','enable','off')

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Sensorconf wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Sensorconf_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

[Sensorconf]   = read_Sensorconfig(['..',filesep,'Conf',filesep,'Sensorconf.xml']);
opt = get(handles.popupmenu1,'value');
maxopt = numel(get(handles.popupmenu1,'string'));

value = [1 0];  table = {false,[],[],'',''}; vis = 'off';
ColumnFormat = {'logical','numeric','numeric','char','char'};
ColumnName   = {'Select','Barycenter [nm]','FWHM [nm]','ISRF value [-]','ISRF wavelenghts [nm]'};
if opt~=1 && opt~=maxopt
    mode = Sensorconf(opt-1).spectral_mode;
    data = Sensorconf(opt-1).bands;
    switch mode
        case 'Multiband'
            value = [1 0];
            ColumnFormat = {'logical','numeric','numeric','char','char'};
            % Update uitable1 Data:
            table = cell(numel(data),5);
            for i=1:numel(data)
                table(i,:) = {false,data(i).barycenter,data(i).fwhm,data(i).isrf_value,data(i).isrf_wvl};
            end
            table(:,2:3) = cellfun(@str2num,table(:,2:3),'UniformOutput',false);
        case 'Hyperspectral'
            value = [0 1];
            ColumnFormat = {'logical','numeric','numeric','numeric','numeric'};
            % Update uitable1 Data:
            table = cell(numel(data),5);
            for i=1:numel(data)
                table(i,:) = {false,data(i).min_wvl,data(i).max_wvl,data(i).fwhm,data(i).ssi};
            end
            table(:,2:end) = cellfun(@str2num,table(:,2:end),'UniformOutput',false);
            ColumnName   = {'Select','Min. wavelength [nm]','Max. wavelength [nm] ','FWHM [nm]','SSI [nm]'};
    end
elseif opt==maxopt
    vis = 'on';
    table = {false,[],[],[],''};
else
    table = [];
end
set(handles.radiobutton1,'enable',vis,'value',value(1))
set(handles.radiobutton2,'enable',vis,'value',value(2))
set(handles.uitable1,'data',table,'ColumnFormat',ColumnFormat,...
    'ColumnName',ColumnName,'ColumnEditable',[true true true true true])
set(handles.edit1,'visible',vis,'enable',vis,'string',[])
set(handles.text2,'visible',vis)
set(handles.checkbox1,'value',0)

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
table = get(handles.uitable1,'data');

if isempty(table), table = {false,[],[],[],[]};
else               table(end+1,:) = {false,[],[],[],[]};
end
set(handles.uitable1,'data',table);




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
table = get(handles.uitable1,'data');
if ~isempty(table)
    select = table(:,1);
    idx    = cell2mat(select);
    if sum(idx)==0
        msgbox('Select spectral bands to remove.','Remove spectral bands','error')
    elseif size(table,1)-sum(idx)==0
        msgbox('There should be at least one spectral band.','Remove spectral bands','error')
    else
        table(idx,:) = [];
        set(handles.uitable1,'data',table)
    end
end

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sensorConfFilename = ['..',filesep,'Conf',filesep,'Sensorconf.xml'];
[Sensorconf]   = read_Sensorconfig(sensorConfFilename);
opt = get(handles.popupmenu1,'value');
maxopt = numel(get(handles.popupmenu1,'string'));

if opt==1 || opt==maxopt
    msgbox('Select first a sensor to remove','Remove sensor - warning','warn')
else
    choice = questdlg(['Do you want to remove ',Sensorconf(opt-1).name,'?'],['Remove ',Sensorconf(opt-1).name],'Yes','No','No');
    if strcmp(choice,'Yes')
        update_Sensorconfig(sensorConfFilename,Sensorconf(opt-1).name,[],'remove')
        msg = {[Sensorconf(opt-1).name,' has been removed.']};
        msgbox(msg,['Remove ',Sensorconf(opt-1).name],'warn')
        [Sensorconf] = read_Sensorconfig(sensorConfFilename);
        set(handles.popupmenu1,'string',['Select sensor...',{Sensorconf(:).name,'Add new sensor'}])
        set(handles.popupmenu1,'value',1)
    end
end


% --- Executes when selected object is changed in uipanel1.
function uipanel1_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel1 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
if get(handles.radiobutton1,'value')==1
    set(handles.uitable1,'data',{false,[],[],'',''},...
        'ColumnName',{'Select','Barycenter [nm]','FWHM [nm]','ISRF value [-]','ISRF wavelenghts [nm]'},...
        'ColumnFormat',{'logical','numeric','numeric','char','char'})
else
    set(handles.uitable1,'data',{false,[],[],[],[]},...
        'ColumnName',{'Select','Min. wavelength [nm]','Max. wavelength [nm] ','FWHM [nm]','SSI [nm]'},...
        'ColumnFormat',{'logical','numeric','numeric','numeric','numeric'})
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
table = get(handles.uitable1,'data');
ColumnFormat = get(handles.uitable1,'ColumnFormat');
idx = eventdata.Indices;

auxtable = table;
if strcmp(ColumnFormat{idx(2)},'numeric') && isempty(str2num(eventdata.EditData))
    % Check if input is string or numeric:
    msgbox('Only numeric values are accepted','Wrong input value','warn')
    table(idx(1),idx(2)) = {eventdata.PreviousData};
    auxtable = table;
elseif strcmp(ColumnFormat{idx(2)},'char') && isempty(str2num(eventdata.EditData))
    table(idx(1),idx(2)) = {eventdata.EditData};
    auxtable = table;
elseif idx(2)==2
    % Reorganize band sorting them to increasing barycenter or min. wavelength:
    [~,i]    = sort(cell2mat(table(:,2)));
    aux      = cell(size(table,1)-numel(i),5); aux(:,1) = {false};
    auxtable = [table(i,:);aux];
elseif idx(2)==1
    select = table(:,1);
    idx    = cell2mat(select);
    if any(idx==0), set(handles.checkbox1,'value',0)
    else            set(handles.checkbox1,'value',1)
    end
end

set(handles.uitable1,'data',auxtable)
return


% --- Executes on key press with focus on uitable1 and none of its controls.
function uitable1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)

table = get(handles.uitable1,'data');
sz = size(table);

ind = get(handles.pushbutton1,'userdata');
if ~isempty(ind)
    if ind(1)==sz(1) && ind(2)==sz(2) && strcmp(eventdata.Key,'tab')
        if isempty(table), table = {false,[],[],[],[]};
        else               table(end+1,:) = {false,[],[],[],[]};
        end
        set(handles.uitable1,'data',table);
    end
end

% --- Executes when selected cell(s) is changed in uitable1.
function uitable1_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)

ind = eventdata.Indices;
set(handles.pushbutton1,'userdata',ind)


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
opt   = get(handles.checkbox1,'value');
table = get(handles.uitable1,'data');

if opt==1, table(:,1) = {true};
else table(:,1) = {false};
end
set(handles.uitable1,'data',table)
