function [RTMconf,Groupnames,datos] = read_RTMconfig(ruta,RTMname)
xDoc = xmlread(ruta);
nodos=xDoc.getChildNodes;    
AtmLutGen = nodos.item(0); % Node 0 is AtmLutGen

%% Read RTM nodes attributes and store them in RTMconf struct:
RTMconf = [];
auxidx = 1;

for i=0:AtmLutGen.getLength-1;
    RTM = AtmLutGen.item(i);
    if RTM.hasAttributes
        theAttributes = RTM.getAttributes;
        for count = 1:theAttributes.getLength
            attrib = theAttributes.item(count-1);
            RTMconf(auxidx).(char(attrib.getName))= char(attrib.getValue);
        end
        RTMconf(auxidx).name = char(RTM.getNodeName);
        auxidx               = auxidx+1;
    end
end


%% Read Groups and Parameters for a selected RTM:
if RTMname % Executed only when RTM idx is input
    % 1) Select RTM node:
    RTM         = AtmLutGen.getElementsByTagName(RTMname).item(0);
    nodos       = RTM.getChildNodes; 
    length      = (nodos.getLength-1)/2;
	Groupnames  = cell(1,length);   auxidx = 1; datos = [];

    for i=1:2:nodos.getLength-1
        % 2) Read Parameters Group names:
        Group   = nodos.item(i);
        theAttributes   = Group.getAttributes;
        for count = 1:theAttributes.getLength
            attrib                      = theAttributes.item(count-1);
            tmpgoup.(char(attrib.getName))  = char(attrib.getValue);
        end
        Groupnames{auxidx}  = tmpgoup.name;
        auxidx   = auxidx+1;

        % 3) Read attributes of each parameter within Group:
        parameters  = Group.getChildNodes;
        auxidx2     = 1;
        asd         = Group.getElementsByTagName('parameter');

        if asd.getLength>0
            for j = 0:asd.getLength-1
                param           = asd.item(j);
                theAttributes   = param.getAttributes;
                datos           = leernodo(param,datos,char(parameters.getNodeName));
                auxidx2         = auxidx2+1;
            end
        else
            datos.(char(parameters.getNodeName)) = [];
        end
    end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [datos]=leernodo(nodo,datos,str)
if nodo.hasAttributes
    theAttributes = nodo.getAttributes;
    for count = 1:theAttributes.getLength
        attrib = theAttributes.item(count-1);
        tmp.(char(attrib.getName))= char(attrib.getValue);
    end
    
    name=tmp.name;
%     switch tmp.type
%         case 'INTEGER'
%             data=str2double(tmp.value);
%         case 'INT'
%             data=str2double(tmp.value);
%         case 'FLOAT'
%             data=eval(['[' tmp.value '];']);            
%         case 'DOUBLE'
%             data=eval(['[' tmp.value '];']);            
%         otherwise
%             data=tmp.value;
%     end
    datos.(str).(name)=tmp;
% else
%     if nodo.hasChildNodes
%         name=char(nodo.getNodeName);
%         hijos=nodo.getChildNodes;
%         j=1;
%         datos1=[];
%         for count=1:hijos.getLength
%             datos1=leernodo(hijos.item(count-1),datos1);            
%         end
%         if ~isempty(datos1)
%             datos.(name)=datos1;
%         end
%     end
end
