function [Sensorconf] = read_Sensorconfig(ruta)
xDoc = xmlread(ruta);
nodos=xDoc.getChildNodes;    
AtmLutGen = nodos.item(0); % Node 0 is AtmLutGen

%% Read Sensor nodes attributes and store them in Sensorconf struct:
Sensorconf = [];
auxidx = 1;

for i=0:AtmLutGen.getLength-1;
    Sensor = AtmLutGen.item(i);
    if Sensor.hasAttributes
        theAttributes = Sensor.getAttributes;
        for count = 1:theAttributes.getLength
            attrib = theAttributes.item(count-1);
            Sensorconf(auxidx).(char(attrib.getName))= char(attrib.getValue);
        end
        Sensorconf(auxidx).name = char(Sensor.getNodeName);
        auxidx               = auxidx+1;
    end
end


%% Read sepctral configuration (i.e. Bands) for the selected Sensor:
for idx=1:numel(Sensorconf)
    % 1) Select Sensor node:
    Sensor  = AtmLutGen.getElementsByTagName(Sensorconf(idx).name).item(0);
    node    = Sensor.getChildNodes;


    % 2) Read attributes of each Band within Group:
    asd     = Sensor.getElementsByTagName('band');

    if asd.getLength>0
    	for j = 0:asd.getLength-1
        	param           = asd.item(j);
            theAttributes   = param.getAttributes;
            for count = 1:theAttributes.getLength
                attrib = theAttributes.item(count-1);
                Sensorconf(idx).bands(j+1).(char(attrib.getName)) = char(attrib.getValue);
            end
        end
    else
    	Sensorconf(idx).bands = [];
    end
end