function [] = update_OPACconfig(ruta,newOPACconf,ParamFamily,newParam)

%% Read input XML file from "ruta":
xDoc = xmlread(ruta);
nodos=xDoc.getChildNodes;    
AtmLutGen = nodos.item(0); % Node 0 is AtmLutGen


%% Modify/Update RTM filepath, version and op_mode attributes:
if ~isempty(newOPACconf)
    OPAC  = AtmLutGen.getElementsByTagName('OPAC').item(0);
    name = char(OPAC.getNodeName);
    theAttributes = OPAC.getAttributes;
    for count = 1:theAttributes.getLength
        attrib = theAttributes.item(count-1);
        if strcmp(attrib.getName,'filepath')
            attrib.setValue(newOPACconf.filepath)
        elseif strcmp(attrib.getName,'version')
            attrib.setValue(newOPACconf.version)
        elseif strcmp(attrib.getName,'op_mode')
            aux = '{';
            if iscell(newOPACconf.op_mode)
                for i=1:length(newOPACconf.op_mode)
                    aux =[aux,newOPACconf.op_mode{i},','];
                end
            else
                aux =[aux,newOPACconf.op_mode,','];
            end
           aux(end) = '}';
           attrib.setValue(aux)
        end
    end
end


%% Modify/Update OPAC parameters:
if ~isempty(newParam) && ~isempty(ParamFamily)
    OPAC   = AtmLutGen.getElementsByTagName('OPAC').item(0);    % 1st select RTM
    Group = OPAC.getElementsByTagName(ParamFamily).item(0);      % 2nd select Group of parameters
    
    for i=0:Group.getLength-1
        Group.removeChild(Group.item(0));                       % Remove previous parameters
    end
    
    for i=2:size(newParam,1)                                    % For each parameter...
        product = xDoc.createElement('parameter');
        for j=2:size(newParam,2)                                % ...set attributes...
            product.setAttribute(newParam{1,j},newParam{i,j});
        end
        Group.appendChild(product);                             % ...then append new/updated parameter
    end
end

%% Update XML file:
XML_string = xmlwrite(xDoc); %XML as string
XML_string = regexprep(XML_string,'\n\s*\n','\n'); %removes tabs and extra lines

%Write to file
fid = fopen(ruta,'w');
fprintf(fid,'%s\n',XML_string);
fclose(fid); 
