function [] = update_RTMconfig(ruta,RTMname,newRTMconf,option,newRTM,ParamFamily,newParam)

%% Read input XML file from "ruta":
xDoc = xmlread(ruta);
nodos=xDoc.getChildNodes;    
AtmLutGen = nodos.item(0); % Node 0 is AtmLutGen


%% Modify/Update RTM filepath, version and op_mode attributes:
if ~isempty(newRTMconf)
    RTM  = AtmLutGen.getElementsByTagName(RTMname).item(0);
    name = char(RTM.getNodeName);
    theAttributes = RTM.getAttributes;
    for count = 1:theAttributes.getLength
        attrib = theAttributes.item(count-1);
        if strcmp(attrib.getName,'filepath')
            attrib.setValue(newRTMconf.filepath)
        elseif strcmp(attrib.getName,'version')
            attrib.setValue(newRTMconf.version)
        elseif strcmp(attrib.getName,'op_mode')
            aux = '{';
            if iscell(newRTMconf.op_mode)
                for i=1:length(newRTMconf.op_mode)
                    aux =[aux,newRTMconf.op_mode{i},','];
                end
            else
                aux =[aux,newRTMconf.op_mode,','];
            end
           aux(end) = '}';
           attrib.setValue(aux)
        end
    end
end

%% Add/Remove RTM:
if ~isempty(option)
    if isempty(newRTM)                                         %% Remove RTM
        AtmLutGen.removeChild(AtmLutGen.getElementsByTagName(RTMname).item(0));
    elseif strcmp(option,'add')                                %% Add newRTM
        % New RTM node:
        product = xDoc.createElement(newRTM);
        product.setAttribute('filepath','');
        product.setAttribute('op_mode','{}');
        product.setAttribute('version','');
        AtmLutGen.appendChild(product);

        param = {'AtmParam','AerParam','GeoParam','SpeParam','AdvParam'};
        auxtxt = {'Atmospheric','Aerosols','Geometric','Spectral','Advanced'};
        for i=1:length(param)
            product = xDoc.createElement(param{i});
            newRTMnode = AtmLutGen.item(AtmLutGen.getLength-1);
            product.setAttribute('name',auxtxt{i});
            newRTMnode.appendChild(product);
        end
    end
end

%% Modify/Update RTM parameters:
if ~isempty(newParam) && ~isempty(ParamFamily)
    RTM   = AtmLutGen.getElementsByTagName(RTMname).item(0);    % 1st select RTM
    Group = RTM.getElementsByTagName(ParamFamily).item(0);      % 2nd select Group of parameters
    
    for i=0:Group.getLength-1
        Group.removeChild(Group.item(0));                       % Remove previous parameters
    end
    
    for i=2:size(newParam,1)                                    % For each parameter...
        product = xDoc.createElement('parameter');
        for j=2:size(newParam,2)                                % ...set attributes...
            product.setAttribute(newParam{1,j},newParam{i,j});
        end
        Group.appendChild(product);                             % ...then append new/updated parameter
    end
end

%% Update XML file:
XML_string = xmlwrite(xDoc); %XML as string
XML_string = regexprep(XML_string,'\n\s*\n','\n'); %removes tabs and extra lines

%Write to file
fid = fopen(ruta,'w');
fprintf(fid,'%s\n',XML_string);
fclose(fid); 
