function [] = update_Sensorconfig(ruta,Sensorname,newSensorconf,option)

%% Read input XML file from "ruta":
xDoc = xmlread(ruta);
nodos=xDoc.getChildNodes;    
AtmLutGen = nodos.item(0); % Node 0 is AtmLutGen


%% Remove Sensor:
if strcmp(option,'remove')
    AtmLutGen.removeChild(AtmLutGen.getElementsByTagName(Sensorname).item(0));
else
    %% Modify/Update Sensor spectral configuration:
    if ~isempty(newSensorconf)
        try % Update Sensor node:
            Sensor  = AtmLutGen.getElementsByTagName(Sensorname).item(0);
            theAttributes = Sensor.getAttributes;
            attrib = theAttributes.item(0);
            attrib.setValue(newSensorconf.spectral_mode)
        catch % New Sensor node:
            product = xDoc.createElement(Sensorname);
            product.setAttribute('spectral_mode',newSensorconf.spectral_mode);
            AtmLutGen.appendChild(product);
        end
    
        % Now update/add spectral bands:
        Sensor = AtmLutGen.getElementsByTagName(Sensorname).item(0);    % 1st select Sensor

        for i=0:Sensor.getLength-1
            Sensor.removeChild(Sensor.item(0));                       % Remove previous bands
        end

        if strcmp(newSensorconf.spectral_mode,'Multiband')
            attrname = {'','barycenter','fwhm','isrf_value','isrf_wvl'};
        elseif strcmp(newSensorconf.spectral_mode,'Hyperspectral')
            attrname = {'','min_wvl','max_wvl','fwhm','ssi'};
        end
        for i=1:size(newSensorconf.bands,1)                                    % For each band...
            product = xDoc.createElement('band');
            for j=2:size(newSensorconf.bands,2)                                % ...set attributes...
                data = newSensorconf.bands{i,j};
                if isnumeric(data)
                    product.setAttribute(attrname{j},num2str(data));
                elseif ischar(data)
                    product.setAttribute(attrname{j},data);
                end
            end
            Sensor.appendChild(product);                             % ...then append new/updated band
        end
    end
end
%% Update XML file:
XML_string = xmlwrite(xDoc); %XML as string
XML_string = regexprep(XML_string,'\n\s*\n','\n'); %removes tabs and extra lines

%Write to file
fid = fopen(ruta,'w');
fprintf(fid,'%s\n',XML_string);
fclose(fid); 
