function varargout = atk(varargin)
% ATK MATLAB code for atk.fig
%      ATK, by itself, creates a new ATK or raises the existing
%      singleton*.
%
%      H = ATK returns the handle to a new ATK or the handle to
%      the existing singleton*.
%
%      ATK('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ATK.M with the given input arguments.
%
%      ATK('Property','Value',...) creates a new ATK or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before atk_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to atk_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help atk

% Last Modified by GUIDE v2.5 13-Apr-2019 16:19:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @atk_OpeningFcn, ...
                   'gui_OutputFcn',  @atk_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before atk is made visible.
function atk_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to atk (see VARARGIN)

% Choose default command line output for atk
handles.output = hObject;

RTMconf = read_RTMconfig('../Conf/RTMconf.xml',[]);
set(handles.popupmenu1,'string',['Select RTM...',{RTMconf(:).name}],...
                       'value',1,'fontweight','bold')

                   set(handles.uitable1,'data',{},'enable','off')
set(handles.pushbutton1,'enable','off'), set(handles.pushbutton2,'enable','off')
set(handles.pushbutton3,'enable','off'), set(handles.pushbutton4,'enable','off')
set(handles.pushbutton5,'enable','off')
set(handles.edit1,'enable','off')
set(handles.listbox1,'enable','off')
set(handles.checkbox1,'enable','off')
set(handles.popupmenu2,'enable','off','visible','off')
set(handles.text5,'visible','off')
set(handles.pushbutton6,'enable','off','visible','off')
set(handles.text6,'visible','off')
set(handles.popupmenu3,'visible','off')



% Update handles structure
guidata(hObject, handles);

% UIWAIT makes atk wait for user response (see UIRESUME)
% uiwait(handles.atk);


% --- Outputs from this function are returned to the command line.
function varargout = atk_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1
dbfile = '../Userdata/aerdb.h5';
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
types = get(handles.popupmenu2,'userdata');

contents = cellstr(get(hObject,'String'));
aername = contents{get(hObject,'Value')};
aux = h5read(dbfile,['/',rtm,'/',aername]);
modeltype = h5readatt(dbfile,['/',rtm,'/',aername],'modeltype');
ind = find(types==modeltype); if numel(ind)>1,ind=ind(1); end
set(handles.popupmenu2,'value',ind,'enable','off')
set(handles.edit1,'string',aername)
set(handles.pushbutton3,'enable','on')

switch rtm
    case {'MODTRAN5','MODTRAN6'}
        if ind==2 % User-defined optical properties
            en = 'on';
            ColumnName = {'Select','Wavelength [um]','Normalized EXT [km-1]','SSA [km-1]','Asymmetry param: [-]'};
            ColumnFormat = {'logical','numeric','numeric','numeric','numeric'};
            RowName = 'numbered';
            table = cell(size(aux,1),size(aux,2)+1); table(:,1) = {false};
            aux = mat2cell(aux,ones(1,size(aux,1)),ones(1,size(aux,2)));
            table(:,2:end) = aux;
        elseif ind==3 % OPAC-based aerosols
            en = 'off';
            aux = h5readatt(dbfile,['/',rtm,'/',aername],'opacdata')';
            [~,~,datos]   = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
            fn = fieldnames(datos.PARTYPE); nAers = numel(fn);
            ColumnName = cell(1,nAers);
           	for i=1:nAers
            	ColumnName{i} = [datos.PARTYPE.(fn{i}).description,' [%]'];
            end
            ColumnFormat = cell(1,nAers); ColumnFormat(:)={'numeric'};
            RowName = 'numbered';
            table = mat2cell(aux,ones(1,size(aux,1)),ones(1,size(aux,2)));
        end
        set(handles.checkbox1,'enable',en)
    case 'sixSV'
        if ind==2 % User-defined optical properties
            en = 'off';
            ColumnName = {'Select','Wavelength [um]','Normalized EXT [km-1]','SSA [km-1]','Asymmetry param: [-]'};
            ColumnFormat = {'logical','numeric','numeric','numeric','numeric'};
            RowName = 'numbered';
            table = cell(size(aux,1),size(aux,2)+1); table(:,1) = {false};
            aux = mat2cell(aux,ones(1,size(aux,1)),ones(1,size(aux,2)));
            table(:,2:end) = aux;
        elseif ind==3
            en = 'off';
            ColumnName = {'Dust [%]','Water-soluble [%]','Oceanic [%]','Soot [%]'};
            ColumnFormat = {'numeric','numeric','numeric','numeric'};
            RowName = 'numbered';
            table = mat2cell(aux,ones(1,size(aux,1)),ones(1,size(aux,2)));
        elseif any(ind==[4,5,6])
            en = 'on';
            ColumnName = {};
            RowName = cell(size(aux,1),1);
            RowName(1) = {'Rmin,Rmax:'};
            RowName(2:3:end) = {'Rmean,Sigma,%:'};
            RowName(3:3:end) = {'n_r'}; RowName(4:3:end)={'n_i'};
            table = mat2cell(aux,ones(1,size(aux,1)),ones(1,size(aux,2)));
            ColumnFormat = cell(1,size(table,2)); ColumnFormat(:)={'numeric'};
        end
        
end
set(handles.pushbutton4,'enable',en)
set(handles.pushbutton5,'enable',en)
set(handles.uitable1,'data',table,'ColumnName',ColumnName,'RowName',RowName,...
    'ColumnFormat',ColumnFormat,'ColumnEditable',true,...
    'enable','on')

% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
dbfile = '../Userdata/aerdb.h5';
flag = exist(dbfile,'file');

set(handles.pushbutton6,'enable','off','visible','off')
set(handles.text6,'visible','off')
set(handles.popupmenu3,'enable','off','visible','off')

contents = cellstr(get(hObject,'String'));
rtm = contents{get(hObject,'Value')};
info =[]; enable = 'off'; aernames = {};
try info = h5info(dbfile,['/',rtm]); end

if flag==2 && ~isempty(info)
    % File exists and RTM has user-defined aerosols
    n = numel(info.Datasets); % Number of user-defined aerosols
    aernames = cell(1,n);
    for i=1:n, aernames{i} = info.Datasets(i).Name; end
    set(handles.listbox1,'string',aernames,'value',[],'min',0,'max',2)
else
    set(handles.listbox1,'string','')
end


if ~strcmp(rtm,'Select RTM...')
    set(handles.pushbutton1,'enable','on'), set(handles.pushbutton2,'enable','on')
    set(handles.listbox1,'enable','on')
    set(handles.popupmenu2,'enable','off','visible','off')
    set(handles.popupmenu2,'backgroundcolor',[1 1 1])
    set(handles.text5,'visible','off')
    switch rtm
        case {'MODTRAN5','MODTRAN6'}
            set(handles.popupmenu2,'enable','on','visible','on',...
                'userdata',[0 1 2],'string',{'Select...',...
                'Optical properties','OPAC-based'},'value',1)
            set(handles.text5,'visible','on')
            table = cell(2,5); table(:,1) = {false};
            ColumnName = {}; ColumnFormat = {}; usrdata = {};
            en = 'off';
        case 'sixSV'
            set(handles.popupmenu2,'enable','on','visible','on',...
                'userdata',[0 12 4 8 9 10 11 8],'string',{'Select...',...
                'Optical properties','User''s components','Multimodal (log-normal)',...
                'Modified gamma distr.','Junge power-law distr.',...
                'Sun photometric distr.','OPAC-based'},'value',1)
            set(handles.text5,'visible','on')
            table = cell(2,5); table(:,1) = {false};
            ColumnName = {}; ColumnFormat = {}; usrdata = {};
            en = 'off';
        case 'libRadtran'
            table = cell(2,5); table(:,1) = {false};
    end
    set(handles.uitable1,'data',table,'ColumnName',ColumnName,...
       'ColumnFormat',ColumnFormat,'ColumnEditable',true,'enable',en)
    set(handles.uitable1,'userdata',usrdata)
    set(handles.pushbutton3,'enable',en), set(handles.pushbutton4,'enable',en)
    set(handles.pushbutton5,'enable',en), set(handles.edit1,'enable',en)
    set(handles.checkbox1,'enable',en)
else
    set(handles.uitable1,'data',{},'enable','off','ColumnName',{})
    set(handles.pushbutton1,'enable','off'), set(handles.pushbutton2,'enable','off')
    set(handles.pushbutton3,'enable','off'), set(handles.pushbutton4,'enable','off')
    set(handles.pushbutton5,'enable','off'), set(handles.edit1,'enable','off')
    set(handles.listbox1,'enable','off','string','')
    set(handles.checkbox1,'enable','off','value',0)
    set(handles.popupmenu2,'enable','off','visible','off')
    set(handles.text5,'visible','off')
end

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.listbox1,'value',[],'min',0,'max',2)
set(handles.edit1,'string','new_aerosol_name')
table = get(handles.uitable1,'data');
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
set(handles.popupmenu2,'enable','on','value',1)
set(handles.pushbutton4,'enable','off')
set(handles.pushbutton5,'enable','off')
set(handles.checkbox1,'enable','off')
set(handles.uitable1,'ColumnName',{},'ColumnFormat',{})

set(handles.uitable1,'data',{})
set(handles.popupmenu2,'backgroundcolor',[1 1 0])

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
dbfile = '../Userdata/aerdb.h5';
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
aernames = get(handles.listbox1,'string');

ind = get(handles.listbox1,'value');
if isempty(ind), return, end
aername = aernames{ind};

choice = questdlg(['Do you want to remove selected aerosol (',aername,') from database?'],...
                  'Delete aerosol?','Yes','No','No');
if strcmp(choice,'Yes')
    set(handles.listbox1,'value',1);
    fid = H5F.open(dbfile,'H5F_ACC_RDWR','H5P_DEFAULT');
    H5L.delete(fid,['/',rtm,'/',aername],'H5P_DEFAULT');
    H5F.close(fid);
    aernames(ind)=[];
    set(handles.listbox1,'string',aernames);
end

function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
text = get(hObject,'String');
if ~isempty(text)
    set(handles.edit1,'backgroundcolor',[1 1 1])
    if numel(text)>8
        h = msgbox('Length of aerosol name cannot exceed 8 characters','Input aerosol name','warn');
        set(h,'windowstyle','modal'), uiwait(h)
        set(handles.edit1,'string',text(1:8))
    end
end


% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

aername = get(handles.edit1,'string');
if isempty(aername)
    h = msgbox('Please introduce an aerosol name','Save aerosol data','error');
    set(h,'windowstyle','modal'), uiwait(h)
    set(handles.edit1,'backgroundcolor',[1 1 0])
    return
end

contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
ind = get(handles.popupmenu2,'value');
modeltype = get(handles.popupmenu2,'userdata'); modeltype = modeltype(ind);
table = get(handles.uitable1,'data');

opac = false;
switch rtm
    case {'MODTRAN5','MODTRAN6'}
        if ind==2 % User-defined optical properties
            n = size(table,1);
            table = cell2mat(table(:,2:end)); wvl = table(:,1);
            aux = isnan(table);
            if any(sum(aux)==n)
                msgbox('Each table column must have at least two values','Save aerosol data','error');
                return
            else
                if any(aux(:))
                    h = msgbox('Empty cells are filled by spline interpolation','Save aerosol data','warn');
                    set(h,'windowstyle','modal'), uiwait(h)
                    for i=find(any(aux))
                        dta = table(~aux(:,i),i);
                        for j=find(aux(:,i))'
                            table(j,i) = spline(wvl(~aux(:,i)),dta,wvl(j));
                        end    
                    end
                end
            end
            extc550 = spline(wvl,table(:,2),0.55);
            if extc550~=1
                h = msgbox('Extinction coefficient will be normalized to 1 at 0.55 um','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                table(:,2) = table(:,2)/extc550;
            end
            auxdim = Inf; % Dimension for database
        elseif ind==3 % OPAC-based aerosol
            opac = true;
            table = cell2mat(table);
            if sum(table~=0)>5
                h = msgbox('OPAC-based aerosols only admit max. 5 components. Please edit table.','Save aerosol data','error');
                set(h,'windowstyle','modal'), uiwait(h)
                return
            end
            tot = sum(table)/100;
            if tot~=1
                h = msgbox('Total volumetric percentage will be normalized to 100%','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                table = table/tot;
            end
            opacTable = table;
            % Now we run OPAC:
            [OPACconf,~,data] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
            [opacpathstr,~,~] = fileparts(OPACconf.filepath);
            inputpath         = [opacpathstr,filesep,'input',filesep];
            outputpath        = [opacpathstr,filesep,'result',filesep];
            filename = [inputpath,aername,'.inp'];

            varnames          = {'AERTYPE','PARTYPE','NDENS','WVLAER','RH'};
            WVLAER            = str2num(data.MainParam.WVLAER.values);
            
            idx = find(table~=0);
            if get(handles.popupmenu3,'value')~=1
                RH = str2num(get(handles.popupmenu3,'string'));
            else
                RH = 70;
            end
            inputval = {0,idx,table(idx),WVLAER,RH};
            
            % Write OPAC input file:
            Write_opacinp(filename,varnames,inputval)
            % Run OPAC based on created input file:
            runfile = ['..',filesep,'Userdata',filesep,'runOPAC.bat'];
            fid = fopen(runfile,'w');
            diskLoc = pwd; diskLoc=diskLoc(1);
            if ~strcmp(diskLoc,OPACconf.filepath(1))
                % Change between disks to run OPAC if necessary
                fprintf(fid,'%-100s\n',[OPACconf.filepath(1),':']);
            end
            fprintf(fid,'%-100s\n',['cd ',fileparts(OPACconf.filepath)]);
            [~,name,~] = fileparts(filename);
            fprintf(fid,'%-100s\n',['echo ',name,' | opac']); fclose(fid);
            evalin('base',['!',runfile,' &'])
            delete(runfile)
            delete(filename)
            % Read OPAC each output file and store variables in OPAC LUT .h5
            % file:
            filename = [outputpath,aername,'.out'];
            [VARSPC,~,EXTC,ABSC,ASYM,~,~] = Read_opacout(filename);
            SSA = 1-ABSC./EXTC;
            delete(filename)
            
            auxdim = Inf;
            table = [VARSPC',EXTC,SSA,ASYM];
        end
    case 'sixSV'
        if numel(aername)>8
            h = msgbox('Length of aerosol name cannot exceed 8 characters','Input aerosol name','warn');
            set(h,'windowstyle','modal'), uiwait(h)
            aername = aername(1:8);
            set(handles.edit1,'string',aername)
        end
        ind = get(handles.popupmenu2,'value');
        wvl6SV = [0.35,0.4,0.412,0.443,0.47,0.488,0.515,0.55,0.59,...
                  0.633,0.67,0.694,0.76,0.86,1.24,1.536,1.65,1.95,...
                  2.25,3.75]; % 6SV reflective index wavelengths (hard-coded!!)
        if ind==2 % User-defined optical properties
            n = size(table,1);
            table = cell2mat(table(:,2:end)); wvl = table(:,1);
            aux = isnan(table);
            if any(sum(aux)==n)
                msgbox('Each table column must have at least two values','Save aerosol data','error');
                return
            else
                if any(aux(:))
                    h = msgbox('Empty cells are filled by spline interpolation','Save aerosol data','warn');
                    set(h,'windowstyle','modal'), uiwait(h)
                    for i=find(any(aux))
                        dta = table(~aux(:,i),i);
                        for j=find(aux(:,i))'
                            table(j,i) = spline(wvl(~aux(:,i)),dta,wvl(j));
                        end    
                    end
                end
            end
            if ~isequal(wvl',wvl6SV)
                h = msgbox('Optical properties interpolated to 6SV internal spectral grid','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                auxtable = spline(wvl,table(:,2:end)',wvl6SV)';
                table = [wvl6SV',auxtable];
            end
            
            extc550 = spline(wvl6SV,table(:,2),0.55);
            if extc550~=1
                h = msgbox('Extinction coefficient will be normalized to 1 at 0.5 um','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                table(:,2) = table(:,2)/extc550;
            end
            auxdim = Inf; % Dimension for database
        elseif ind==3 % User components
            tot = sum(cell2mat(table))/100;
            if tot~=1
                h = msgbox('Total volumetric percentage will be normalized to 100%','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                table = cellfun(@(x) x/tot,table,'un',0);
            end
            auxdim = 1;
            table = cell2mat(table);
        elseif any(ind==[4,5,6]) % Particle distribution
            auxdim = Inf;
            table = cell2mat(table);
        elseif ind==8 % OPAC-based aerosol
            opac = true;
            auxdim = Inf;
            table = cell2mat(table);
            if sum(table~=0)>4
                h = msgbox('OPAC-based aerosols only admit max. 4 components. Please edit table.','Save aerosol data','error');
                set(h,'windowstyle','modal'), uiwait(h)
                return
            end
            tot = sum(table)/100;
            if tot~=1
                h = msgbox('Total volumetric percentage will be normalized to 100%','Save aerosol data','warn');
                set(h,'windowstyle','modal'), uiwait(h)
                table = table/tot;
            end
            opacTable = table;

            % Now we run OPAC in order to calculate the volume mixing ratio:
            [OPACconf,~,data] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
            [opacpathstr,~,~] = fileparts(OPACconf.filepath);
            wvlopac = str2num(data.MainParam.WVLAER.values); % Wavelengths OPAC
            inputpath         = [opacpathstr,filesep,'input',filesep];
            outputpath        = [opacpathstr,filesep,'result',filesep];
            filename = [inputpath,aername,'.inp'];

            varnames          = {'AERTYPE','PARTYPE','NDENS','WVLAER','RH'};
            
            idx = find(table~=0);
            if get(handles.popupmenu3,'value')~=1
                RH = get(handles.popupmenu3,'string');
                RH = str2num(RH{get(handles.popupmenu3,'value')});
            else
                RH = 70;
            end
            inputval = {0,idx,table(idx),wvlopac,RH};
            
            % Write OPAC input file:
            Write_opacinp(filename,varnames,inputval)
            % Run OPAC based on created input file:
            runfile = ['..',filesep,'Userdata',filesep,'runOPAC.bat'];
            fid = fopen(runfile,'w');
            diskLoc = pwd; diskLoc=diskLoc(1);
            if ~strcmp(diskLoc,OPACconf.filepath(1))
                % Change between disks to run OPAC if necessary
                fprintf(fid,'%-100s\n',[OPACconf.filepath(1),':']);
            end
            fprintf(fid,'%-100s\n',['cd ',fileparts(OPACconf.filepath)]);
            [~,name,~] = fileparts(filename);
            fprintf(fid,'%-100s\n',['echo ',name,' | opac']); fclose(fid);
            evalin('base',['!',runfile,' &'])
            delete(runfile)
            delete(filename)
            % Read Volume mixing ratio in OPAC output file:
            filename = [outputpath,aername,'.out'];
            fid = fopen(filename);
                tline = fgetl(fid);
                while ~contains(tline,'VOL.MIX'), tline = fgetl(fid); end
                tline = fgetl(fid); tline = fgetl(fid);
                auxVol = textscan(fid,['# %s %s ',repmat('%s ',1,7)],1);
                VolMixRatio(1) = str2num(cell2mat(auxVol{end-1}));
                auxVol = textscan(fid,['# %s %s ',repmat('%s ',1,7)],numel(idx)-1);
                VolMixRatio(2:numel(idx)) = str2num(cell2mat(auxVol{end-2}));
            fclose(fid);
            delete(filename)
            
            % Now read particle data from OPAC:
            idx = strfind(opacpathstr,filesep);
            opacpathstr = [opacpathstr(1:idx(end)),'optdat',filesep];
            auxnames = {'inso','waso','soot','ssam','sscm','minm','miam',...
                        'micm','mitr','suso'}; % OPAC particles ID names (hard-coded!!)
            % Convert RH into string:
            if RH==0, RH='00'; else, RH = num2str(RH); end
            % Read input components and associated data from OPAC files:
            idx   = find(table~=0);
            opacTable = table;
            table = table(idx);
            Rmin = 0; Rmax = 0;
            auxdata = nan(3*numel(idx),20);
            for i=1:numel(idx)
                partname = [auxnames{idx(i)},RH];
                if ~exist([opacpathstr,partname])
                    % Selected particle is not RH-dependent. Reset to 0% RH
                    partname = [partname(1:end-2),'00'];
                end
                aux = importdata([opacpathstr,partname]);
                Rmin = Rmin + aux.data(1)*table(i)/100;
                Rmax = Rmax + aux.data(2)*table(i)/100;
                % See Hess et all for OPAC description of log-normal 
                % distribution values and compare with 6SV AEROSOL and MIE
                % function. Note: OPAC says is the mode but from the 
                % equation it rather looks like the median (which is also 
                % the one used in 6SV)
                auxdata(2+3*(i-1),1) = aux.data(4); % Rmedian
                auxdata(2+3*(i-1),2) = aux.data(3); % Sigma
                auxdata(2+3*(i-1),3) = VolMixRatio(i); % Percentage (0 to 1)
                fid = fopen([opacpathstr,partname]);
                tline = fgetl(fid);
                while ~contains(tline,'# wavelength'),tline = fgetl(fid); end
                tline = fgetl(fid); tline = fgetl(fid); %tline = fgetl(fid);
                refInd = cell2mat(textscan(fid,['# ',repmat('%f ',1,9)],numel(wvlopac)));
                fclose(fid);
                auxdata(3+3*(i-1),:) = interp1(wvlopac,abs(refInd(:,8)),wvl6SV);
                auxdata(4+3*(i-1),:) = interp1(wvlopac,abs(refInd(:,9)),wvl6SV);
            end
            auxdata(1,1) = Rmin; auxdata(1,2) = Rmax;
            table = auxdata;    
        end
    case 'libRadtran'
end
% set(handles.uitable1,'data',table);

% Save data into aerosol database file:
dbfile = ['..',filesep,'Userdata',filesep,'aerdb.h5'];
aernames = [];
flag = exist(dbfile,'file');


info =[]; try info = h5info(dbfile,['/',rtm]); end

if flag==2 && ~isempty(info)
    % Read existing aerosol names in the database:
    n = numel(info.Datasets); % Number of user-defined aerosols
    aernames = cell(1,n);
    for i=1:n, aernames{i} = info.Datasets(i).Name; end
    % Check if new aerosol already exists in the database
    idx = find(cellfun(cellfind(aername),aernames));
    if idx % Aerosol name is in the database
        choice = questdlg(['Aerosol name already exists in the database.',...
                           'Would you want to replace it?'],'Replace aerosol?','Yes','No','No');
        if strcmp(choice,'Yes') % Replace existing aerosol properties
            fid = H5F.open(dbfile,'H5F_ACC_RDWR','H5P_DEFAULT');
            dset_id = H5D.open(fid,['/',rtm,'/',aername]);
            H5D.set_extent(dset_id,fliplr(size(table)));
            H5D.close(dset_id); H5F.close(fid);
            h5write(dbfile,['/',rtm,'/',aername],table,[1 1],size(table))
            set(handles.listbox1,'value',idx)
            msgbox(['Aerosol ',aername,' has been updated into the ',rtm,' aerosol database'],'Updated aerosol added','warn')
        end
    else % Aerosol name is not in the database
        h5create(dbfile,['/',rtm,'/',aername],[auxdim size(table,2)],'ChunkSize',size(table))
        h5write(dbfile,['/',rtm,'/',aername],table,[1 1],size(table))
        if opac
           h5writeatt(dbfile,['/',rtm,'/',aername],'opacdata',opacTable)
        end
        aux = get(handles.uitable1,'userdata');
        h5writeatt(dbfile,['/',rtm,'/',aername],'varnames',strjoin(aux(1,:)))
        if size(aux,1)>1
            h5writeatt(dbfile,['/',rtm,'/',aername],'units',strjoin(aux(2,:)))
        else
            h5writeatt(dbfile,['/',rtm,'/',aername],'units','%')
        end
        h5writeatt(dbfile,['/',rtm,'/',aername],'modeltype',modeltype)
        aernames(end+1) = {aername};
        set(handles.listbox1,'string',aernames,'value',numel(aernames))
        msgbox(['New aerosol (',aername,') has been added into the ',rtm,' aerosol database'],'New aerosol added')
    end
elseif (flag==2 && isempty(info)) || flag==0 % File or Group do not exist --> create it for 1st time
    h5create(dbfile,['/',rtm,'/',aername],[auxdim size(table,2)],'ChunkSize',size(table))
    h5write(dbfile,['/',rtm,'/',aername],table,[1 1],size(table))
    aux = get(handles.uitable1,'userdata');
    h5writeatt(dbfile,['/',rtm,'/',aername],'varnames',strjoin(aux(1,:)))
    h5writeatt(dbfile,['/',rtm,'/',aername],'modeltype',modeltype)
    if size(aux,1)==2
        h5writeatt(dbfile,['/',rtm,'/',aername],'units',strjoin(aux(2,:)))
    end
    set(handles.listbox1,'string',aername,'value',numel(aernames)+1)
    msgbox(['New aerosol (',aername,') has been added into the ',rtm,' aerosol database'],'New aerosol added')
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
opt   = get(handles.checkbox1,'value');
tabledata = get(handles.uitable1,'data');

if opt==1, tabledata(:,1) = {true};
else tabledata(:,1) = {false};
end
set(handles.uitable1,'data',tabledata)


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.TABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
ind = get(handles.popupmenu2,'value');

idx = eventdata.Indices;
table = get(handles.uitable1,'data');

switch rtm
    case {'MODTRAN5','MODTRAN6'}
        if ind==2 % User-defined optical properties
            if idx(2)>1 && (~isnan(eventdata.NewData) && isempty(str2num(eventdata.EditData)))
                h = msgbox('Only numeric values are accepted','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif idx(2)==2 
                if eventdata.NewData<0.2 || eventdata.NewData>9.2
                    h = msgbox('Updated wavelength should be between 0.2 um and 9.2 um.','Update wavalenght','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table{idx(1),idx(2)} = eventdata.PreviousData;
                elseif isnan(eventdata.NewData)
                    h = msgbox('Only numeric values are accepted','Wrong input value','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table(idx(1),idx(2)) = {eventdata.PreviousData};
                else
                    [~,ind] = sort(cell2mat(table(:,idx(2))));
                    table = table(ind,:);
                end
            elseif idx(2)==4
                if eventdata.NewData<0 || eventdata.NewData>1
                    h = msgbox('Updated Single Scattering Albedo (SSA) should be between 0 and 1','Uptade SSA','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table{idx(1),idx(2)} = eventdata.PreviousData;
                end
            elseif idx(2)==5
                if eventdata.NewData<0 || eventdata.NewData>1
                    h = msgbox('Updated asymmetry parameter should be between -1 and 1','Uptade asymmetry parameter','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table{idx(1),idx(2)} = eventdata.PreviousData;
                end
            end
            set(handles.uitable1,'data',table)
            if idx(2)==1 
                select = table(:,1);
                idx    = cell2mat(select);
                if any(idx==0), set(handles.checkbox1,'value',0)
                else,           set(handles.checkbox1,'value',1)
                end
            end
        elseif ind==3 % OPAC-based aerosols
            if ~isnan(eventdata.NewData) && isempty(str2num(eventdata.EditData))
                h = msgbox('Only numeric values are accepted','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif eventdata.NewData<0 || eventdata.NewData>100
                h = msgbox('Volumic percentage should be between 0% and 100%.','Update value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table{idx(1),idx(2)} = eventdata.PreviousData;
            end
            set(handles.uitable1,'data',table)
        end
    case 'sixSV'
        if ind==2 % User-defined optical properties
            if idx(2)>1 && (~isnan(eventdata.NewData) && isempty(str2num(eventdata.EditData)))
                h = msgbox('Only numeric values are accepted','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif idx(2)==2 
                if eventdata.NewData<0.2 || eventdata.NewData>9.2
                    h = msgbox('Updated wavelength should be between 0.2 um and 9.2 um.','Update wavalenght','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table{idx(1),idx(2)} = eventdata.PreviousData;
                elseif isnan(eventdata.NewData)
                    h = msgbox('Only numeric values are accepted','Wrong input value','error');
                    set(h,'windowstyle','modal'), uiwait(h)
                    table(idx(1),idx(2)) = {eventdata.PreviousData};
                else
                    [~,ind] = sort(cell2mat(table(:,idx(2))));
                    table = table(ind,:);
                end
            end
        elseif ind==3 % User components
            if ~isnan(eventdata.NewData) && isempty(str2num(eventdata.EditData))
                h = msgbox('Only numeric values are accepted','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif eventdata.NewData<0 || eventdata.NewData>100
                h = msgbox('Volumic percentage should be between 0% and 100%.','Update value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table{idx(1),idx(2)} = eventdata.PreviousData;
            end
            set(handles.uitable1,'data',table)
        elseif any(ind==[4,5,6])
            if isnan(eventdata.PreviousData) && ~isnan(eventdata.NewData)
                h = msgbox('Cell must not be edited','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif idx(2)==3 && any(idx(1)==[2,5,8]) && (eventdata.NewData<=0 || eventdata.NewData>1)
                h = msgbox('Particle density must be between 0 and 1','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};            
            end
            set(handles.uitable1,'data',table)
        elseif ind==8 % OPAC-based aerosols
            if ~isnan(eventdata.NewData) && isempty(str2num(eventdata.EditData))
                h = msgbox('Only numeric values are accepted','Wrong input value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table(idx(1),idx(2)) = {eventdata.PreviousData};
            elseif eventdata.NewData<0 || eventdata.NewData>100
                h = msgbox('Volumic percentage should be between 0% and 100%.','Update value','error');
                set(h,'windowstyle','modal'), uiwait(h)
                table{idx(1),idx(2)} = eventdata.PreviousData;
            end
            set(handles.uitable1,'data',table)
        end
    case 'libRadtran' 
end



% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
ind = get(handles.popupmenu2,'value');

tabledata = get(handles.uitable1,'data');
ColumnName = get(handles.uitable1,'ColumnName');
RowName    = get(handles.uitable1,'RowName');

switch rtm
    case {'MODTRAN5','MODTRAN6'}   
        aux = cell(1,size(tabledata,2)); aux(1,1) = {false};
        tabledata(end+1,:) = aux;        
    case 'sixSV'
        if any(ind==[4,5,6]) && size(tabledata,1)<13
            aux = cell(3,size(tabledata,2)); aux(:)={0};
            aux(1,4:end) = {NaN};
            tabledata(end+1:end+3,:) = aux;
            RowName(end+1:end+3) = RowName(2:4);
            set(handles.pushbutton5,'enable','on')
            if size(tabledata,1)==13, set(handles.pushbutton4,'enable','off'), end
        end
end

set(handles.uitable1,'data',tabledata,'ColumnName',ColumnName,...
    'RowName',RowName);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
ind = get(handles.popupmenu2,'value');

tabledata = get(handles.uitable1,'data');
ColumnName = get(handles.uitable1,'ColumnName');
RowName    = get(handles.uitable1,'RowName');

if ~isempty(tabledata)
    switch rtm
        case {'MODTRAN5','MODTRAN6'}
            select = tabledata(:,1);
            idx    = cell2mat(select);
            if sum(idx)==0
            	h = msgbox('Select spectral bands to remove.','Remove spectral bands','error');
                set(h,'windowstyle','modal'), uiwait(h)
            elseif sum(idx)>size(tabledata,1)-2
            	h = msgbox('There should be at least two wavelength values. Please select again','Remove spectral bands','error');
                set(h,'windowstyle','modal'), uiwait(h)
            else
            	if sum(idx)==size(tabledata,1)-2, set(handles.checkbox1,'value',0), end
                    tabledata(idx,:) = [];
%                     set(handles.uitable1,'data',tabledata)
            end
        case 'sixSV'
            if any(ind==[4,5,6]) && size(tabledata,1)>4
                tabledata(end-2:end,:) = [];
                RowName(end-2:end) = [];
%                 set(handles.uitable1,'data',tabledata)
                if size(tabledata,1)==4, set(handles.pushbutton5,'enable','off'), end
            end 
                
        case 'LibRadtran'
    end
end
set(handles.uitable1,'data',tabledata,'ColumnName',ColumnName,...
    'RowName',RowName);


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2
contents = cellstr(get(handles.popupmenu1,'String'));
rtm = contents{get(handles.popupmenu1,'Value')};
ind = get(handles.popupmenu2,'value');

set(handles.pushbutton6,'enable','off','visible','off')
set(handles.text6,'visible','off')
set(handles.popupmenu3,'enable','off','visible','off','value',1)

set(handles.popupmenu2,'backgroundcolor',[1 1 1])
if ind==1 % No option has been selected
    set(handles.uitable1,'enable','off')
    set(handles.pushbutton3,'enable','off')
    set(handles.edit1,'enable','off')
    set(handles.checkbox1,'enable','off')
    set(handles.pushbutton4,'enable','off')
    set(handles.pushbutton5,'enable','off')
    set(handles.uitable1,'data',{},'ColumnName',{},...
        'RowName','numbered')
else
    switch rtm
        case 'sixSV'
            set(handles.uitable1,'enable','on')
            set(handles.pushbutton3,'enable','on')
            set(handles.edit1,'enable','on')
            if ind==2 % User-defined optical properties
                table = cell(2,5); table(:,1) = {false};
                ColumnName = {'Select','Wavelength [um]','Normalized EXT [km-1]','SSA [km-1]','Asymmetry param: [-]'};
                ColumnFormat = {'logical','numeric','numeric','numeric','numeric'};
                RowName = 'numbered';
                usrdata = {'wvl','EXTC','SSA','ASYM';'um','km-1','adim','adim'};
                en = 'off';
                set(handles.pushbutton6,'enable','on','visible','on')
            elseif ind==3 % User components
            	table = {25,25,25,25};
                ColumnName = {'Dust [%]','Water-soluble [%]','Oceanic [%]','Soot [%]'};
                RowName = 'numbered';
                ColumnFormat = cell(1,4); ColumnFormat(:)={'numeric'};
                usrdata = {'dust','h2osoluble','oceanic','soot';...
                           '%','%','%','%'};
                en = 'off';
            elseif any(ind==[4 5 6]) % Particles distributions
            	table = cell(4,20); table(:)={0}; table(1,3:end) = {NaN};
                table(2,4:end) = {NaN};
                ColumnName = {};
                RowName = {'Rmin,Rmax:','Rmean,Sigma,%:','n_r','n_i'};
                ColumnFormat = cell(1,size(table,2)); ColumnFormat(:)={'numeric'};
                usrdata = {'Rmean','Sigma','Percentage','nRe','nIm';...
                           'um','um','%/100','adim','adim'};
                en = 'on';
            elseif ind==7 % Sun-photometric distribution
            	msgbox('Model not yet implemented','Aerosol model','error')
                set(handles.popupmenu2,'value',1)
                popupmenu2_Callback(hObject, eventdata, handles)
                return
            elseif ind==8 % OPAC-based
                [OPACconf,~,datos] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
                if isempty(OPACconf.filepath)
                	msgbox('OPAC database is not integrated into ALG. Please configure ALG first to have access to OPAC',...
                           'OPAC-based aerosols','error')
                    set(handles.popupmenu2,'value',1)
                    popupmenu2_Callback(hObject, eventdata, handles)
                    return
                else
                    rhopac  = str2num(datos.MainParam.RH.values);
                    rhopac = [{'Default'},mat2cell(rhopac,ones(1,size(rhopac,1)),ones(1,size(rhopac,2)))];
                    set(handles.text6,'visible','on')
                    set(handles.popupmenu3,'string',rhopac,'visible','on','enable','on')
                	fn = fieldnames(datos.PARTYPE); nAers = numel(fn);
                    ColumnName = cell(1,nAers);
                    for i=1:nAers
                    	ColumnName{i} = [datos.PARTYPE.(fn{i}).description,' [%]'];
                    end
                    ColumnFormat = cell(1,nAers); ColumnFormat(:)={'numeric'};
                    RowName = 'numbered';
                    table = cell(1,nAers); table(:) = {0};
                    usrdata = {'Rmean','Sigma','Percentage','nRe','nIm';...
                           'um','um','%/100','adim','adim'};
                    en = 'off';
                end
            end
           
        case {'MODTRAN5','MODTRAN6'}
        	set(handles.uitable1,'enable','on')
            set(handles.pushbutton3,'enable','on')
            set(handles.edit1,'enable','on')
            if ind==2 % User-defined optical properties
                table = cell(2,5); table(:,1) = {false};
                ColumnName = {'Select','Wavelength [um]','Normalized EXT [km-1]','SSA [km-1]','Asymmetry param: [-]'};
                ColumnFormat = {'logical','numeric','numeric','numeric','numeric'};
                RowName = 'numbered';
                usrdata = {'wvl','EXTC','SSA','ASYM';'um','km-1','adim','adim'};
                en = 'on';
                set(handles.pushbutton6,'enable','on','visible','on')
            elseif ind==3 % OPAC-based aerosols
            	[OPACconf,~,datos] = read_OPACconfig(['..',filesep,'Conf',filesep,'OPACconf.xml']);
                if isempty(OPACconf.filepath)
                	msgbox('OPAC database is not integrated into ALG. Please configure ALG first to have access to OPAC',...
                           'OPAC-based aerosols','error')
                    set(handles.popupmenu2,'value',1)
                    popupmenu2_Callback(hObject, eventdata, handles)
                    return
                else
                    rhopac  = str2num(datos.MainParam.RH.values);
                    rhopac = [{'Default'},mat2cell(rhopac,ones(1,size(rhopac,1)),ones(1,size(rhopac,2)))];
                    set(handles.text6,'visible','on')
                    set(handles.popupmenu3,'string',rhopac,'visible','on','enable','on')
                	fn = fieldnames(datos.PARTYPE); nAers = numel(fn);
                    ColumnName = cell(1,nAers);
                    for i=1:nAers
                    	ColumnName{i} = [datos.PARTYPE.(fn{i}).description,' [%]'];
                    end
                    ColumnFormat = cell(1,nAers); ColumnFormat(:)={'numeric'};
                    RowName = 'numbered';
                    table = cell(1,nAers); table(:) = {0};
                    usrdata = {'wvl','EXTC','SSA','ASYM';'um','km-1','adim','adim'};
                    en = 'off';
                end
            end
            set(handles.checkbox1,'enable',en)
    end
    set(handles.uitable1,'data',table,'ColumnName',ColumnName,...
    	'RowName',RowName,'ColumnFormat',ColumnFormat,'ColumnEditable',true)
	set(handles.uitable1,'userdata',usrdata)
    set(handles.pushbutton4,'enable',en)
    set(handles.pushbutton5,'enable',en)
end


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)

% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName] = uigetfile({'*.mie';'*.out';'*.h5'},'Select file(s)','multiselect','on');
if ischar(FileName), FileName = {FileName}; end

if iscell(FileName)
    for i=1:numel(FileName) % Loop for every selected file
        [~,name,ext]=fileparts(FileName{i});
        % Read aerosol optical properties from selected file(s)
        switch ext
            case '.mie' % 6SV .mie file
                ext='_6SV';
                fid   = fopen([PathName,filesep,FileName{i}]);
                tline = fgetl(fid);tline = fgetl(fid);
                data = cell2mat(textscan(fid,repmat('%f\t',1,7),20));
                data = data(:,[1,2,4,5]);
                fclose(fid);
                n = 1;
            case '.out' % OPAC .out file
                if i==1
                    h = msgbox('Rel. humidity will be assigned to 70%','Import OPAC aerosol','warn');
                    set(h,'windowstyle','modal'), uiwait(h)
                end
                ext='_OPAC';
                [VARSPC,~,EXTC,ABSC,ASYM,~,~] = Read_opacout([PathName,filesep,FileName{i}]);
                SSA = 1-ABSC(:,3)./EXTC(:,3);
                data = [VARSPC',EXTC(:,3),SSA,ASYM(:,3)];
                n = 1;
            case '.h5' % ALGs OPAC-based aerosol
                if i==1
                    h = msgbox('Rel. humidity will be assigned to 70%','Import OPAC aerosol','warn');
                    set(h,'windowstyle','modal'), uiwait(h)
                end
                ext='_OPAC';
                VARSPC = h5read([PathName,filesep,FileName{i}],'/VARSPC');
                SPEC   = h5read([PathName,filesep,FileName{i}],'/SPEC');
                n = size(SPEC,4);
                SSA    = 1-squeeze(SPEC(:,3,2,:))./squeeze(SPEC(:,3,1,:));
                for j=1:n
                    data(:,:,j) = [VARSPC,squeeze(SPEC(:,3,1,j)),SSA(:,j),squeeze(SPEC(:,3,3,j))];
                end
        end
        
        % Put optical properties into uitable1
        for j=1:n
            if n==1
                set(handles.edit1,'string',[name,ext])
            else
                idx = strfind(name,'_OPAC');
                set(handles.edit1,'string',[name(1:idx-1),num2str(j),ext])
            end
            table = cell(size(data,1),size(data,2)+1); table(:,1) = {false};
            auxdata = mat2cell(data(:,:,j),ones(1,size(data,1)),ones(1,size(data,2)));
            table(:,2:end) = auxdata;
            set(handles.uitable1,'data',table)
            if numel(FileName)>1 || n>1
                pushbutton3_Callback(hObject, eventdata, handles)
            end
        end
    end
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3


% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
