function [] = runRTM(alg,parspmb)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

% Once the input files are generated, the atmospheric RTM is run for each
% combination of key input atmospheric parameters. This step considers the
% possibility of multithreading
       
comp = computer;
switch comp
    case 'PCWIN64' % Windows
        ext = '.bat';
    case 'GLNXA64' % Linux
        ext = '.sh';
    case 'MACI64' % MacOS
        ext = '.sh';
end

Nparallel = str2num(alg.GenConf.parallel);

% Loop for the number of parallel executions of the RTM:
for i = 1:Nparallel
    % Create script file and run MODTRAN5
    fid = fopen([alg.GenConf.filename,'_',num2str(i),ext],'w');
    fprintf(fid,'%-100s\n',['cd ',alg.GenConf.filename,'_',num2str(i)]);
    fprintf(fid,'%-100s\n',['"',alg.RTMfilepath,'" ']);
    fclose(fid);
end
if isempty(parspmb)
    for i = 1:Nparallel
        % This next line calls the shell script from system terminal
        % (i.e. outside of Matlab)
        % REVIEW for implementation in Linux
        evalin('base',['!',alg.GenConf.filename,'_',num2str(i),ext,' &'])
    end
elseif strcmp(parspmb,'spmd')
	if Nparallel==1
        flag = true; n0 = 0;
        while flag
        	% This next line calls the shell script from Matlab (i.e. 
            % Matlab is busy until MODTRAN5 finish running)
            evalin('base',['!',alg.GenConf.filename,'_1',ext])
            % Check if all tp7 files have been correctly generated:
            mod5file = [alg.GenConf.filename,'_1',filesep,'mod5root.in'];
            tp5      = importdata(mod5file); n = numel(tp5);
            f        = dir([alg.GenConf.filename,'_1',filesep,'tape',filesep,'*.tp7']);
            if numel(f)==n+n0 %&& f(end-1).bytes==f(end).bytes 
            	% All tp7 have been correctly generated
                flag=false;
            elseif numel(f)<n
            	n0 = numel(f)-1;
                % There are missing tp7 files to be generated
                fid = fopen(mod5file,'w');
                for row=numel(f):n
                	fprintf(fid,'%s\n',tp5{row});
                end
                fclose(fid);
            end
        end
    else
    	parpool(Nparallel)
        spmd
            i=labindex;
            flag = true; n0 = 0;
            while flag
            	% This next line calls the shell script from Matlab (i.e. 
                % Matlab is busy until MODTRAN5 finish running)
                evalin('base',['!',alg.GenConf.filename,'_',num2str(i),ext])
                % Check if all tp7 files have been correctly generated:
                mod5file = [alg.GenConf.filename,'_',num2str(i),filesep,'mod5root.in'];
                tp5      = importdata(mod5file); n = numel(tp5);
                f        = dir([alg.GenConf.filename,'_',num2str(i),filesep,'tape',filesep,'*.tp7']);
                [i,n,n0,numel(f)]
                if numel(f)==n+n0 %&& f(end-1).bytes==f(end).bytes 
                	% All tp7 have been correctly generated
                    flag=false;
                elseif numel(f)<n
                	n0 = numel(f)-1;
                    % There are missing tp7 files to be generated
                    fid = fopen(mod5file,'w');
                    for row=numel(f):n
                    	fprintf(fid,'%s\n',tp5{row});
                    end
                    fclose(fid);
                end
            end
        end
    end
end

