function [] = runRTM(alg,parspmb)
cellfind = @(string)(@(cell_contents)(strcmp(string,cell_contents)));

% Once the input files are generated, the atmospheric RTM is run for each
% combination of key input atmospheric parameters. This step considers the
% possibility of multithreading
       
comp = computer;
switch comp
    case 'PCWIN64' % Windows
        ext = '.bat';
    case 'GLNXA64' % Linux
        ext = '.sh';
    case 'MACI64' % MacOS
        ext = '.sh';
end

Nparallel = str2num(alg.GenConf.parallel);

% Loop for the number of parallel executions of the RTM:
for i = 1:Nparallel
	% Create script file and run MODTRAN
    fid = fopen([alg.GenConf.filename,'_',num2str(i),ext],'w');
    path = [alg.GenConf.filename,'_',num2str(i),filesep,'tape'];
    fprintf(fid,'%-100s\n',['cd ',path]);
    dr = dir(path);
    for j=3:numel(dr)
        fprintf(fid,'%-100s\n',[alg.RTMfilepath,' ',dr(j).name]);
    end
	fclose(fid);
end

if isempty(parspmb)
	for i = 1:Nparallel
        % This next line calls the shell script from system terminal
        % (i.e. outside of Matlab)
        evalin('base',['!',alg.GenConf.filename,'_',num2str(i),ext,' &'])
    end
elseif strcmp(parspmb,'spmd')
	if Nparallel==1
    	flag = true; n0 = 0;
        while flag
        	% This next line calls the shell script from Matlab (i.e. 
            % Matlab is busy until MODTRAN6 finishes running)
            evalin('base',['!',alg.GenConf.filename,'_1',ext])
        end
    else
    	parpool(Nparallel)
        spmd
        	i=labindex;
            flag = true; n0 = 0;
            while flag
                % This next line calls the shell script from Matlab (i.e. 
                % Matlab is busy until MODTRAN6 finishes running)
                evalin('base',['!',alg.GenConf.filename,'_',num2str(i),ext])
            end
        end
    end
end
