function varargout = Paramconf(varargin)
% PARAMCONF MATLAB code for Paramconf.fig
%      PARAMCONF, by itself, creates a new PARAMCONF or raises the existing
%      singleton*.
%
%      H = PARAMCONF returns the handle to a new PARAMCONF or the handle to
%      the existing singleton*.
%
%      PARAMCONF('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PARAMCONF.M with the given input arguments.
%
%      PARAMCONF('Property','Value',...) creates a new PARAMCONF or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Paramconf_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Paramconf_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Paramconf

% Last Modified by GUIDE v2.5 30-May-2016 15:04:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Paramconf_OpeningFcn, ...
                   'gui_OutputFcn',  @Paramconf_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Paramconf is made visible.
function Paramconf_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Paramconf (see VARARGIN)

% Choose default command line output for Paramconf
handles.output = hObject;

[RTMconf] = read_RTMconfig('../Conf/RTMconf.xml',[]);

set(handles.popupmenu1,'string',['Select RTM...',{RTMconf(:).name}])
set(handles.popupmenu2,'string','Select group...')

colname = {'','Name','Description','Type','Disc./cont.','Static/Dynamic','Default','Values/Min-Max','Options','Unit'};
colformat = {'logical','char','char',{'STRING','INTEGER','FLOAT'},{'continuous','discrete'},{'static','dynamic'},'char','char','char','char'};
[colwidth{1:length(colname)}] = deal('auto');

set(handles.uitable1,'columnname',colname)
set(handles.uitable1,'columnformat',colformat)
set(handles.uitable1,'ColumnEditable',true(size(colname)))
set(handles.uitable1,'ColumnWidth',colwidth)

set(handles.uitable1,'data',[])

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Paramconf wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Paramconf_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

[RTMconf] = read_RTMconfig('../Conf/RTMconf.xml',[]);
idx = get(hObject,'Value');
if idx~=1
    [~,Groupnames,~] = read_RTMconfig('../Conf/RTMconf.xml',RTMconf(idx-1).name);
    set(handles.popupmenu2,'string',['Select group...',Groupnames])
    set(handles.popupmenu2,'value',1)
    set(handles.uitable1,'data',[])
else
    set(handles.uitable1,'data',[])
end


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2

[RTMconf] = read_RTMconfig('../Conf/RTMconf.xml',[]);
idx = get(handles.popupmenu1,'value');
[RTMconf,Groupnames,paramdata] = read_RTMconfig('../Conf/RTMconf.xml',RTMconf(idx-1).name);
idx1 = get(hObject,'Value');
aux = get(handles.uitable1,'columnname'); Ncols = numel(aux);

if idx1~=1
    fn = fieldnames(paramdata); aux1 = fn{idx1-1};
    if ~isempty(paramdata.(aux1))
        % Update Row and Column names:
        VarName = fieldnames(paramdata.(aux1));
        
        % Update uitable1 Data:
        data = cell(length(VarName),Ncols);
        for i = 1:length(VarName)
            aux = paramdata.(aux1).(VarName{i});
            data(i,:) = {false,aux.name,aux.description,aux.datatype,aux.paramtype,aux.static,aux.default,aux.values,aux.desc,aux.unit};
        end

        set(handles.uitable1,'Data',data)
    else
        msg = {[RTMconf(idx-1).name,' has no defined ',Groupnames{idx1-1},' parameters.'],...
                'Press + to add a new parameter first.'};
        msgbox(msg,'No parameters found','warn')
        set(handles.uitable1,'data',[])
    end
else
    set(handles.uitable1,'data',[])
end


% columnformat = {'string','string','logical',{'Fixed' 'Adjustable'}};

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when entered data in editable cell(s) in uitable1.
function uitable1_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.uitable1,'data');
newdata = {false,'','','FLOAT','continuous','static','','','',''};
data = [data;newdata];

set(handles.uitable1,'data',data);




% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = get(handles.uitable1,'data');
select = cell2mat(data(:,1));
if any(select,true)
    newdata = data(~select,:);
    set(handles.uitable1,'data',newdata);
else
    msgbox('Select first parameters to remove','','warn')
end
