#include <stdio.h>
#include <windows.h>
#include <winbase.h>

WINBASEAPI BOOLEAN APIENTRY CreateSymbolicLinkA (LPCSTR lpSymlinkFileName, LPCSTR lpTargetFileName, DWORD dwFlags);
WINBASEAPI BOOLEAN APIENTRY CreateSymbolicLinkW (LPCWSTR lpSymlinkFileName, LPCWSTR lpTargetFileName, DWORD dwFlags);

#define CreateSymbolicLink __MINGW_NAME_AW(CreateSymbolicLink)

typedef BOOLEAN APIENTRY (CALLBACK* CreateSymbolicLinkType)(LPCTSTR, LPCSTR, DWORD);

int main(int argc, char **argv) {

    int res = 0;
	
    if (argc < 3) {
		printf("mymklink <link name> <source name>");
        return 1;
    }
    
    printf("Symlink %s to %s\n", argv[2], argv[1]);
	HMODULE dll = LoadLibrary("kernel32.dll");
	if (dll == NULL) {
		printf("Error loading kernel32.dll\n");
		return 1;
	}
	
	CreateSymbolicLinkType CreateSymbolicLinkPtr;
	CreateSymbolicLinkPtr = (CreateSymbolicLinkType) GetProcAddress(dll, "CreateSymbolicLinkA");
	if (CreateSymbolicLinkPtr == NULL) {
		printf("Error loading CreateSymbolicLink\n");
		return 1;
	}
	
	//res = CreateSymbolicLink(argv[1], argv[2], 0x1);
	if (CreateSymbolicLinkPtr(argv[1], argv[2], 0x1)) {
		printf("Symbolic link created\n");
		res = 0;
	}
	else {
		DWORD error = GetLastError();
		printf("Failed to create symbolic link: %ld\n", error);
		if (error == 1314) { 
			printf("Permission denied\n");
		}
		res = 1;
	}
	
    return res;
}

